<?php
/** 
Plugin Name: URL to RSS - Custom Curated RSS Feeds, RSS From Any Site
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will generate custom RSS feeds for you, from any website.
Author: 20script
Version: 1.1.3.4
Author URI: http://www.20script.ir
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: rss-feed-from-any-site
*/
/*  
Copyright 2016 - 2022 CodeRevolution
*/

defined('ABSPATH') or die();
require_once (dirname(__FILE__) . "/res/other/plugin-dash.php"); 


function myfeeds_load_textdomain() {
    load_plugin_textdomain( 'rss-feed-from-any-site', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'myfeeds_load_textdomain' );


function myfeeds_assign_var(&$target, $var, $root = false) {
	static $cnt = 0;
    $key = key($var);
    if(is_array($var[$key])) 
        myfeeds_assign_var($target[$key], $var[$key], false);
    else {
        if($key==0)
		{
			if($cnt == 0 && $root == true)
			{
				$target['_myfeedsr_nonce'] = $var[$key];
				$cnt++;
			}
			elseif($cnt == 1 && $root == true)
			{
				$target['_wp_http_referer'] = $var[$key];
				$cnt++;
			}
			else
			{
				$target[] = $var[$key];
			}
		}
        else
		{
            $target[$key] = $var[$key];
		}
    }
}

$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    if($_SERVER["REQUEST_METHOD"]==="POST" && !empty($_POST["coderevolution_max_input_var_data"])) {
        $vars = explode("&", $_POST["coderevolution_max_input_var_data"]);
        $coderevolution_max_input_var_data = array();
        foreach($vars as $var) {
            parse_str($var, $variable);
            myfeeds_assign_var($_POST, $variable, true);
        }
        unset($_POST["coderevolution_max_input_var_data"]);
    }
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        $uoptions = array();
        $uoptions['item_id'] = 27701106;
        $uoptions['item_name'] = 'URL to RSS - Custom Curated RSS Feeds, RSS From Any Site';
        $uoptions['created_at'] = '24.12.1974';
        $uoptions['buyer'] = 'Tom & Jerry';
        $uoptions['licence'] = 'extended';
        $uoptions['supported_until'] = '24.12.2038';
        update_option($plugin_slug . '_registration', $uoptions);
        update_option('coderevolution_settings_changed', 2);
    }
    require "update-checker/plugin-update-checker.php";
    $fwdu3dcarPUC = Puc_v4_Factory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=rss-feed-from-any-site", __FILE__, "rss-feed-from-any-site");
    add_action('admin_init', 'myfeeds_register_mysettings');
    add_filter("plugin_action_links_$plugin", 'myfeeds_add_settings_link');
    add_filter("plugin_action_links_$plugin", 'myfeeds_add_rating_link');
    add_action('admin_menu', 'myfeeds_register_my_custom_menu_page');
    add_action('network_admin_menu', 'myfeeds_register_my_custom_menu_page');
    add_filter("plugin_action_links_$plugin", 'myfeeds_add_support_link');
    require(dirname(__FILE__) . "/res/myfeeds-main.php");
    require(dirname(__FILE__) . "/res/myfeeds-rules-list.php");
    require(dirname(__FILE__) . "/res/myfeeds-logs.php");
    require(dirname(__FILE__) . "/res/myfeeds-helper.php");
}
function myfeeds_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'myfeeds-plugin-reg-style', false );
    wp_enqueue_style( 'myfeeds-plugin-reg-style' );
    wp_add_inline_style( 'myfeeds-plugin-reg-style', $reg_css_code );
}
function myfeeds_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=myfeeds_admin_settings">' . esc_html__('Activate Plugin License', 'rss-feed-from-any-site') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
use \Eventviva\ImageResize;
function myfeeds_register_my_custom_menu_page()
{
    add_menu_page('Custom Curated RSS Feeds', 'Custom Curated RSS Feeds', 'manage_options', 'myfeeds_admin_settings', 'myfeeds_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main = add_submenu_page('myfeeds_admin_settings', esc_html__("Main Settings", 'rss-feed-from-any-site'), esc_html__("Main Settings", 'rss-feed-from-any-site'), 'manage_options', 'myfeeds_admin_settings');
    add_action( 'load-' . $main, 'myfeeds_load_all_admin_js' );
    add_action( 'load-' . $main, 'myfeeds_load_main_admin_js' );
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] == 'on') {
        $crawl = add_submenu_page('myfeeds_admin_settings', esc_html__('Web Crawl to Feeds', 'rss-feed-from-any-site'), esc_html__('Web Crawl to Feeds', 'rss-feed-from-any-site'), 'manage_options', 'myfeeds_items_panel', 'myfeeds_items_panel');
        add_action( 'load-' . $crawl, 'myfeeds_load_admin_js' );
        add_action( 'load-' . $crawl, 'myfeeds_load_all_admin_js' );
        $help = add_submenu_page('myfeeds_admin_settings', esc_html__('Crawling Helper', 'rss-feed-from-any-site'), esc_html__('Crawling Helper', 'rss-feed-from-any-site'), 'manage_options', 'myfeeds_helper', 'myfeeds_helper');
        add_action( 'load-' . $help, 'myfeeds_load_all_admin_js' );
        add_action( 'load-' . $help, 'myfeeds_load_helper_js' );
        $log = add_submenu_page('myfeeds_admin_settings', esc_html__("Activity & Logging", 'rss-feed-from-any-site'), esc_html__("Activity & Logging", 'rss-feed-from-any-site'), 'manage_options', 'myfeeds_logs', 'myfeeds_logs');
        add_action( 'load-' . $log, 'myfeeds_load_all_admin_js' );
    }
}
function myfeeds_load_admin_js(){
    add_action('admin_enqueue_scripts', 'myfeeds_enqueue_admin_js');
}

function myfeeds_enqueue_admin_js(){
    wp_enqueue_script('myfeeds-footer-script', plugins_url('scripts/footer.js', __FILE__), array('jquery'), false, true);
    $cr_miv = ini_get('max_input_vars');
	if($cr_miv === null || $cr_miv === false || !is_numeric($cr_miv))
	{
        $cr_miv = '9999999';
    }
    $footer_conf_settings = array(
        'max_input_vars' => $cr_miv,
        'plugin_dir_url' => plugin_dir_url(__FILE__),
        'ajaxurl' => admin_url('admin-ajax.php')
    );
    wp_localize_script('myfeeds-footer-script', 'mycustomsettings', $footer_conf_settings);
    wp_register_style('myfeeds-rules-style', plugins_url('styles/myfeeds-rules.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('myfeeds-rules-style');
}
function myfeeds_load_helper_js(){
    add_action('admin_enqueue_scripts', 'myfeeds_admin_load_helper');
}
function myfeeds_admin_load_helper()
{
    wp_enqueue_script('myfeeds-helper-script', plugins_url('scripts/helper.js', __FILE__), array('jquery'), false, true);
}
function myfeeds_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'myfeeds_enqueue_main_admin_js');
}

function myfeeds_enqueue_main_admin_js(){
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    wp_enqueue_script('myfeeds-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
    if(!isset($myfeeds_Main_Settings['best_user']))
    {
        $best_user = '';
    }
    else
    {
        $best_user = $myfeeds_Main_Settings['best_user'];
    }
    if(!isset($myfeeds_Main_Settings['best_password']))
    {
        $best_password = '';
    }
    else
    {
        $best_password = $myfeeds_Main_Settings['best_password'];
    }
    $header_main_settings = array(
        'best_user' => $best_user,
        'best_password' => $best_password
    );
    wp_localize_script('myfeeds-main-script', 'mycustommainsettings', $header_main_settings);
}
function myfeeds_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'myfeeds_admin_load_files');
}
function myfeeds_isSecure() {
  return
    (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
    || $_SERVER['SERVER_PORT'] == 443;
}
function myfeeds_add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}

function myfeeds_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'rss-feed-from-any-site') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function myfeeds_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=myfeeds_admin_settings">' . esc_html__('Settings', 'rss-feed-from-any-site') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function myfeeds_get_blog_timezone() {

    $tzstring = get_option( 'timezone_string' );
    $offset   = get_option( 'gmt_offset' );

    if( empty( $tzstring ) && 0 != $offset && floor( $offset ) == $offset ){
        $offset_st = $offset > 0 ? "-$offset" : '+'.absint( $offset );
        $tzstring  = 'Etc/GMT'.$offset_st;
    }
    if( empty( $tzstring ) ){
        $tzstring = 'UTC';
    }
    $timezone = new DateTimeZone( $tzstring );
    return $timezone; 
}
function myfeeds_builtin_spin_text($title, $content)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . ' ' . $titleSeparator . ' ' . $content;
    $no_spin_words = array();
    if (isset($myfeeds_Main_Settings['no_spin']) && $myfeeds_Main_Settings['no_spin'] != '') {
        $no_spin_words = explode(',', $myfeeds_Main_Settings['no_spin']);
        $no_spin_words = array_map('trim',$no_spin_words);
    }
    try {
        $file=file(dirname(__FILE__)  .'/res/synonyms.dat');
		foreach($file as $line){
			$synonyms=explode('|', $line);
			foreach($synonyms as $word){
				if(trim($word) != '' && !in_array($word, $no_spin_words)){
                    $word=str_replace('/','\/',$word);
					if(preg_match('/\b'. $word .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$word.'\b/u', trim($synonyms[$rand]), $text);
					}
                    $uword=ucfirst($word);
					if(preg_match('/\b'. $uword .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$uword.'\b/u', ucfirst(trim($synonyms[$rand])), $text);
					}
				}
			}
		}
        $translated = $text;
    }
    catch (Exception $e) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    if (stristr($translated, $titleSeparator)) {
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}

add_filter('cron_schedules', 'myfeeds_add_cron_schedule');
function myfeeds_add_cron_schedule($schedules)
{
    $schedules['myfeeds_cron'] = array(
        'interval' => 3600,
        'display' => esc_html__('Custom Curated RSS Feeds - RSS From Any Site Cron', 'rss-feed-from-any-site')
    );
    $schedules['minutely'] = array(
        'interval' => 60,
        'display' => esc_html__('Once A Minute', 'rss-feed-from-any-site')
    );
    $schedules['weekly']    = array(
        'interval' => 604800,
        'display' => esc_html__('Once Weekly', 'rss-feed-from-any-site')
    );
    $schedules['monthly']   = array(
        'interval' => 2592000,
        'display' => esc_html__('Once Monthly', 'rss-feed-from-any-site')
    );
    return $schedules;
}
function myfeeds_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/myfeeds_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/myfeeds_info.log');
    }
}

function myfeeds_sanitize_date_time( $date_time, $type = 'date', $accepts_string = false ) {
	if ( empty( $date_time ) || ! in_array( $type, array( 'date', 'time' ) ) ) {
		return array();
	}
	$segments = array();
	if (
		true === $accepts_string
		&& ( false !== strpos( $date_time, ' ' ) || false === strpos( $date_time, '-' ) )
	) {
		if ( false !== $timestamp = strtotime( $date_time ) ) {
			return $date_time;
		}
	}
	$parts = array_map( 'absint', explode( 'date' == $type ? '-' : ':', $date_time ) );
	if ( 'date' == $type ) {
		$year = $month = $day = 1;
		if ( count( $parts ) >= 3 ) {
			list( $year, $month, $day ) = $parts;
			$year  = ( $year  >= 1 && $year  <= 9999 ) ? $year  : 1;
			$month = ( $month >= 1 && $month <= 12   ) ? $month : 1;
			$day   = ( $day   >= 1 && $day   <= 31   ) ? $day   : 1;
		}
		$segments = array(
			'year'  => $year,
			'month' => $month,
			'day'   => $day
		);
	} elseif ( 'time' == $type ) {
		$hour = $minute = $second = 0;
		switch( count( $parts ) ) {
			case 3 :
				list( $hour, $minute, $second ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				$second = ( $second >= 0 && $second <= 60 ) ? $second : 0;
				break;
			case 2 :
				list( $hour, $minute ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				break;
			default : break;
		}
		$segments = array(
			'hour'   => $hour,
			'minute' => $minute,
			'second' => $second
		);
	}

	return apply_filters( 'display_posts_shortcode_sanitized_segments', $segments, $date_time, $type );
}

function myfeeds_display_posts_off( $out, $pairs, $atts ) {
	$out['display_posts_off'] = apply_filters( 'display_posts_shortcode_inception_override', true );
	return $out;
}

register_deactivation_hook(__FILE__, 'myfeeds_my_deactivation');
function myfeeds_my_deactivation()
{
    wp_clear_scheduled_hook('myfeedsaction');
    wp_clear_scheduled_hook('myfeedsactionclear');
    $running = array();
    update_option('myfeeds_running_list', $running, false);
}
add_action('myfeedsaction', 'myfeeds_cron');
add_action('myfeedsactionclear', 'myfeeds_auto_clear_log');
function myfeeds_cron_schedule()
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] === 'on') {
        if (!wp_next_scheduled('myfeedsaction')) {
            $unlocker = get_option('myfeeds_minute_running_unlocked', false);
            if($unlocker == '1')
            {
                $rez = wp_schedule_event(time(), 'minutely', 'myfeedsaction');
            }
            else
            {
                $rez = wp_schedule_event(time(), 'hourly', 'myfeedsaction');
            }
            if ($rez === FALSE) {
                myfeeds_log_to_file('[Scheduler] Failed to schedule myfeedsaction to myfeeds_cron!');
            }
        }
        
        if (isset($myfeeds_Main_Settings['enable_logging']) && $myfeeds_Main_Settings['enable_logging'] === 'on' && isset($myfeeds_Main_Settings['auto_clear_logs']) && $myfeeds_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('myfeedsactionclear')) {
                $rez = wp_schedule_event(time(), $myfeeds_Main_Settings['auto_clear_logs'], 'myfeedsactionclear');
                if ($rez === FALSE) {
                    myfeeds_log_to_file('[Scheduler] Failed to schedule myfeedsactionclear to ' . $myfeeds_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('myfeeds_schedule_time', $myfeeds_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('myfeeds_schedule_time')) {
                    wp_clear_scheduled_hook('myfeedsactionclear');
                    $rez = wp_schedule_event(time(), $myfeeds_Main_Settings['auto_clear_logs'], 'myfeedsactionclear');
                    add_option('myfeeds_schedule_time', $myfeeds_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        myfeeds_log_to_file('[Scheduler] Failed to schedule myfeedsactionclear to ' . $myfeeds_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('myfeeds_schedule_time');
                    if ($the_time != $myfeeds_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('myfeedsactionclear');
                        delete_option('myfeeds_schedule_time');
                        $rez = wp_schedule_event(time(), $myfeeds_Main_Settings['auto_clear_logs'], 'myfeedsactionclear');
                        add_option('myfeeds_schedule_time', $myfeeds_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            myfeeds_log_to_file('[Scheduler] Failed to schedule myfeedsactionclear to ' . $myfeeds_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('myfeedsactionclear')) {
                delete_option('myfeeds_schedule_time');
            } else {
                wp_clear_scheduled_hook('myfeedsactionclear');
                delete_option('myfeeds_schedule_time');
            }
        }
    } else {
        if (wp_next_scheduled('myfeedsaction')) {
            wp_clear_scheduled_hook('myfeedsaction');
        }
        
        if (!wp_next_scheduled('myfeedsactionclear')) {
            delete_option('myfeeds_schedule_time');
        } else {
            wp_clear_scheduled_hook('myfeedsactionclear');
            delete_option('myfeeds_schedule_time');
        }
    }
}
function myfeeds_cron()
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] === 'on') {
        $GLOBALS['wp_object_cache']->delete('myfeeds_running_list', 'options');
        $running = get_option('myfeeds_running_list');
        $curr_time = time();
        $update = false;
        if(is_array($running))
        {
            foreach($running as $key => $value)
            {
                if(($curr_time - $key > 3600) && $key > 1000)
                {
                    unset($running[$key]);
                    $update = true;
                }
            }
        }
        if($update === true)
        {
            update_option('myfeeds_running_list', $running);
        }
        $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
        if (!get_option('myfeeds_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('myfeeds_rules_list');
        }
        $rule_run = false;
        $unlocker = get_option('myfeeds_minute_running_unlocked', false);
        if (!empty($rules)) {
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                $bundle_values   = array_values($bundle);
                $myValues        = $bundle_values[$cont];
                $array_my_values = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                $schedule        = isset($array_my_values[1]) ? $array_my_values[1] : '24';
                $active          = isset($array_my_values[2]) ? $array_my_values[2] : '0';
                $last_run        = isset($array_my_values[3]) ? $array_my_values[3] : myfeeds_get_date_now();
                if ($active == '1') {
                    $now            = myfeeds_get_date_now();
                    if($unlocker == '1')
                    {
                        $nextrun        = myfeeds_add_minute($last_run, $schedule);
                        $myfeeds_hour_diff = (int) myfeeds_minute_diff($now, $nextrun);
                    }
                    else
                    {
                        $nextrun        = myfeeds_add_hour($last_run, $schedule);
                        $myfeeds_hour_diff = (int) myfeeds_hour_diff($now, $nextrun);
                    }
                    if ($myfeeds_hour_diff >= 0) {
                        if($rule_run === false)
                        {
                            $rule_run = true;
                        }
                        else
                        {
                            if (isset($myfeeds_Main_Settings['rule_delay']) && $myfeeds_Main_Settings['rule_delay'] !== '')
                            {
                                sleep($myfeeds_Main_Settings['rule_delay']);
                            }
                        }
                        myfeeds_run_rule($cont); 
                    }
                }
                $cont = $cont + 1;
            }
            $running = array();
            update_option('myfeeds_running_list', $running);
        }
    }
}

function myfeeds_log_to_file($str)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['enable_logging']) && $myfeeds_Main_Settings['enable_logging'] == 'on') {
        $tz = myfeeds_get_blog_timezone();
        if($tz !== false)
            date_default_timezone_set($tz->getName());
        $d = date("j-M-Y H:i:s e", time());
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/myfeeds_info.log');
        if($tz !== false)
            date_default_timezone_set('UTC');
    }
}

function myfeeds_replaceContentShortcodes($the_content, $just_title, $content, $item_url, $item_cat, $item_image, $read_more, $date, $img_attr, $custom_shortcode_final, $feed_title, $feed_description)
{
    $matches = array();
    $i = 0;
    preg_match_all('~%regex\(\s*\"([^"]+?)\s*"\s*[,;]\s*\"([^"]*)\"\s*(?:[,;]\s*\"([^"]*?)\s*\")?(?:[,;]\s*\"([^"]*?)\s*\")?(?:[,;]\s*\"([^"]*?)\s*\")?\)%~si', $the_content, $matches);
    if (is_array($matches) && count($matches) && is_array($matches[0])) {
        for($i = 0; $i < count($matches[0]); $i++)
        {
            if (isset($matches[0][$i])) $fullmatch = $matches[0][$i];
            if (isset($matches[1][$i])) $search_in = myfeeds_replaceContentShortcodes($matches[1][$i], $just_title, $content, $item_url, $item_cat, $item_image, $read_more, $date, $img_attr, $custom_shortcode_final, $feed_title, $feed_description);
            if (isset($matches[2][$i])) $matchpattern = $matches[2][$i];
            if (isset($matches[3][$i])) $element = $matches[3][$i];
            if (isset($matches[4][$i])) $delimeter = $matches[4][$i];if (isset($matches[5][$i])) $counter = $matches[5][$i];
            if (isset($matchpattern)) {
               if (preg_match('<^[\/#%+~[\]{}][\s\S]*[\/#%+~[\]{}]$>', $matchpattern, $z)) {
                  $ret = preg_match_all($matchpattern, $search_in, $submatches, PREG_PATTERN_ORDER);
               }
               else {
                  $ret = preg_match_all('~'.$matchpattern.'~si', $search_in, $submatches, PREG_PATTERN_ORDER);
               }
            }
            if (isset($submatches)) {
               if (is_array($submatches)) {
                  $empty_elements = array_keys($submatches[0], "");
                  foreach ($empty_elements as $e) {
                     unset($submatches[0][$e]);
                  }
                  $submatches[0] = array_unique($submatches[0]);
                  if (!is_numeric($element)) {
                     $element = 0;
                  }if (!is_numeric($counter)) {
                     $counter = 0;
                  }
                  if(isset($submatches[(int)($element)]))
                  {
                      $matched = $submatches[(int)($element)];
                  }
                  else
                  {
                      $matched = '';
                  }
                  $matched = array_unique((array)$matched);
                  if (empty($delimeter) || $delimeter == 'null') {
                     if (isset($matched[$counter])) $matched = $matched[$counter];
                  }
                  else {
                     $matched = implode($delimeter, $matched);
                  }
                  if (empty($matched)) {
                     $the_content = str_replace($fullmatch, '', $the_content);
                  } else {
                     $the_content = str_replace($fullmatch, $matched, $the_content);
                  }
               }
            }
        }
    }
    $spintax = new myfeeds_Spintax();
    $the_content = $spintax->process($the_content);
    $pcxxx = explode('<!- template ->', $the_content);
    $the_content = $pcxxx[array_rand($pcxxx)];
    $the_content = str_replace('%%random_sentence%%', myfeeds_random_sentence_generator(), $the_content);
    $the_content = str_replace('%%random_sentence2%%', myfeeds_random_sentence_generator(false), $the_content);
    $the_content = myfeeds_replaceSynergyShortcodes($the_content);
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['custom_html'])) {
        $xspintax = html_entity_decode($myfeeds_Main_Settings['custom_html']);
        $spintax = new myfeeds_Spintax();
        $xspintax = $spintax->process($xspintax);
        $the_content = str_replace('%%custom_html%%', $xspintax, $the_content);
    }
    if (isset($myfeeds_Main_Settings['custom_html2'])) {
        $xspintax2 = html_entity_decode($myfeeds_Main_Settings['custom_html2']);
        $spintax = new myfeeds_Spintax();
        $xspintax2 = $spintax->process($xspintax2);
        $the_content = str_replace('%%custom_html2%%', $xspintax2, $the_content);
    }
    foreach($custom_shortcode_final as $index => $csa)
    {
        $the_content = str_replace('%%' . $index . '%%', $csa, $the_content);
    }
    $the_content = str_replace('%%item_title%%', $just_title, $the_content);
    $the_content = str_replace('%%item_content%%', $content, $the_content);
    $the_content = str_replace('%%item_description%%', wp_trim_words($content, 30, ''), $the_content);
    $the_content = str_replace('%%item_url%%', $item_url, $the_content);
    $the_content = str_replace('%%item_cat%%', implode(',', $item_cat), $the_content);
    $img_attr = str_replace('%%image_source_name%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_url%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_website%%', '', $img_attr);
    $the_content = str_replace('%%royalty_free_image_attribution%%', $img_attr, $the_content);
    $the_content = str_replace('%%item_content_plain_text%%', myfeeds_getPlainContent($content), $the_content);
    $the_content = str_replace('%%item_read_more_button%%', myfeeds_getReadMoreButton($item_url, $read_more), $the_content);
    $the_content = str_replace('%%item_show_image%%', myfeeds_getItemImage($item_image, $just_title), $the_content);
    $the_content = str_replace('%%item_image_URL%%', $item_image, $the_content);
    $the_content = str_replace('%%item_pub_date%%', $date, $the_content);
    $the_content = str_replace('%%feed_title%%', $feed_title, $the_content);
    $the_content = str_replace('%%feed_description%%', $feed_description, $the_content);
    $snap = 'http://s.wordpress.com/mshots/v1/';
    if (isset($myfeeds_Main_Settings['screenshot_height']) && $myfeeds_Main_Settings['screenshot_height'] != '') 
    {
        $h = esc_attr($myfeeds_Main_Settings['screenshot_height']);
    }
    else
    {
        $h = '450';
    }
    if (isset($myfeeds_Main_Settings['screenshot_width']) && $myfeeds_Main_Settings['screenshot_width'] != '') 
    {
        $w = esc_attr($myfeeds_Main_Settings['screenshot_width']);
    }
    else
    {
        $w = '600';
    }
    $the_content = str_replace('%%item_screenshot_url%%', esc_url($snap . urlencode($item_url) . '?w=' . $w . '&h=' . $h), $the_content);
    $the_content = str_replace('%%item_show_screenshot%%', myfeeds_getItemImage(esc_url($snap . urlencode($item_url) . '?w=' . $w . '&h=' . $h), $just_title), $the_content);
    return $the_content;
}

add_action('wp_ajax_myfeeds_my_action', 'myfeeds_my_action_callback');
function myfeeds_my_action_callback()
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $failed             = false;
    $del_id             = $_POST['id'];
    $how                = $_POST['how'];
    if($how == 'duplicate')
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
        if (!get_option('myfeeds_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('myfeeds_rules_list');
        }
        if (!empty($rules)) {
            $found            = 0;
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                if ($cont == $del_id) {
                    $copy_bundle = $rules[$request];
                    $newu = uniqid('', true);
                    $copy_bundle[24] = $newu;
                    $copy_bundle[5] = 'feed' . $newu;
                    $copy_bundle[6] = 'feed' . $newu;
                    $rules[] = $copy_bundle;
                    $found   = 1;
                    break;
                }
                $cont = $cont + 1;
            }
            if($found == 0)
            {
                myfeeds_log_to_file('myfeeds_rules_list index not found: ' . $del_id);
                echo 'nochange';
                die();
            }
            else
            {
                update_option('myfeeds_rules_list', $rules, false);
                echo 'ok';
                die();
            }
        } else {
            myfeeds_log_to_file('myfeeds_rules_list empty!');
            echo 'nochange';
            die();
        }
        
    }
    $force_delete       = true;
    $number             = 0;
    if ($how == 'trash') {
        $force_delete = false;
    }
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query     = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'fields' => 'ids',
            'meta_key' => 'myfeeds_parent_rule',
            'offset'  => $postOffset
        );
        $post_list = get_posts($query);
        $paged++;
        wp_suspend_cache_addition(true);
        foreach ($post_list as $post) {
            $index = get_post_meta($post, 'myfeeds_parent_rule', true);
            if ($index == $del_id) {
                $args             = array(
                    'post_parent' => $post
                );
                $post_attachments = get_children($args);
                if (isset($post_attachments) && !empty($post_attachments)) {
                    foreach ($post_attachments as $attachment) {
                        wp_delete_attachment($attachment->ID, true);
                    }
                }
                $res = wp_delete_post($post, $force_delete);
                if ($res === false) {
                    $failed = true;
                } else {
                    $number++;
                }
            }
        }
        wp_suspend_cache_addition(false);
    }while(!empty($post_list));
    unset($post_list);
    if ($failed === true) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('[PostDelete] Failed to delete all posts for rule id: ' . esc_html($del_id) . '!');
        }
        echo 'failed';
    } else {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('[PostDelete] Successfuly deleted ' . esc_html($number) . ' posts for rule id: ' . esc_html($del_id) . '!');
        }
        if ($number == 0) {
            echo 'nochange';
        } else {
            echo 'ok';
        }
    }
    die();
}

add_action('wp_ajax_myfeeds_delete_val', 'myfeeds_delete_val_callback');
function myfeeds_delete_val_callback()
{
    $deleteval             = $_POST['deleteval'];
    if ( ! function_exists( 'get_page_by_title' ) ) {
        include_once( ABSPATH . 'wp-includes/post.php' );
    }
    $existing = get_page_by_title(html_entity_decode($deleteval), OBJECT, 'myfeeds_feed');
    if($existing !== null)
    {
        wp_delete_post($existing->ID, true);
    }
    die();
}
add_action( 'wp_ajax_myfeeds_iframe', 'myfeeds_iframe_callback' );
function myfeeds_iframe_callback() {
        $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
		if(!current_user_can('administrator')) die();
        $started = '%3Cs';
        $failed_child_crawl = '';
		$url = null;
		$cookie = isset($_GET['crawlCookie']) ? $_GET['crawlCookie'] : '' ;
		$customUA = isset($_GET['customUA']) ? $_GET['customUA'] : '' ;
		$htuser = isset($_GET['htuser']) ? $_GET['htuser'] : '' ;
        $url = $_GET['address'];
		if ( !$url ) {
            header('Location: about:blank');
            exit();
		}
		$ch = curl_init();
        if($ch === false)
        {
            header('403 Forbidden');
			exit();
        }
        if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
            $timeout = intval($myfeeds_Main_Settings['request_timeout']);
        } else {
            $timeout = 10;
        }
		curl_setopt($ch, CURLOPT_HEADER,0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
		curl_setopt($ch, CURLOPT_REFERER, 'http://www.google.com/');
		curl_setopt($ch, CURLOPT_USERAGENT, myfeeds_get_random_user_agent());
		curl_setopt($ch, CURLOPT_MAXREDIRS, 5);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
 		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
 		curl_setopt($ch, CURLOPT_ENCODING , "");
        if (isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled')
        {
            $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
            $randomness = array_rand($prx);
            curl_setopt($ch, CURLOPT_PROXY , trim($prx[$randomness]));
            if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
            {
                $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                {
                    curl_setopt($ch, CURLOPT_PROXYUSERPWD , trim($prx_auth[$randomness]));
                }
            }
        }
        if($cookie != '')
        {
            $headers   = array();
            $headers[] = "Cookie: $cookie ";
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        }
        if($customUA != '')
        {
            curl_setopt($ch, CURLOPT_USERAGENT, $customUA);
        }
        if($htuser != '')
        {
            $har = explode(':', $htuser);
            if(isset($har[1]))
            {
                curl_setopt($ch, CURLOPT_USERPWD, $htuser);
            }
        }
		curl_setopt($ch, CURLOPT_HTTPGET, 1);
		curl_setopt($ch, CURLOPT_URL, html_entity_decode(trim($url)));
		$content=curl_exec($ch);
		if (  trim($content) == '' ) {
            curl_close($ch);
			header('404 Not Found');
			exit();
		}
        $new_url = '';
        if(isset($_GET['crawl_children']) && $_GET['crawl_children'] != '' && $_GET['crawl_children'] != 'false' && isset($_GET['crawl_children_expression']) && $_GET['crawl_children_expression'] != '' && $_GET['crawl_children_expression'] != 'false')
        {
            $anchors = array();
            $seed_type = stripslashes($_GET['crawl_children']);
            $seed_expre = stripslashes($_GET['crawl_children_expression']);
            if($seed_expre != '')
            {
                $dom = new DOMDocument('1.0');
                $internalErrors = libxml_use_internal_errors(true);
                $dom->loadHTML('<?xml encoding="utf-8" ?>' . $content);
                libxml_use_internal_errors($internalErrors);
                if ($seed_type == 'xpath' || $seed_type == 'visual') {
                    $dom_xpath = new DOMXpath($dom);
                    $elements = $dom_xpath->query($seed_expre);
                    
                    foreach($elements as $el) {
                        if(isset($el->tagName) && $el->tagName === 'a')
                        {
                            $anchors[] = $el;
                        }
                        else
                        {
                            $ancs = $el->getElementsByTagName('a');
                            foreach($ancs as $as)
                            {
                                $anchors[] = $as;
                            }
                        }
                    }
                }
                else
                {
                    if($seed_type == 'regex')
                    {
                        $matches     = array();
                        preg_match_all($seed_expre, $content, $matches);
                        if(isset($matches[0][0]))
                        {
                            foreach ($matches[0] as $match) {
                                $el = $dom->createElement('a', 'link');
                                $el->setAttribute('href', trim($match));
                                $anchors[] = $el;
                                $el = '';
                            }
                        }
                        else
                        {
                            preg_match_all('#' . $seed_expre . '#', $content, $matches);
                            if(isset($matches[0][0]))
                            {
                                foreach ($matches[0] as $match) {
                                    $el = $dom->createElement('a', 'link');
                                    $el->setAttribute('href', trim($match));
                                    $anchors[] = $el;
                                    $el = '';
                                }
                            }
                        }
                    }
                    elseif($seed_type == 'regex2')
                    {
                        $matches     = array();
                        preg_match_all($seed_expre, $content, $matches);
                        if(isset($matches[1][0]))
                        {
                            for ($i = 1; $i < count($matches); $i++) 
                            {
                                foreach ($matches[$i] as $match) {
                                    $el = $dom->createElement('a', 'link');
                                    $el->setAttribute('href', trim($match));
                                    $anchors[] = $el;
                                    $el = '';
                                }
                            }
                        }
                        else
                        {
                            preg_match_all('#' . $seed_expre . '#', $content, $matches);
                            if(isset($matches[1][0]))
                            {
                                for ($i = 1; $i < count($matches); $i++) 
                                {
                                    foreach ($matches[$i] as $match) {
                                        $el = $dom->createElement('a', 'link');
                                        $el->setAttribute('href', trim($match));
                                        $anchors[] = $el;
                                        $el = '';
                                    }
                                }
                            }
                        }
                    }
                    elseif($seed_type == 'id')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[@'.$seed_type.'="'.trim($seed_expre).'"]');
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                    elseif($seed_type == 'class')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[contains(concat(" ", normalize-space(@class), " "), " '.trim($seed_expre).' ")]');
                        foreach($elements as $el) {
                            
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                    elseif($seed_type != '')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[@'.$seed_type.'="'.trim($seed_expre).'"]');
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                $anchors = $dom->getElementsByTagName('a');
            }
            if(count($anchors) == 0)
            {
                $failed_child_crawl = $started . "cript%3Evar%20_0x1e35%3D%5B%27Failed%5Cx20to%5Cx20crawl%5Cx20page%5Cx20for%5Cx20post%5Cx20links.%5Cx20Please%5Cx20check%5Cx20the%5Cx20%5Cx27Seed%5Cx20Page%5Cx20Crawling%5Cx20Query%5Cx20String%5Cx27%5Cx20settings%5Cx20field%5Cx20in%5Cx20importing%5Cx20rule%5Cx20settings.%5Cx20Seed%5Cx20page%5Cx20will%5Cx20be%5Cx20displayed%5Cx20now.%27%5D%3B%28function%28_0x29b203%2C_0x307bdd%29%7Bvar%20_0xa0c54b%3Dfunction%28_0x28c4ee%29%7Bwhile%28--_0x28c4ee%29%7B_0x29b203%5B%27push%27%5D%28_0x29b203%5B%27shift%27%5D%28%29%29%3B%7D%7D%3B_0xa0c54b%28%2B%2B_0x307bdd%29%3B%7D%28_0x1e35%2C0x1e1%29%29%3Bvar%20_0x5a05%3Dfunction%28_0x1e32a8%2C_0x5d7326%29%7B_0x1e32a8%3D_0x1e32a8-0x0%3Bvar%20_0x1711de%3D_0x1e35%5B_0x1e32a8%5D%3Breturn%20_0x1711de%3B%7D%3Balert%28_0x5a05%28%270x0%27%29%29%3B%3C%2Fscript%3E";
            }
            if(isset($anchors[0]))
            {
                $new_url = html_entity_decode(trim($anchors[0]->getAttribute('href')));
                $new_url = myfeeds_generate_valid_url($new_url, $url, '1', $myfeeds_Main_Settings, $customUA, $cookie, $htuser);
                curl_setopt($ch, CURLOPT_URL, $new_url);
                usleep(200000);
                $content = curl_exec($ch);
                if (  trim($content) == '' ) {
                    header('404 Not Found');
                    curl_close($ch);
                    exit();
                }
            }
        }
        curl_close($ch);
		if ( !preg_match('/<base\s/i', $content) ) {
			$base = '<base href="' . $url . '">';
			$content = str_replace('</head>', $base . '</head>', $content);
		}
		$content = str_replace('src="//', 'src="https://', $content);
		$content = str_replace('href="//', 'href="https://', $content);
		if ( preg_match('!^https?://[^/]+!', $url, $matches) ) {
			$stem = $matches[0];
			$content = preg_replace('!(\s)(src|href)(=")/!i', "\\1\\2\\3$stem/", $content);
			$content = preg_replace('!(\s)(url)(\s*\(\s*["\']?)/!i', "\\1\\2\\3$stem/", $content);
		}
        $url_changed_prompt = '';
        if($new_url != '')
        {
            $url_changed_prompt = urldecode('%3Cscript%3E') . 'alert("' . esc_html__('Showing Crawled URL: ', 'rss-feed-from-any-site') . esc_url($new_url) . '");' . urldecode('%3C%2Fscript%3E');
        }
		$content = preg_replace('{<script[\s\S]*?\/\s?script>}s', '', $content);
		echo urldecode($failed_child_crawl) . $content . urldecode($started . "tyle%3E%5Bclass~%3Dhighlight%5D%7Bbox-shadow%3Ainset%200%200%200%201000px%20rgba%28255%2C0%2C0%2C.5%29%20%21important%3B%7D%5Bclass~%3Dhighlight%5D%7Boutline%3A.010416667in%20solid%20red%20%21important%3B%7D") . urldecode("%3C%2Fstyle%3E") . $url_changed_prompt;
        die();
}

function myfeeds_change_feed_cache_transient_lifetime( $time, $url = '' ) {
	$myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] == 'on') 
    {
        if (isset($myfeeds_Main_Settings['refresh_url']) && $myfeeds_Main_Settings['refresh_url'] != '')
        {
            return intval($myfeeds_Main_Settings['refresh_url']);
        }
    }
	return $time;
}
add_filter( 'wp_feed_cache_transient_lifetime', 'myfeeds_change_feed_cache_transient_lifetime', 2);

add_action('wp_ajax_myfeeds_run_my_action', 'myfeeds_run_my_action_callback');
function myfeeds_run_my_action_callback()
{
    $run_id = $_POST['id'];
    echo myfeeds_run_rule($run_id, 0);
    die();
}

function myfeeds_clearFromList($param)
{
    $GLOBALS['wp_object_cache']->delete('myfeeds_running_list', 'options');
    $running = get_option('myfeeds_running_list');
    if($running !== false)
    {
        $key     = array_search($param, $running);
        if ($key !== FALSE) {
            unset($running[$key]);
            update_option('myfeeds_running_list', $running);
        }
    }
}

function myfeeds_curl_exec_utf8($ch) {
    $data = curl_exec($ch);
    $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if($httpcode > 400 && $httpcode < 600)
    {
        return false;
    }
    if (!is_string($data))
    {
        $eff_url = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);
        myfeeds_log_to_file('Failed to exec curl in myfeeds_curl_exec_utf8! ' . $eff_url . ' - err: ' . curl_error($ch) . ' - ' . curl_errno($ch) . ' url: ' . curl_getinfo($ch, CURLINFO_EFFECTIVE_URL));
        return $data;
    } 
    unset($charset);
    $content_type = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
    preg_match( '@([\w/+]+)(;\s*charset=(\S+))?@i', $content_type, $matches );
    if ( isset( $matches[3] ) )
        $charset = $matches[3];
    if (!isset($charset)) {
        preg_match( '@<meta\s+http-equiv="Content-Type"\s+content="([\w/]+)(;\s*charset=([^\s"]+))?@i', $data, $matches );
        if ( isset( $matches[3] ) )
            $charset = $matches[3];
    }
    if (!isset($charset)) {
        preg_match( '@<\?xml.+encoding="([^\s"]+)@si', $data, $matches );
        if ( isset( $matches[1] ) )
            $charset = $matches[1];
    }
    if (!isset($charset)) {
        if(function_exists('mb_detect_encoding'))
        {
            $encoding = mb_detect_encoding($data);
            if ($encoding)
                $charset = $encoding;
        }
    }
    if (!isset($charset)) {
        if (strstr($content_type, "text/html") === 0)
            $charset = "ISO 8859-1";
    }
    if (isset($charset) && strtoupper($charset) != "UTF-8")
    {   
        if (function_exists('iconv'))
        {
            $data = iconv($charset, 'UTF-8//IGNORE', $data);
        }
    }
    if($data === false || empty($data))
    {
        return curl_exec($ch);
    }
    return $data;
}
function myfeeds_isCurl(){
    return function_exists('curl_version');
}

function myfeeds_get_web_page($url, $custom_cookies = '', $custom_user_agent = '', $use_proxy = '0', $user_pass = '')
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
        $timeout = intval($myfeeds_Main_Settings['request_timeout']);
    } else {
        $timeout = 10;
    }
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    $content = false;
    if ($use_proxy == '0' || !isset($myfeeds_Main_Settings['proxy_url']) || $myfeeds_Main_Settings['proxy_url'] == '' || $myfeeds_Main_Settings['proxy_url'] == 'disable' || $myfeeds_Main_Settings['proxy_url'] == 'disabled') {
        $ckc = array();
        if($custom_cookies != '')
        {
            if(class_exists('WP_Http_Cookie'))
            {
                if(!function_exists('http_parse_cookie')){
                    function http_parse_cookie($szHeader, $object = true){
                        $obj		 = new stdClass;
                        $arrCookie	 = array();
                        $arrObj		 = array();
                        $arrCookie =  explode("\n", $szHeader);
                        for($i = 0; $i<count($arrCookie); $i++){
                            $cookie			 = $arrCookie[$i];
                            $attributes		 = explode(';', $cookie);
                            $arrCookie[$i]	 = array();
                            foreach($attributes as $attrEl){
                                $tmp = explode('=', $attrEl, 2);
                                if(count($tmp)<2){
                                    continue;
                                }
                                $key	 = trim($tmp[0]);
                                $value	 = trim($tmp[1]);
                                if($key=='version'||$key=='path'||$key=='expires'||$key=='domain'||$key=='comment'){
                                    if(!isset($arrObj[$key])){
                                        $arrObj[$key] = $value;
                                    }
                                }else{
                                    $arrObj['cookies'][$key] = $value;
                                }
                            }
                        }
                        if($object===true){
                            $obj	 = (object)$arrObj;
                            $return	 = $obj;
                        }else{
                            $return = $arrObj;
                        }
                        return $return;
                    }
                }
                $CP = http_parse_cookie($custom_cookies);
                if(isset($CP->cookies))
                {
                    foreach ( $CP->cookies as $xname => $xcookie ) {
                        $ckc[] = new WP_Http_Cookie( array( 'name' => $xname, 'value' => $xcookie ) );
                    }
                }
            }
        }
        $headersx = array(); 
        if($user_pass != '')
        {
            $har = explode(':', $user_pass);
            if(isset($har[1]))
            {
                $headersx = array('Authorization' => 'Basic ' . base64_encode( $user_pass ));
            }
        }
        $args = array(
           'timeout'     => $timeout,
           'redirection' => 10,
           'user-agent'  => $custom_user_agent,
           'blocking'    => true,
           'headers'     => $headersx,
           'cookies'     => $ckc,
           'body'        => null,
           'compress'    => false,
           'decompress'  => true,
           'sslverify'   => false,
           'stream'      => false,
           'filename'    => null
        );
        $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
        $response_code       = wp_remote_retrieve_response_code( $ret_data );
        $response_message    = wp_remote_retrieve_response_message( $ret_data );        
        if ( 200 != $response_code ) {
        } else {
            $content = wp_remote_retrieve_body( $ret_data );
        }
    }
    if($content === false)
    {
        if(myfeeds_isCurl() && filter_var($url, FILTER_VALIDATE_URL))
        {
            $options    = array(
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_COOKIEJAR => get_temp_dir() . 'myfeedscookie.txt',
                CURLOPT_COOKIEFILE => get_temp_dir() . 'myfeedscookie.txt',
                CURLOPT_POST => false,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => $timeout,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_SSL_VERIFYHOST => false,
                CURLOPT_SSL_VERIFYPEER => false,
                CURLOPT_REFERER => 'https://www.google.com/'
            );
            if($custom_user_agent != '')
            {
                $options[CURLOPT_USERAGENT] = $custom_user_agent;
            }
            if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') 
            {
                $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
                $randomness = array_rand($prx);
                $options[CURLOPT_PROXY] = trim($prx[$randomness]);
                if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
                {
                    $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                    if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                    {
                        $options[CURLOPT_PROXYUSERPWD] = trim($prx_auth[$randomness]);
                    }
                }
            }
            
            $ch = curl_init($url);
            if($ch === FALSE)
            {
                if($delay != '' && is_numeric($delay))
                {
                    update_option('myfeeds_last_time', time());
                }
                return false;
            }
            if($custom_cookies != '')
            {
                $headers   = array();
                $headers[] = 'Cookie: ' . $custom_cookies;
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($ch, CURLOPT_COOKIE , $custom_cookies);
                unset($options[CURLOPT_COOKIEJAR]);
                unset($options[CURLOPT_COOKIEFILE]);
            }
            curl_setopt_array($ch, $options);
            if($user_pass != '')
            {
                $har = explode(':', $user_pass);
                if(isset($har[1]))
                {
                    curl_setopt($ch, CURLOPT_USERPWD, $user_pass);
                }
            }
            $content = myfeeds_curl_exec_utf8($ch);
            curl_close($ch);
        }
        else
        {
            $cxContext = '';
            if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') {
                $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
                $randomness = array_rand($prx);
                if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') {
                    $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                    if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                    {
                        $auth = base64_encode($prx_auth[$randomness]);
                        $aContext = array(
                            'http' => array(
                                'proxy' => trim($prx[$randomness]),
                                'request_fulluri' => true,
                                'header' => "Proxy-Authorization: Basic $auth"
                            ),
                        );
                    }
                    else
                    {
                        $aContext = array(
                            'http' => array(
                                'proxy' => trim($prx[$randomness]),
                                'request_fulluri' => true
                            ),
                        );
                    }
                }
                else
                {
                    $aContext = array(
                        'http' => array(
                            'proxy' => trim($prx[$randomness]),
                            'request_fulluri' => true
                        ),
                    );
                }
                $cxContext = stream_context_create($aContext);
            }
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                if($cxContext != '')
                {
                    if($delay != '' && is_numeric($delay))
                    {
                        update_option('myfeeds_last_time', time());
                    }
                    return file_get_contents($url, false, $cxContext);
                }
                else
                {
                    global $wp_filesystem;
                    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                        wp_filesystem($creds);
                    }
                    if($delay != '' && is_numeric($delay))
                    {
                        update_option('myfeeds_last_time', time());
                    }
                    return $wp_filesystem->get_contents($url);
                }
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    if(($content === false || empty($content)) && myfeeds_isCurl())
    {
        if (isset($myfeeds_Main_Settings['search_google']) && $myfeeds_Main_Settings['search_google'] == 'on') {
            $google_url =  "http://webcache.googleusercontent.com/search?q=cache:".urlencode($url);
            $ch2 = curl_init($google_url);
            if ($ch2 === FALSE) {
                return FALSE;
            }
            curl_setopt_array($ch2, $options);
            $content = curl_exec($ch2);
            curl_close($ch2);
            if($content === false || empty($content) || (stristr($content, 'was not found on this server.') !== false && stristr($content, 'Error 404 (Not Found)!!1') !== false))
            {
                return false;
            }
        }
    }
    return $content;
}

function myfeeds_get_author($content)
{
    preg_match('{<meta[^<]*?name=["\']author["\'][^<]*?>}s', $content, $mathc);
    if(isset($mathc[0]) && stristr($mathc[0], 'author')){
        preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
        if(isset($matx[1]))
        {
            $auth = $matx[1];
            if(trim($auth) !='')
            {
                return $auth;
            }
        }
    }
    return ''; 
}
function myfeeds_get_featured_image($content, $dom, $skip_og, $skip_post_content, $url, $lazy_tag)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $html_data = false;
    if($skip_og != '1')
    {
        preg_match('{<meta[^<]*?property=["\']og:image(?::secure_url)?["\'][^<]*?>}i', $content,$mathc);
        if(isset($mathc[0]) && stristr($mathc[0], 'og:image')){
            preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
            if(isset($matx[1]))
            {
                $og_img = $matx[1];
                if(trim($og_img) !='')
                {
                    return $og_img;
                }
            }
        }
        preg_match('{[\'"]]thumbnailUrl[\'"]\s*:\s*[\'"]([^\'"]+)[\'"]}i', $content, $mathc);
        if(isset($mathc[1][0])){
            $og_img = $mathc[1][0];
            if(trim($og_img) !='')
            {
                return $og_img;
            }
        }
        preg_match('{[\'"]@type[\'"]:[\'"]ImageObject[\'"],[\'"]url[\'"]:[\'"]([^\'"]+)[\'"]}i', $content, $mathc);
        if(isset($mathc[1][0])){
            $og_img = $mathc[1][0];
            if(trim($og_img) !='')
            {
                return $og_img;
            }
        }
        preg_match('{<meta[^<]*?property\s*=["\']twitter:image["\'][^<]*?>}i', $content,$mathc);
        if(isset($mathc[0]) && stristr($mathc[0], 'twitter:image')){
            preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
            if(isset($matx[1]))
            {
                $og_img = $matx[1];
                if(trim($og_img) !='')
                {
                    return $og_img;
                }
            }
        }
        preg_match('{<meta[^<]*?name\s*=["\']thumbnail["\'][^<]*?>}i', $content,$mathc);
        if(isset($mathc[0]) && stristr($mathc[0], 'content=')){
            preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
            if(isset($matx[1]))
            {
                $og_img = $matx[1];
                if(trim($og_img) !='')
                {
                    return $og_img;
                }
            }
        }
        preg_match('{<meta[^<]*?itemprop\s*=["\']image["\'][^<]*?>}i', $content,$mathc);
        if(isset($mathc[0]) && stristr($mathc[0], 'content=')){
            preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
            if(isset($matx[1]))
            {
                $og_img = $matx[1];
                if(trim($og_img) !='')
                {
                    return $og_img;
                }
            }
        }
        preg_match('{<meta[^<]*?itemprop\s*=["\']thumbnailUrl["\'][^<]*?>}i', $content,$mathc);
        if(isset($mathc[0]) && stristr($mathc[0], 'content=')){
            preg_match('{content=["\'](.*?)["\']}s', $mathc[0],$matx);
            if(isset($matx[1]))
            {
                $og_img = $matx[1];
                if(trim($og_img) !='')
                {
                    return $og_img;
                }
            }
        }
    }
    if($skip_post_content != '1')
    {
        $count = 0;
        $biggest_img = '';           
        $tags    = $dom->getElementsByTagName('img');
        $maxSize = 0;
        foreach ($tags as $tag) {
            if($lazy_tag == '')
            {
                $lazy_tag = 'src';
            }
            $temp_get_img = $tag->getAttribute($lazy_tag);
            if($temp_get_img == '' && $lazy_tag != 'src')
            {
                $temp_get_img = $tag->getAttribute('src');
            }
            if ($temp_get_img != '') {
                if(stristr($temp_get_img, 'http:') === FALSE && stristr($temp_get_img, 'www.') === FALSE && stristr($temp_get_img, 'https:') === FALSE)
                {
                    $my_url  = parse_url($url);
                    $my_host = $my_url['host'];
                    $temp_get_img = trim($temp_get_img);
                    if(preg_match('{^//}', $temp_get_img)){
                        $temp_get_img = 'http:'.$temp_get_img;
                    }elseif( preg_match('{^/}', $temp_get_img) ){
                        $temp_get_img = 'http://'.$my_host.$temp_get_img;
                    }else{
                        $temp_get_img = 'http://'.$my_host.'/'.$temp_get_img;
                    }
                }
                $temp_get_img = strtok($temp_get_img, '?');
                $temp_get_img   = rtrim($temp_get_img, '/');
                $image=getimagesize($temp_get_img);
                $count++;
                if(isset($image[0]) && isset($image[1]) && is_numeric($image[0]) && is_numeric($image[1]))
                {
                    if (($image[0] * $image[1]) > $maxSize) {   
                        $maxSize = $image[0] * $image[1]; 
                        $biggest_img = $temp_get_img;
                    }
                }
            }
        }
        return $biggest_img;
    }
    return ''; 
}
function myfeeds_is_valid_img($img_type3, $img_url)
{
    if (strstr($img_type3, 'image/') !== false) {
        $image=getimagesize($img_url);
        if(isset($image[0]) && isset($image[1]) && is_numeric($image[0]) && is_numeric($image[1]))
        {
            if (($image[0] * $image[1]) >= 100) {
                return true;
            }
        }
    }
    return false;
}
function myfeeds_wpse_allowedtags() {
        return '<script>,<style>,<br>,<em>,<i>,<ul>,<ol>,<li>,<a>,<p>,<img>,<video>,<audio>'; 
}
    
function myfeeds_custom_wp_trim_excerpt($raw_excerpt, $excerpt_word_count, $more_url, $read_more) {
    $wpse_excerpt = $raw_excerpt;
            $wpse_excerpt = strip_shortcodes( $wpse_excerpt );
            $wpse_excerpt = str_replace(']]>', ']]&gt;', $wpse_excerpt);
            $wpse_excerpt = strip_tags($wpse_excerpt, myfeeds_wpse_allowedtags());
                $tokens = array();
                $excerptOutput = '';
                $count = 0;
                preg_match_all('/(<[^>]+>|[^<>\s]+)\s*/u', $wpse_excerpt, $tokens);
                foreach ($tokens[0] as $token) { 

                    if ($count >= $excerpt_word_count && preg_match('/[\,\;\?\.\!]\s*$/uS', $token)) { 
                        $excerptOutput .= trim($token);
                        break;
                    }
                    $count++;
                    $excerptOutput .= $token;
                }
            $wpse_excerpt = trim(force_balance_tags($excerptOutput));
            $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
            if($read_more == ' '){
                $excerpt_end = '';
            }
            else{
                if($read_more == '')
                {
                    if (isset($myfeeds_Main_Settings['read_more_text']) && $myfeeds_Main_Settings['read_more_text'] != '') {
                        $read_more = $myfeeds_Main_Settings['read_more_text'];
                    }
                    else
                    {
                        $read_more = esc_html__('Read More', 'rss-feed-from-any-site');
                    }
                }
                $excerpt_end = ' <a href="' . esc_url($more_url) . '" target="_blank">&nbsp;&raquo;&nbsp;' . esc_html($read_more) . '</a>'; 
            }
            $wpse_excerpt .= $excerpt_end;
        return $wpse_excerpt;
}

function myfeeds_count_unicode_words( $unicode_string ){
    $unicode_string = preg_replace('/[[:punct:][:digit:]]/', '', $unicode_string);
    $unicode_string = preg_replace('/[[:space:]]/', ' ', $unicode_string);
    $words_array = preg_split( "/[\n\r\t ]+/", $unicode_string, 0, PREG_SPLIT_NO_EMPTY );
    return count($words_array);
}
function myfeeds_replaceSynergyShortcodes($the_content)
{
    $regex = '#%%([a-z0-9]+?)(?:_title)?_(\d+?)_(\d+?)%%#';
    $rezz = preg_match_all($regex, $the_content, $matches);
    if ($rezz === FALSE) {
        return $the_content;
    }
    if(isset($matches[1][0]))
    {
        $two_var_functions = array('pdfomatic');
        $three_var_functions = array('aiomatic', 'bhomatic', 'crawlomatic', 'dmomatic', 'ezinomatic', 'fbomatic', 'flickomatic', 'imguromatic', 'iui', 'instamatic', 'linkedinomatic', 'mediumomatic', 'pinterestomatic', 'echo', 'spinomatic', 'tumblomatic', 'wordpressomatic', 'wpcomomatic', 'youtubomatic', 'mastermind', 'businessomatic');
        $four_var_functions = array('contentomatic', 'quoramatic', 'newsomatic', 'aliomatic', 'amazomatic', 'blogspotomatic', 'bookomatic', 'careeromatic', 'cbomatic', 'cjomatic', 'craigomatic', 'ebayomatic', 'etsyomatic', 'rakutenomatic', 'learnomatic', 'eventomatic', 'gameomatic', 'gearomatic', 'giphyomatic', 'gplusomatic', 'hackeromatic', 'imageomatic', 'midas', 'movieomatic', 'nasaomatic', 'ocartomatic', 'okomatic', 'playomatic', 'recipeomatic', 'redditomatic', 'soundomatic', 'mp3omatic', 'ticketomatic', 'tmomatic', 'trendomatic', 'tuneomatic', 'twitchomatic', 'twitomatic', 'vimeomatic', 'viralomatic', 'vkomatic', 'walmartomatic', 'bestbuyomatic', 'wikiomatic', 'xlsxomatic', 'yelpomatic', 'yummomatic');
        for ($i = 0; $i < count($matches[1]); $i++)
        {
            $replace_me = false;
            if(in_array($matches[1][$i], $four_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 4)
                    {  
                        $rule_runner = $za_function($matches[3][$i], $matches[2][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            if(is_array($rule_runner))
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[0], $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[1], $the_content);
                            }
                            else
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
                            }
                            
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $three_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 3)
                    {
                        $rule_runner = $za_function($matches[3][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            if(is_array($rule_runner))
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[0], $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[1], $the_content);
                            }
                            else
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
                            }
                            
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $two_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 2)
                    {
                        $rule_runner = $za_function($matches[3][$i], 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            if(is_array($rule_runner))
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[0], $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner[1], $the_content);
                            }
                            else
                            {
                                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
                            }
                            
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            if($replace_me == false)
            {
                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
                $the_content = str_replace('%%' . $matches[1][$i] . '_title_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
            }
        }
    }
    return $the_content;
}

function myfeeds_lazy_loading_auto_fix($cont)
{
    preg_match_all('{<img .*?>}s', $cont, $imgsMatchs);
    $imgs_count = count($imgsMatchs[0]);
    if($imgs_count < 1)
    {
        return $cont;
    }
    $our_lazy_tag = '';
    if(stristr($cont, ' data-src=')) 
    {
        $our_lazy_tag = 'data-src';
    } 
    elseif(stristr($cont, ' data-lazy-src=')) 
    {
        $our_lazy_tag = 'data-lazy-src';
    } 
    elseif(stristr($cont, ' data-ezsrc=')) 
    {
        $our_lazy_tag = 'data-ezsrc';
    } 
    elseif(stristr($cont, ' data-pagespeed-lazy-src=')) 
    {
        $our_lazy_tag = 'data-pagespeed-lazy-src';
    } 
    else 
    {
        $lazy_suspected = false;
        $images_plain = implode (' ', $imgsMatchs[0]);
        if (stristr($images_plain, 'lazy')) 
        {
            $lazy_suspected = true;
        } 
        else 
        {
            preg_match_all('{ src[\s]?=[\s]?["|\'](.*?)["|\']}', $images_plain, $srcs_matches);
            $found_srcs_count = count($srcs_matches[0]);
            $unique_srcs_count = count(array_unique($srcs_matches[1]));
            if ($found_srcs_count != 0) 
            {
                $diff_percentage = ($found_srcs_count-$unique_srcs_count)*100/$found_srcs_count;
            } 
            else 
            {
                $diff_percentage = 0;
            }
            if ($diff_percentage > 39) 
            {
                $lazy_suspected = true;
            }
        }
        if ($lazy_suspected) 
        {
            $remove_src_attr = preg_replace ('{ src[\s]?=[\s]?["|\'].*?["|\']}', ' ', $images_plain);
            $remove_these = array (' alt', ' srcset', ' data-srcset', ' class', ' id', ' title');
            $remove_src_attr = str_replace($remove_these, ' ', $remove_src_attr);
            $remove_src_attr = preg_replace('{ [\w|-]*?[\s]?=[\s]?["|\'].{1,9}?["|\']}s', ' ', $remove_src_attr);
            preg_match_all('{( [\w|-]*?)[\s]?=[\s]?["|\'][^",]*?/[^",]*?["|\']}', $remove_src_attr, $possible_src_matches);
            $src_match_unique = array_unique($possible_src_matches[1]);
            if (isset($src_match_unique[0])) 
            {
                $our_lazy_tag = $src_match_unique[0];
            }
        }
    }
    $our_lazy_tag = trim($our_lazy_tag);
    if ($our_lazy_tag == 'src' || $our_lazy_tag == '')
    {
        return $cont;
    }
    if (!stristr($cont, $our_lazy_tag))
    {
        return $cont;
    }
    foreach ($imgsMatchs[0] as $imgMatch) 
    {
        if (stristr($imgMatch, $our_lazy_tag)) 
        {
            $newImg = $imgMatch;
            $newImg = str_replace ( ' src=', ' previous-src=', $newImg );
            $newImg = preg_replace ( '{ previous-src=[\'|"].*?[\'|"] }', ' ', $newImg );
            $newImg = str_replace ( ' ' . $our_lazy_tag, ' src', $newImg );
            $cont = str_replace ( $imgMatch, $newImg, $cont );
        }
    }
    return $cont;
}
function myfeeds_file_get_contents_advanced($url, $headers = '', $referrer = 'self', $user_agent = false)
{
    $content = false;
    if (parse_url($url, PHP_URL_SCHEME) != '' && function_exists('curl_init')) 
    {
        $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
        $max_redirects = 10;
        $ch = curl_init();
        if($ch !== false)
        {
            curl_setopt($ch, CURLOPT_URL, $url);
            if (strtolower($referrer) == 'self') {
                curl_setopt($ch, CURLOPT_REFERER, $url);
            } elseif (strlen($referrer)) {
                curl_setopt($ch, CURLOPT_REFERER, $referrer);
            }
            if ($user_agent) {
                curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
            } 
            curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            $headers = trim($headers);
            if (strlen($headers)) {
                $headers_array = explode(PHP_EOL, $headers);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers_array);
            }
            if (isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') {
                $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
                $randomness = array_rand($prx);
                curl_setopt( $ch, CURLOPT_PROXY, trim($prx[$randomness]));
                if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
                {
                    $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                    if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                    {
                        curl_setopt( $ch, CURLOPT_PROXYUSERPWD, trim($prx_auth[$randomness]));
                    }
                }
            }
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            if (ini_get('open_basedir') == '') 
            {
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_MAXREDIRS, $max_redirects);
            } 
            else 
            {
                $base_url = $url;
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
                $rch = curl_copy_handle($ch);
                curl_setopt($rch, CURLOPT_HEADER, true);
                curl_setopt($rch, CURLOPT_NOBODY, true);
                curl_setopt($rch, CURLOPT_FORBID_REUSE, false);
                curl_setopt($rch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($rch, CURLOPT_SSL_VERIFYPEER, false);
                do 
                {
                    curl_setopt($rch, CURLOPT_URL, $url);
                    curl_setopt($rch, CURLOPT_REFERER, $url);
                    $header = curl_exec($rch);
                    if (curl_errno($rch)) {
                        $code = 0;
                    } else {
                        $code = curl_getinfo($rch, CURLINFO_HTTP_CODE);
                        if ($code == 301 || $code == 302) {
                            preg_match('/Location:(.*?)\n/', $header, $matches);
                            $url = trim(array_pop($matches));
                            if (strlen($url) && substr($url, 0, 1) == '/') {
                                $url = $base_url . $url;
                            }
                        } else {
                            $code = 0;
                        }
                    }
                } 
                while ($code && --$max_redirects);
                curl_close($rch);
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_REFERER, $url);
            }
            curl_setopt($ch, CURLOPT_HEADER, false);
            $content = curl_exec($ch);
            $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            if ($code != 200) {
                $content = false;
            }
            curl_close($ch);
        }
    }
    if (!isset($content) || $content === false) {
        stream_context_set_default(array('ssl' => array('verify_peer' => false, 'verify_peer_name' => false,), 'http' => array('method' => 'HEAD', 'timeout' => 10, 'user_agent' => $user_agent)));
        $content = file_get_contents($url);
    }
    return $content;
}
function myfeeds_get_random_image_google($keyword, $min_width = 0, $min_height = 0)
{
    $gimageurl = 'https://www.google.com/search?q=' . urlencode($keyword . ' -site:depositphotos.com -site:123rf.com') . '&tbm=isch&tbs=il:cl&sa=X';
    $res = myfeeds_file_get_contents_advanced($gimageurl, '', 'self', 'Mozilla/5.0 (Windows NT 10.0;WOW64;rv:97.0) Gecko/20100101 Firefox/97.0/3871tuT2p1u-81');
    preg_match_all('/\["([\w%-\.\/:\?&=]+\.jpg|\.jpeg|\.gif|\.png|\.bmp|\.wbmp|\.webm|\.xbm)",\d+,\d+\]/i', $res, $matches);
    $items = $matches[0];
    if (count($items)) {
        shuffle($items);
        foreach ($items as $item) {
            preg_match('#\["(.*?)",(.*?),(.*?)\]#', $item, $matches);
            if (count($matches) == 4 && ($min_width > 0 || $min_width <= $matches[3]) && ($min_height > 0 || $min_height <= $matches[2])) {
                return $matches[1];
            }
        }
    }
    return '';
}
function myfeeds_repairHTML($text)
{
    $text = htmlspecialchars_decode($text);
    $text = str_replace("< ", "<", $text);
    $text = str_replace(" >", ">", $text);
    $text = str_replace("= ", "=", $text);
    $text = str_replace(" =", "=", $text);
    $text = str_replace("\/ ", "\/", $text);
    $text = str_replace("</ iframe>", "</iframe>", $text);
    $text = str_replace("frameborder ", "frameborder=\"0\" allowfullscreen></iframe>", $text);
    $doc = new DOMDocument();
    $doc->substituteEntities = false;
    $internalErrors = libxml_use_internal_errors(true);
    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $text);
                    libxml_use_internal_errors($internalErrors);
    $text = $doc->saveHTML();
	$text = preg_replace('#<!DOCTYPE html PUBLIC "-\/\/W3C\/\/DTD HTML 4\.0 Transitional\/\/EN" "http:\/\/www\.w3\.org\/TR\/REC-html40\/loose\.dtd">(?:[^<]*)<\?xml encoding="utf-8" \?><html><body>(?:<p>)?#i', '', $text);
	$text = str_replace('</p></body></html>', '', $text);
    $text = str_replace('</body></html></p>', '', $text);
    $text = str_replace('</body></html>', '', $text);
    return $text;
}
if (! function_exists("myfeeds_array_key_last")) {
    function myfeeds_array_key_last($array) {
        if (!is_array($array) || empty($array)) {
            return NULL;
        }
       
        return array_keys($array)[count($array)-1];
    }
}
add_action('init', 'myfeeds_customRSS');
function myfeeds_customRSS(){
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] == 'on') {
        if (!get_option('myfeeds_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('myfeeds_rules_list');
        }
        if (!empty($rules)) {
            if ( !function_exists( 'add_feed' ) ) { 
                require_once ABSPATH . WPINC . '/rewrite.php'; 
            } 
            $cont = 0;
            $xfeed_names = array();
            foreach ($rules as $request => $bundle[]) {
                $bundle_values   = array_values($bundle);
                $myValues        = $bundle_values[$cont];
                $array_my_values = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                $feed_name       = isset($array_my_values[5]) ? $array_my_values[5] : '';
                $feed_id         = isset($array_my_values[6]) ? $array_my_values[6] : '';
                $feed_generated  = isset($array_my_values[7]) ? $array_my_values[7] : '';
                
                if($feed_generated == '1')
                {
                    $xfeed_names[] = $feed_name;
                    add_feed($feed_name,function() use ($feed_name, $feed_id)
                        {
                            myfeeds_customRSSFunc($feed_name, $feed_id);
                        }
                    );
                }
                $cont = $cont + 1;
            }
            if (isset($myfeeds_Main_Settings['force_refresh']) && $myfeeds_Main_Settings['force_refresh'] == 'on') 
            {
                global $wp_rewrite;
                $wp_rewrite->flush_rules();
                myfeeds_log_to_file('Feeds refreshed on demand.');
                unset($myfeeds_Main_Settings['force_refresh']);
                update_option('myfeeds_Main_Settings', $myfeeds_Main_Settings);
            }
            $rwrules = get_option( 'rewrite_rules' );
            $registered = TRUE;
            if(is_array($rwrules))
            {
                $my_feeds = array_keys( $rwrules, 'index.php?&feed=$matches[1]' );
                foreach ( $my_feeds as $xfeed )
                {
                    if($xfeed != '')
                    {
                        foreach($xfeed_names as $xfeed_name)
                        {
                            if ( FALSE === strpos( $xfeed, $xfeed_name ) )
                            {
                                $registered = FALSE;
                                break;
                            }
                        }
                    }
                    if($registered === false)
                    {
                        break;
                    }
                }
            }
            if ( !$registered )
            {
                flush_rewrite_rules( FALSE );
            }
        }
    }
}

function myfeeds_customRSSFunc($query_feed_name, $feed_id){
    
    
    header('Content-Type: ' . feed_content_type( 'rss2' ) . '; charset='.get_option('blog_charset'), true);
    echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>';
    do_action( 'rss_tag_pre', 'rss2' );
    ?>
<rss version="2.0"
xmlns:media="http://search.yahoo.com/mrss/"
xmlns:content="http://purl.org/rss/1.0/modules/content/"
xmlns:wfw="http://wellformedweb.org/CommentAPI/"
xmlns:dc="http://purl.org/dc/elements/1.1/"
xmlns:atom="http://www.w3.org/2005/Atom"
xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
<?php 
ob_start();
do_action( 'rss2_ns' );
$action_data = ob_get_clean();
$action_data = str_replace('xmlns:media="http://search.yahoo.com/mrss/"', '', $action_data);
$action_data = str_replace('xmlns:content="http://purl.org/rss/1.0/modules/content/"', '', $action_data);
$action_data = str_replace('xmlns:wfw="http://wellformedweb.org/CommentAPI/"', '', $action_data);
$action_data = str_replace('xmlns:dc="http://purl.org/dc/elements/1.1/"', '', $action_data);
$action_data = str_replace('xmlns:atom="http://www.w3.org/2005/Atom"', '', $action_data);
$action_data = str_replace('xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"', '', $action_data);
$action_data = str_replace('xmlns:slash="http://purl.org/rss/1.0/modules/slash/"', '', $action_data);
echo $action_data;
?>>
<?php
    
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!get_option('myfeeds_rules_list')) {
        $rules = array();
    } else {
        $rules = get_option('myfeeds_rules_list');
    }
    $feed_name = '';
    $update_period = '';
    $feed_title = '';
    $feed_url = '';
    $feed_language = '';
    $feed_description = '';
    $update_frequency = '';
    $custom_tags = '';
    $url_append  = '';
    
    if (!empty($rules)) {
        $cont = 0;
        foreach ($rules as $request => $bundle[]) {
            $bundle_values   = array_values($bundle);
            $myValues        = $bundle_values[$cont];
            $array_my_values = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
            $temp_name       = isset($array_my_values[5]) ? $array_my_values[5] : '';
            $update_period   = isset($array_my_values[79]) ? $array_my_values[79] : 'daily';
            $feed_title      = isset($array_my_values[80]) ? $array_my_values[80] : '%%wp_title_rss%%';
            $feed_url        = isset($array_my_values[81]) ? $array_my_values[81] : '%%wp_url_rss%%';
            $feed_description = isset($array_my_values[82]) ? $array_my_values[82] : '%%wp_url_rss%%';
            $feed_language   = isset($array_my_values[83]) ? $array_my_values[83] : '%%wp_url_rss%%';
            $update_frequency= isset($array_my_values[84]) ? $array_my_values[84] : '1';
            $post_pubdate    = isset($array_my_values[85]) ? $array_my_values[85] : '%%item_pub_date%%';
            $custom_tags     = isset($array_my_values[89]) ? $array_my_values[89] : '';
            $url_append      = isset($array_my_values[90]) ? $array_my_values[90] : '';
            if($temp_name == $query_feed_name)
            {
                $feed_name = $temp_name;
                break; 
            }
            $cont = $cont + 1; 
        }
    }
    else
    {
?>
</rss>
<?php
        return;
    }
    $feed_title = str_replace('%%wp_title_rss%%', get_wp_title_rss(), $feed_title);
    $feed_url = str_replace('%%wp_url_rss%%', get_bloginfo_rss('url'), $feed_url);
    $feed_description = str_replace('%%wp_description_rss%%', get_bloginfo_rss('description'), $feed_description);
    $feed_language = str_replace('%%wp_language_rss%%', get_bloginfo_rss('language'), $feed_language);
    if($feed_name == '')
    {
?>
</rss>
<?php
        return;
    }
    if ( ! function_exists( 'get_page_by_title' ) ) {
        include_once( ABSPATH . 'wp-includes/post.php' );
    }
    $existing = get_page_by_title(html_entity_decode($feed_id), OBJECT, 'myfeeds_feed');
    if($existing === null)
    {
        myfeeds_log_to_file('Feed ID not found: ' . $feed_id);
?>
</rss>
<?php
        return;
    }
    
    $posts = $existing->post_content;
    $posts = json_decode($posts);
    if(!is_array($posts))
    {
        myfeeds_log_to_file('Feed content cannot be decoded: ' . $feed_id . ' - ' . json_last_error());
?>
</rss>
<?php
        return;
    }
?>
<channel>
<title><![CDATA[<?php echo esc_html($feed_title); ?>]]></title>
<atom:link href="<?php self_link(); ?>" rel="self" type="application/rss+xml" />
<link><?php echo esc_url($feed_url); ?></link>
<description><![CDATA[<?php echo esc_html($feed_description); ?>]]></description>
<language><?php echo esc_html($feed_language); ?></language>
<sy:updatePeriod><?php echo apply_filters( 'rss_update_period', $update_period ); ?></sy:updatePeriod>
<sy:updateFrequency><?php echo apply_filters( 'rss_update_frequency', $update_frequency ); ?></sy:updateFrequency>
<sy:updateBase><?php $xt = gmdate('Y-m-d\TH:i\+00\:00', time()); echo apply_filters( 'rss_update_base', $xt ); ?></sy:updateBase>
<?php do_action('rss2_head');
if(trim($custom_tags) != '')
{
    $custom_tag_arr = preg_split('/\r\n|\r|\n/', trim($custom_tags));
    foreach($custom_tag_arr as $cca)
    {
        //tag_name => tag_value
        if(trim($cca) != '')
        {
            $ctag_name = explode('=>', $cca);
            if(isset($ctag_name[1]))
            {
                $tag_name = trim($ctag_name[0]);
?>
<<?php echo esc_html($tag_name);?>><![CDATA[<?php echo trim($ctag_name[1]);?>]]></<?php echo esc_html($tag_name);?>>
<?php
            }
        }
    }
}
?>
<?php foreach($posts as $post)
{
?>
<item>
<?php
if(isset($post->final_title) && $post->final_title !== '')
{
?>
<title><![CDATA[<?php echo html_entity_decode(str_replace('\\\\', '\\', $post->final_title), ENT_QUOTES | ENT_HTML5, 'utf-8'); ?>]]></title>
<?php 
}
if(isset($post->url) && $post->url !== '')
{
?>
<link><?php if($url_append != ''){echo esc_url($post->url . $url_append);}else{echo esc_url($post->url);}?></link>
<?php                
} 
if(isset($post->final_content) && $post->final_content !== '')
{       
$etext = strip_shortcodes( html_entity_decode(str_replace('\\\\', '\\', $post->final_content), ENT_QUOTES | ENT_HTML5, 'utf-8') );
$etext = apply_filters( 'the_content', $etext );
$etext = str_replace(']]>', ']]&gt;', $etext);
$excerpt_length = apply_filters( 'excerpt_length', 55 );
$excerpt_more = apply_filters( 'excerpt_more', ' ' . '...' );
$etext = wp_trim_words( $etext, $excerpt_length, $excerpt_more );
if($etext != '')
{
?>
<description><![CDATA[<?php echo esc_html($etext); ?>]]></description>
<?php
}
}
if(isset($post->custom_tag) && is_array($post->custom_tag))
{ 
foreach($post->custom_tag as $ct => $cval)
{
?>
<<?php echo html_entity_decode(str_replace('\\\\', '\\', $ct), ENT_QUOTES | ENT_HTML5, 'utf-8');?>><![CDATA[<?php echo html_entity_decode(str_replace('\\\\', '\\', $cval), ENT_QUOTES | ENT_HTML5, 'utf-8'); ?>]]></<?php echo html_entity_decode(str_replace('\\\\', '\\', $ct), ENT_QUOTES | ENT_HTML5, 'utf-8');?>>
<?php
}
}
if(isset($post->final_content) && $post->final_content !== '')
{      
?>
<content:encoded><![CDATA[<?php echo html_entity_decode(str_replace('\\\\', '\\', $post->final_content), ENT_QUOTES | ENT_HTML5, 'utf-8'); ?>]]></content:encoded>
<?php
}
?>
<guid isPermaLink="false"><?php echo esc_html(uniqid()); ?></guid>
<?php
    if(isset($post->categories) && $post->categories)
    {
        foreach($post->categories as $px)
        {
?>
<category><![CDATA[<?php echo esc_html($px); ?>]]></category>
<?php
        }
    }
    $feed_itdate = $post_pubdate;
    if(isset($post->date) && $post->date != '')
    {
        $post_date = $post->date;
        $timex = strtotime($post_date);
        if(!empty($post_date) && $timex !== false && $timex > 0)
        {
            $post_date = mysql2date('D, d M Y H:i:s +0000', $post_date, false);
            $feed_itdate = str_replace('%%item_pub_date%%', $post_date, $feed_itdate);
        }
        else
        {
            $feed_itdate = str_replace('%%item_pub_date%%', '', $feed_itdate);
        }
    }
    else
    {
        $post_date = '';
        $feed_itdate = '';
    }
    $feed_itdate = str_replace('%%current_time%%', date('m/d/Y h:i:s a', time()), $feed_itdate);
    if($feed_itdate != '')
    {
?>
<pubDate><?php echo esc_html($feed_itdate);?></pubDate>
<?php
    }
if(isset($post->author) && $post->author != '')
{
?>
<dc:creator><![CDATA[<?php if(isset($post->author)){echo esc_html($post->author);}?>]]></dc:creator>                     
<?php
}
if( isset($post->image) && $post->image != '' ) {
    echo '<media:content medium="image" url="';
    echo esc_url($post->image);
    echo '" />';
}
rss_enclosure(); ?>
<?php do_action('rss2_item'); ?>
</item>
<?php } ?>
</channel>
</rss>
<?php
}
add_action('init', 'myfeeds_create_posttype');
function myfeeds_create_posttype() {
    $labels = array(
        'name' => 'Custom RSS Feeds',
        'all_items' => 'All RSS Feeds',
        'singular_name' => 'myfeeds_feed',
        'add_new' => 'New RSS Feed' ,
        'add_new_item' => 'Add New RSS Feed',
        'edit_item' => 'Edit RSS Feed',
        'new_item' => 'New RSS Feed',
        'view_item' => 'View RSS Feed',
        'search_items' => 'Search RSS Feeds',
        'not_found' => 'No RSS Feeds found',
        'not_found_in_trash' => 'No RSS Feeds found in Trash',
        'parent_item_colon' => 'Parent RSS Feed:',
        'menu_name' => 'Custom RSS Feeds',
	);
    $args = array(
        'labels' => $labels,
        'hierarchical' => false,
        'description' => 'Custom RSS Feeds List',
        'supports' => array( 'title', 'editor' ),
        'taxonomies' => array( 'options' ),
        'public' => false,
        'show_ui' => true,
        'show_in_menu' => true,
        'show_in_nav_menus' => false,
        'menu_position' => 66666665666666666  ,
        'publicly_queryable' => false,
        'exclude_from_search' => true,
        'has_archive' => false,
        'query_var' => true,
        'can_export' => true,
        'rewrite' => true,
        'capability_type' => 'post'
	);
	$admin_caps = array('capabilities' => array(
        'edit_post'          => 'manage_options',
        'read_post'          => 'manage_options',
        'delete_post'        => 'manage_options',
        'edit_posts'         => 'manage_options',
        'edit_others_posts'  => 'manage_options',
        'delete_posts'       => 'manage_options',
        'publish_posts'      => 'manage_options',
        'read_private_posts' => 'manage_options'
	));
    $args = array_merge($args, $admin_caps);
    register_post_type( 'myfeeds_feed', $args);
}
class myfeeds_keywords{ 
    public static $charset = 'UTF-8';
    public static $banned_words = array('adsbygoogle', 'able', 'about', 'above', 'act', 'add', 'afraid', 'after', 'again', 'against', 'age', 'ago', 'agree', 'all', 'almost', 'alone', 'along', 'already', 'also', 'although', 'always', 'am', 'amount', 'an', 'and', 'anger', 'angry', 'animal', 'another', 'answer', 'any', 'appear', 'apple', 'are', 'arrive', 'arm', 'arms', 'around', 'arrive', 'as', 'ask', 'at', 'attempt', 'aunt', 'away', 'back', 'bad', 'bag', 'bay', 'be', 'became', 'because', 'become', 'been', 'before', 'began', 'begin', 'behind', 'being', 'bell', 'belong', 'below', 'beside', 'best', 'better', 'between', 'beyond', 'big', 'body', 'bone', 'born', 'borrow', 'both', 'bottom', 'box', 'boy', 'break', 'bring', 'brought', 'bug', 'built', 'busy', 'but', 'buy', 'by', 'call', 'came', 'can', 'cause', 'choose', 'close', 'close', 'consider', 'come', 'consider', 'considerable', 'contain', 'continue', 'could', 'cry', 'cut', 'dare', 'dark', 'deal', 'dear', 'decide', 'deep', 'did', 'die', 'do', 'does', 'dog', 'done', 'doubt', 'down', 'during', 'each', 'ear', 'early', 'eat', 'effort', 'either', 'else', 'end', 'enjoy', 'enough', 'enter', 'even', 'ever', 'every', 'except', 'expect', 'explain', 'fail', 'fall', 'far', 'fat', 'favor', 'fear', 'feel', 'feet', 'fell', 'felt', 'few', 'fill', 'find', 'fit', 'fly', 'follow', 'for', 'forever', 'forget', 'from', 'front', 'gave', 'get', 'gives', 'goes', 'gone', 'good', 'got', 'gray', 'great', 'green', 'grew', 'grow', 'guess', 'had', 'half', 'hang', 'happen', 'has', 'hat', 'have', 'he', 'hear', 'heard', 'held', 'hello', 'help', 'her', 'here', 'hers', 'high', 'hill', 'him', 'his', 'hit', 'hold', 'hot', 'how', 'however', 'I', 'if', 'ill', 'in', 'indeed', 'instead', 'into', 'iron', 'is', 'it', 'its', 'just', 'keep', 'kept', 'knew', 'know', 'known', 'late', 'least', 'led', 'left', 'lend', 'less', 'let', 'like', 'likely', 'likr', 'lone', 'long', 'look', 'lot', 'make', 'many', 'may', 'me', 'mean', 'met', 'might', 'mile', 'mine', 'moon', 'more', 'most', 'move', 'much', 'must', 'my', 'near', 'nearly', 'necessary', 'neither', 'never', 'next', 'no', 'none', 'nor', 'not', 'note', 'nothing', 'now', 'number', 'of', 'off', 'often', 'oh', 'on', 'once', 'only', 'or', 'other', 'ought', 'our', 'out', 'please', 'prepare', 'probable', 'pull', 'pure', 'push', 'put', 'raise', 'ran', 'rather', 'reach', 'realize', 'reply', 'require', 'rest', 'run', 'said', 'same', 'sat', 'saw', 'say', 'see', 'seem', 'seen', 'self', 'sell', 'sent', 'separate', 'set', 'shall', 'she', 'should', 'side', 'sign', 'since', 'so', 'sold', 'some', 'soon', 'sorry', 'stay', 'step', 'stick', 'still', 'stood', 'such', 'sudden', 'suppose', 'take', 'taken', 'talk', 'tall', 'tell', 'ten', 'than', 'thank', 'that', 'the', 'their', 'them', 'then', 'there', 'therefore', 'these', 'they', 'this', 'those', 'though', 'through', 'till', 'to', 'today', 'told', 'tomorrow', 'too', 'took', 'tore', 'tought', 'toward', 'tried', 'tries', 'trust', 'try', 'turn', 'two', 'under', 'until', 'up', 'upon', 'us', 'use', 'usual', 'various', 'verb', 'very', 'visit', 'want', 'was', 'we', 'well', 'went', 'were', 'what', 'when', 'where', 'whether', 'which', 'while', 'white', 'who', 'whom', 'whose', 'why', 'will', 'with', 'within', 'without', 'would', 'yes', 'yet', 'you', 'young', 'your', 'br', 'img', 'p','lt', 'gt', 'quot', 'copy');
    public static $min_word_length = 4;
    
    public static function text($text, $length = 160)
    {
        return self::limit_chars(self::clean($text), $length,'',TRUE);
    } 

    public static function keywords($text, $max_keys = 3)
    {
        include (dirname(__FILE__) . "/res/diacritics.php");
        $wordcount = array_count_values(str_word_count(self::clean($text), 1, $diacritics));
        foreach ($wordcount as $key => $value) 
        {
            if ( (strlen($key)<= self::$min_word_length) OR in_array($key, self::$banned_words))
                unset($wordcount[$key]);
        }
        uasort($wordcount,array('self','cmp'));
        $wordcount = array_slice($wordcount,0, $max_keys);
        return implode(' ', array_keys($wordcount));
    } 

    private static function clean($text)
    { 
        $text = html_entity_decode($text,ENT_QUOTES,self::$charset);
        $text = strip_tags($text);
        $text = preg_replace('/\s\s+/', ' ', $text);
        $text = str_replace (array('\r\n', '\n', '+'), ',', $text);
        return trim($text); 
    } 

    private static function cmp($a, $b) 
    {
        if ($a == $b) return 0; 

        return ($a < $b) ? 1 : -1; 
    } 

    private static function limit_chars($str, $limit = 100, $end_char = NULL, $preserve_words = FALSE)
    {
        $end_char = ($end_char === NULL) ? '&#8230;' : $end_char;
        $limit = (int) $limit;
        if (trim($str) === '' OR strlen($str) <= $limit)
            return $str;
        if ($limit <= 0)
            return $end_char;
        if ($preserve_words === FALSE)
            return rtrim(substr($str, 0, $limit)).$end_char;
        if ( ! preg_match('/^.{0,'.$limit.'}\s/us', $str, $matches))
            return $end_char;
        return rtrim($matches[0]).((strlen($matches[0]) === strlen($str)) ? '' : $end_char);
    }
} 
function myfeeds_run_rule($param, $auto = 1, $ret_content = 0)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if($ret_content == 0)
    {  
        if (isset($myfeeds_Main_Settings['rule_timeout']) && $myfeeds_Main_Settings['rule_timeout'] != '') {
            $timeout = intval($myfeeds_Main_Settings['rule_timeout']);
        } else {
            $timeout = 3600;
        }
        ini_set('memory_limit', '-1');
        ini_set('default_socket_timeout', $timeout);
        ini_set('safe_mode', 'Off');
        ini_set('max_execution_time', $timeout);
        ini_set('ignore_user_abort', 1);
        ini_set('user_agent', myfeeds_get_random_user_agent());
        if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
        if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    }
    $posts_inserted         = 0;
    if (isset($myfeeds_Main_Settings['myfeeds_enabled']) && $myfeeds_Main_Settings['myfeeds_enabled'] == 'on') {
        try {
            $items            = array();
            $item_img         = '';
            $cont             = 0;
            $found            = 0;
            $ids              = '';
            $schedule         = '';
            $author_link      = '';
            $author_email     = '';
            $active           = '0';
            $last_run         = '';
            $post_title       = '';
            $post_content     = '';
            $default_category = '';
            $allow_html_tags  = '';
            $strip_links     = '';
            $only_text       = '';
            $type            = '';
            $expre           = '';
            $post_status     = 'publish';
            $feed_id         = '';
            $feed_generated  = 0;
            $strip_images    = '0';
            $max             = 50;
            $image_url       = '';
            $banned_words    = '';
            $required_words  = '';
            $strip_by_id     = '';
            $encoding        = 'NO_CHANGE';
            $strip_by_class  = '';
            $strip_by_xpath  = '';
            $skip_no_match   = '';
            $regex_image     = '';
            $limit_word_count = '';
            $translate       = 'disabled';
            $rule_unique_id  = '';
            $read_more       = '';
            $skip_og         = '0';
            $remove_cats     = '';
            $content_percent = '';
            $skip_post_content = '0';
            $source_lang     = 'en';
            $strip_by_regex  = '';
            $replace_regex   = '';
            $strip_by_regex_title  = '';
            $replace_regex_title   = '';
            $no_external     = '1';
            $title_expre     = '';
            $author_expre    = '';
            $author_type     = '';
            $title_type      = '';
            $image_type      = '';
            $image_expre     = '';
            $lazy_tag        = '';
            $date_type       = '';
            $date_expre      = '';
            $cat_type        = '';
            $cat_expre       = '';
            $max_depth       = '2';
            $custom_cookies  = '';
            $custom_user_agent = '';
            $only_class      = '';
            $only_id         = '';
            $no_source       = '0';
            $reverse_crawl   = '';
            $seed_type       = '';
            $seed_expre      = '';
            $crawled_type    = '';
            $crawled_expre   = '';
            $paged_crawl_str = '';
            $paged_crawl_type= 'class';
            $max_paged_depth = 5;
            $seed_pag_type   = '';
            $seed_pag_expre  = '';
            $continue_search = '';
            $cat_sep         = '';
            $date_index      = '';
            $keep_source     = '';
            $use_proxy       = '';
            $use_phantom     = '';
            $custom_crawling_expre = '';
            $custom_tag_expre= '';
            $strip_by_tag    = '';
            $crawl_exclude   = '';
            $crawl_title_exclude = '';
            $phantom_wait    = '';
            $user_pass       = '';
            $royalty_free    = '';
            $max_results     = '';
            $replace_words   = '';
            $url_type        = '';
            $url_expre       = '';
            $feed_title      = '';
            $no_link_scraper = '';
            $feed_description = '';
            $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
            if (!get_option('myfeeds_rules_list')) {
                $rules = array();
            } else {
                $rules = get_option('myfeeds_rules_list');
            }
            if (!empty($rules)) {
                foreach ($rules as $request => $bundle[]) {
                    if ($cont == $param) {
                        $bundle_values    = array_values($bundle);
                        $myValues         = $bundle_values[$cont];
                        $array_my_values  = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                        $ids              = isset($array_my_values[0]) ? $array_my_values[0] : '';
                        $schedule         = isset($array_my_values[1]) ? $array_my_values[1] : '';
                        $active           = isset($array_my_values[2]) ? $array_my_values[2] : '';
                        $last_run         = isset($array_my_values[3]) ? $array_my_values[3] : '';
                        $max              = isset($array_my_values[4]) ? $array_my_values[4] : '';
                        $post_status      = isset($array_my_values[5]) ? $array_my_values[5] : '';
                        $feed_id          = isset($array_my_values[6]) ? $array_my_values[6] : '';
                        $feed_generated   = isset($array_my_values[7]) ? $array_my_values[7] : '0';
                        $default_category = isset($array_my_values[8]) ? $array_my_values[8] : '';
                        $image_url        = isset($array_my_values[9]) ? $array_my_values[9] : '';
                        $post_title       = isset($array_my_values[10]) ? htmlspecialchars_decode($array_my_values[10]) : '';
                        $post_content     = isset($array_my_values[11]) ? htmlspecialchars_decode($array_my_values[11]) : '';
                        $only_text        = isset($array_my_values[12]) ? $array_my_values[12] : '';
                        $type             = isset($array_my_values[13]) ? $array_my_values[13] : '';
                        $expre            = isset($array_my_values[14]) ? $array_my_values[14] : '';
                        $banned_words     = isset($array_my_values[15]) ? $array_my_values[15] : '';
                        $required_words   = isset($array_my_values[16]) ? $array_my_values[16] : '';
                        $strip_by_id      = isset($array_my_values[17]) ? $array_my_values[17] : '';
                        $strip_by_class   = isset($array_my_values[18]) ? $array_my_values[18] : '';
                        $encoding         = isset($array_my_values[19]) ? $array_my_values[19] : '';
                        $limit_word_count = isset($array_my_values[20]) ? $array_my_values[20] : '';
                        $translate        = isset($array_my_values[21]) ? $array_my_values[21] : '';
                        $seed_pag_type    = isset($array_my_values[22]) ? $array_my_values[22] : '';
                        $strip_images     = isset($array_my_values[23]) ? $array_my_values[23] : '';
                        $rule_unique_id   = isset($array_my_values[24]) ? $array_my_values[24] : '';
                        $read_more        = isset($array_my_values[25]) ? $array_my_values[25] : '';
                        $skip_og          = isset($array_my_values[26]) ? $array_my_values[26] : '';
                        $remove_cats      = isset($array_my_values[27]) ? $array_my_values[27] : '';
                        $skip_post_content= isset($array_my_values[28]) ? $array_my_values[28] : '';
                        $content_percent  = isset($array_my_values[29]) ? $array_my_values[29] : '';
                        $custom_tag_expre = isset($array_my_values[30]) ? $array_my_values[30] : '';
                        $source_lang      = isset($array_my_values[31]) ? $array_my_values[31] : '';
                        $strip_by_regex   = isset($array_my_values[32]) ? $array_my_values[32] : '';
                        $replace_regex    = isset($array_my_values[33]) ? $array_my_values[33] : '';
                        $no_external      = isset($array_my_values[34]) ? $array_my_values[34] : '';
                        $title_type       = isset($array_my_values[35]) ? $array_my_values[35] : '';
                        $title_expre      = isset($array_my_values[36]) ? $array_my_values[36] : '';
                        $image_type       = isset($array_my_values[37]) ? $array_my_values[37] : '';
                        $image_expre      = isset($array_my_values[38]) ? $array_my_values[38] : '';
                        $date_type        = isset($array_my_values[39]) ? $array_my_values[39] : '';
                        $date_expre       = isset($array_my_values[40]) ? $array_my_values[40] : '';
                        $cat_type         = isset($array_my_values[41]) ? $array_my_values[41] : '';
                        $cat_expre        = isset($array_my_values[42]) ? $array_my_values[42] : '';
                        $max_depth        = isset($array_my_values[43]) ? $array_my_values[43] : '';
                        $custom_cookies   = isset($array_my_values[44]) ? $array_my_values[44] : '';
                        $only_class       = isset($array_my_values[45]) ? $array_my_values[45] : '';
                        $only_id          = isset($array_my_values[46]) ? $array_my_values[46] : '';
                        $no_source        = isset($array_my_values[47]) ? $array_my_values[47] : '';
                        $seed_type        = isset($array_my_values[48]) ? $array_my_values[48] : '';
                        $seed_expre       = isset($array_my_values[49]) ? $array_my_values[49] : '';
                        $crawled_type     = isset($array_my_values[50]) ? $array_my_values[50] : '';
                        $crawled_expre    = isset($array_my_values[51]) ? $array_my_values[51] : '';
                        $paged_crawl_str  = isset($array_my_values[52]) ? $array_my_values[52] : '';
                        $paged_crawl_type = isset($array_my_values[53]) ? $array_my_values[53] : '';
                        $max_paged_depth  = isset($array_my_values[54]) ? $array_my_values[54] : '';
                        $custom_user_agent= isset($array_my_values[55]) ? $array_my_values[55] : '';
                        $seed_pag_expre   = isset($array_my_values[56]) ? $array_my_values[56] : '';
                        $cat_sep          = isset($array_my_values[57]) ? $array_my_values[57] : '';
                        $date_index       = isset($array_my_values[58]) ? $array_my_values[58] : '';
                        $keep_source      = isset($array_my_values[59]) ? $array_my_values[59] : '';
                        $use_proxy        = isset($array_my_values[60]) ? $array_my_values[60] : '';
                        $use_phantom      = isset($array_my_values[61]) ? $array_my_values[61] : '';
                        $user_pass        = isset($array_my_values[62]) ? $array_my_values[62] : '';
                        $strip_by_tag     = isset($array_my_values[63]) ? $array_my_values[63] : '';
                        $crawl_exclude    = isset($array_my_values[64]) ? $array_my_values[64] : '';
                        $royalty_free     = isset($array_my_values[65]) ? $array_my_values[65] : '';
                        $max_results      = isset($array_my_values[66]) ? $array_my_values[66] : '';
                        $allow_html_tags  = isset($array_my_values[67]) ? $array_my_values[67] : '';
                        $strip_links      = isset($array_my_values[68]) ? $array_my_values[68] : '';
                        $lazy_tag         = isset($array_my_values[69]) ? $array_my_values[69] : '';
                        $reverse_crawl    = isset($array_my_values[70]) ? $array_my_values[70] : '';
                        $replace_words    = isset($array_my_values[71]) ? $array_my_values[71] : '';
                        $crawl_title_exclude = isset($array_my_values[72]) ? $array_my_values[72] : '';
                        $strip_by_regex_title = isset($array_my_values[73]) ? $array_my_values[73] : '';
                        $replace_regex_title = isset($array_my_values[74]) ? $array_my_values[74] : '';
                        $phantom_wait     = isset($array_my_values[75]) ? $array_my_values[75] : '';
                        $strip_by_xpath   = isset($array_my_values[76]) ? $array_my_values[76] : '';
                        $skip_no_match    = isset($array_my_values[77]) ? $array_my_values[77] : '';
                        $continue_search  = isset($array_my_values[78]) ? $array_my_values[78] : '';
                        //79 used in other parts
                        $feed_title       = isset($array_my_values[80]) ? $array_my_values[80] : '';
                        //81 used in other parts
                        $feed_description = isset($array_my_values[82]) ? $array_my_values[82] : '';
                        //83-85 used in other parts
                        $author_type      = isset($array_my_values[86]) ? $array_my_values[86] : '';
                        $author_expre     = isset($array_my_values[87]) ? $array_my_values[87] : '';
                        $custom_crawling_expre= isset($array_my_values[88]) ? $array_my_values[88] : '';
                        //89-90 used in other parts
                        $url_type         = isset($array_my_values[91]) ? $array_my_values[91] : '';
                        $url_expre        = isset($array_my_values[92]) ? $array_my_values[92] : '';
                        $regex_image      = isset($array_my_values[93]) ? $array_my_values[93] : '';
                        $no_link_scraper  = isset($array_my_values[94]) ? $array_my_values[94] : '';
                        $found            = 1;
                        break;
                    }
                    $cont = $cont + 1;
                }
            } else {
                myfeeds_log_to_file('No rules found for myfeeds_rules_list!');
                return 'fail';
            }
            if($ret_content == 0)
            {
                $f = fopen(get_temp_dir() . 'myfeeds_' . $param, 'w');
                if($f !== false)
                {
                    $flock_disabled = explode(',', ini_get('disable_functions'));
                    if(!in_array('flock', $flock_disabled))
                    {
                        if (!flock($f, LOCK_EX | LOCK_NB)) 
                        {
                            $GLOBALS['wp_object_cache']->delete('myfeeds_running_list', 'options');
                            $running = get_option('myfeeds_running_list', array());
                            if (!empty($running)) 
                            {
                                if (in_array($rule_unique_id, $running)) 
                                {
                                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
                                    {
                                        myfeeds_log_to_file('This rule is already running!');
                                    }
                                    return 'nochange';
                                }
                            }
                        }
                    }
                }
            }
            if($use_phantom == '1')
            {
                $phantom = myfeeds_testPhantom();
                if($phantom === 0)
                {
                    myfeeds_log_to_file('PhantomJS not found! Please install it on your server or configure the path to it from plugin\'s \'Main Settings\'.');
                    $use_phantom = '0';
                }
                elseif($phantom === -1)
                {
                    myfeeds_log_to_file('shell' . '_exec is not enabled on your server. Please enable it and retry using this feature of the plugin.');
                    $use_phantom = '0';
                }
                elseif($phantom === -2)
                {
                    myfeeds_log_to_file('shell' . '_exec is not allowed to run on your server (in disable_functions list in php.ini). Please enable it and retry using this feature of the plugin.');
                    $use_phantom = '0';
                }
            }
            if(!is_numeric($max_depth))
            {
                $max_depth = 2;
            }
			if($source_lang == 'disabled')
            {
                $source_lang = 'auto';
            }
            
            if($rule_unique_id == '')
            {
                $rule_unique_id = $param;
            }
            if ($found == 0) {
                myfeeds_log_to_file($param . ' not found in myfeeds_rules_list!');
                return 'fail';
            } else {
                if($ret_content == 0)
                {
                    $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
                    $rules = get_option('myfeeds_rules_list');
                    $rules[$param][3] = myfeeds_get_date_now();
                    update_option('myfeeds_rules_list', $rules, false);
                }
            }
            if($ret_content == 0)
            {
                $GLOBALS['wp_object_cache']->delete('myfeeds_running_list', 'options');
                $running = get_option('myfeeds_running_list', array());
                if (!empty($running)) {
                    if (in_array($rule_unique_id, $running)) {
                        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                            myfeeds_log_to_file('Only one instance of this rule is allowed. Rule is already running!');
                        }
                        return 'nochange';
                    }
                }
                $key = time();
                if(!isset($running[$key]))
                {
                    $running[$key] = $rule_unique_id;
                }
                else
                {
                    $running[$key + 1] = $rule_unique_id;
                }
                update_option('myfeeds_running_list', $running, false);
                register_shutdown_function('myfeeds_clear_flag_at_shutdown', $rule_unique_id);
            }
            if($max_paged_depth === '')
            {
                $max_paged_depth = 3;
            }
            if (isset($myfeeds_Main_Settings['cat_separator']) && $myfeeds_Main_Settings['cat_separator'] !== '') {
                if($cat_sep == '')
                {
                    $cat_sep = $myfeeds_Main_Settings['cat_separator'];
                }
            }
            else
            {
                if($cat_sep == '')
                {
                    $cat_sep = ',';
                }
            }
            if($crawl_exclude != '')
            {
                $crawl_exclude = preg_split('/\r\n|\r|\n/', $crawl_exclude);
                $crawl_exclude = array_map('trim', $crawl_exclude);
            }
            else
            {
                $crawl_exclude = array();
            }
            if($crawl_title_exclude != '')
            {
                $crawl_title_exclude = preg_split('/\r\n|\r|\n/', $crawl_title_exclude);
                $crawl_title_exclude = array_map('trim', $crawl_title_exclude);
            }
            else
            {
                $crawl_title_exclude = array();
            }
            $ids = myfeeds_replaceSynergyShortcodes($ids);
            if(substr($ids, 0, 2) === "//")
            {
                $ids = 'http:' . $ids;
            }
            if($max_results != '')
            {
                $maximum_crawl = $max_results;
            }
            else
            {
                $maximum_crawl = $max;
            }
            if (isset($myfeeds_Main_Settings['price_sep']))
            {
                $price_sep = $myfeeds_Main_Settings['price_sep'];
            }
            else
            {
                $price_sep = '.';
            }
            $GLOBALS['wp_object_cache']->delete('myfeeds_continue_search', 'options');
            $skip_posts_temp = get_option('myfeeds_continue_search', array());
            preg_match_all('{%%counter_(\d+)_(\d+)_(\d+)%%}', $ids, $counter_matches);
            if (!empty($counter_matches[3])) {
                $run_counter = $counter_matches[1][0];
                do
                {
                    $items_xtemp = array();
                    $new_ids = preg_replace('{%%counter_(\d+)_(\d+)_(\d+)%%}', $run_counter, $ids);
                    $GLOBALS['crawl_done'] = false;
                    $GLOBALS['seed'] = true;
                    $items_xtemp = myfeeds_crawl_page($new_ids, $maximum_crawl, $skip_og, $skip_post_content, $no_external, $required_words, $banned_words, $type, $expre, $title_type, $title_expre, $image_type, $image_expre, $date_type, $date_expre, $cat_type, $cat_expre, intval($max_depth), $custom_cookies, $only_class, $only_id, $no_source, $seed_type, $seed_expre, $crawled_type, $crawled_expre, $paged_crawl_str, $paged_crawl_type, $max_paged_depth, $custom_user_agent, $cat_sep, true, $seed_pag_type, $seed_pag_expre, true, $use_proxy, $use_phantom, $user_pass, $crawl_exclude, $crawl_title_exclude, $price_sep, $encoding, $reverse_crawl, $lazy_tag, $phantom_wait, $param, $continue_search, $strip_links, $royalty_free, $strip_by_id, $strip_by_class, $strip_by_xpath, $strip_by_tag, $only_text, $allow_html_tags, $content_percent, $replace_words, $strip_images, $limit_word_count, $read_more, $strip_by_regex, $strip_by_regex_title, $keep_source, $post_content, $post_title, $translate, $source_lang, $default_category, $remove_cats, $author_type, $author_expre, $custom_crawling_expre, $custom_tag_expre, $url_type, $url_expre, $feed_title, $feed_description, $regex_image, $replace_regex, $replace_regex_title, $skip_no_match, $no_link_scraper, $image_url);
                    if($items_xtemp === false || !is_array($items_xtemp))
                    {
                        myfeeds_log_to_file('Failed to get source web page (%%counter_' . $counter_matches[1][0] . '_' . $counter_matches[2][0] . '_' . $counter_matches[3][0] . ')! ' . print_r($items_xtemp, true));
                    }
                    else
                    {
                        $items = array_merge($items, $items_xtemp);
                    }
                    $run_counter += $counter_matches[3][0];
                }
                while(count($items) < $max && $run_counter <= $counter_matches[2][0]);
            }
            else
            {
                $GLOBALS['crawl_done'] = false;
                $GLOBALS['seed'] = true;
                if($continue_search == '1')
                {
                    if(isset($skip_posts_temp[$param]))
                    {
                        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                            myfeeds_log_to_file('Loading URL from saved data (continue crawling) (rule ID ' . $param . '): ' . $skip_posts_temp[$param] . '!');
                        }
                        $ids = $skip_posts_temp[$param];
                    }
                }
                else
                {
                    if(isset($skip_posts_temp[$param]))
                    {
                        unset($skip_posts_temp[$param]);
                        update_option('myfeeds_continue_search', $skip_posts_temp);
                    }
                }
                $items = myfeeds_crawl_page($ids, $maximum_crawl, $skip_og, $skip_post_content, $no_external, $required_words, $banned_words, $type, $expre, $title_type, $title_expre, $image_type, $image_expre, $date_type, $date_expre, $cat_type, $cat_expre, intval($max_depth), $custom_cookies, $only_class, $only_id, $no_source, $seed_type, $seed_expre, $crawled_type, $crawled_expre, $paged_crawl_str, $paged_crawl_type, $max_paged_depth, $custom_user_agent, $cat_sep, true, $seed_pag_type, $seed_pag_expre, true, $use_proxy, $use_phantom, $user_pass, $crawl_exclude, $crawl_title_exclude, $price_sep, $encoding, $reverse_crawl, $lazy_tag, $phantom_wait, $param, $continue_search, $strip_links, $royalty_free, $strip_by_id, $strip_by_class, $strip_by_xpath, $strip_by_tag, $only_text, $allow_html_tags, $content_percent, $replace_words, $strip_images, $limit_word_count, $read_more, $strip_by_regex, $strip_by_regex_title, $keep_source, $post_content, $post_title, $translate, $source_lang, $default_category, $remove_cats, $author_type, $author_expre, $custom_crawling_expre, $custom_tag_expre, $url_type, $url_expre, $feed_title, $feed_description, $regex_image, $replace_regex, $replace_regex_title, $skip_no_match, $no_link_scraper, $image_url);
                if($items === false || !is_array($items))
                {
                    myfeeds_log_to_file('Failed to get source web page, importing will not run! ' . print_r($items, true));
                    if($continue_search == '1' && isset($skip_posts_temp[$param]))
                    {
                        unset($skip_posts_temp[$param]);
                        update_option('myfeeds_continue_search', $skip_posts_temp);
                    }
                    return 'fail';
                }
            }
            $posts_inserted = count($items);
            if($posts_inserted == 0)
            {
                myfeeds_log_to_file('The query you defined returned no results. Please check it. Rule ID: ' . esc_html($param));
                if($continue_search == '1' && isset($skip_posts_temp[$param]))
                {
                    unset($skip_posts_temp[$param]);
                    update_option('myfeeds_continue_search', $skip_posts_temp);
                }
                return 'nochange';
            }
            $init_date = time();
            $skip_pcount = 0;
            $skipped_pcount = 0;
            if($ret_content == 1)
            {
                $item_xcounter = count($items);
                $skip_pcount = rand(0, $item_xcounter-1);
            }
            
            if ( ! function_exists( 'get_page_by_title' ) ) {
                include_once( ABSPATH . 'wp-includes/post.php' );
            }
            $existing = get_page_by_title(html_entity_decode($feed_id), OBJECT, 'myfeeds_feed');
            if($existing === null)
            {
                $za_cnt = json_encode($items, JSON_PRETTY_PRINT);
                $my_post = array();
                $my_post['post_title'] = $feed_id;
                $my_post['post_content'] = wp_slash($za_cnt);
                $my_post['post_type'] = 'myfeeds_feed';
                $my_post['post_status'] = 'publish';
                remove_filter('content_save_pre', 'wp_filter_post_kses');
                remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');remove_filter('title_save_pre', 'wp_filter_kses');
                $campaign_idx = wp_insert_post($my_post, true);
                add_filter('content_save_pre', 'wp_filter_post_kses');
                add_filter('content_filtered_save_pre', 'wp_filter_post_kses');add_filter('title_save_pre', 'wp_filter_kses');
                if (!is_wp_error($campaign_idx)) {
                    $za_new_id = $campaign_idx;
                    $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
                    $rules = get_option('myfeeds_rules_list');
                    $rules[$param][7] = '1';
                    update_option('myfeeds_rules_list', $rules, false);
                }
                else
                {
                    myfeeds_log_to_file('Failed to insert submitted data into database: ' . $campaign_idx->get_error_message());
                    return 'fail';
                }
            }
            else
            {
                $za_cnt = json_encode($items, JSON_PRETTY_PRINT);
                $my_post = array();
                $my_post['post_content'] = wp_slash($za_cnt);
                $my_post['post_type'] = 'myfeeds_feed';
                $my_post['ID'] = $existing->ID;
                remove_filter('content_save_pre', 'wp_filter_post_kses');
                remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');remove_filter('title_save_pre', 'wp_filter_kses');
                $campaign_idx = wp_update_post($my_post, true);
                add_filter('content_save_pre', 'wp_filter_post_kses');
                add_filter('content_filtered_save_pre', 'wp_filter_post_kses');add_filter('title_save_pre', 'wp_filter_kses');
                if (!is_wp_error($campaign_idx)) {
                    $za_new_id = $campaign_idx;
                    if($feed_generated != '1')
                    {
                        $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
                        $rules = get_option('myfeeds_rules_list');
                        $rules[$param][7] = '1';
                        update_option('myfeeds_rules_list', $rules, false);
                    }
                }
                else
                {
                    myfeeds_log_to_file('Failed to update submitted data into database: ' . $campaign_idx->get_error_message());
                    return 'fail';
                }
            }
        }
        catch (Exception $e) {
            if($continue_search == '1' && isset($skip_posts_temp[$param]))
            {
                unset($skip_posts_temp[$param]);
                update_option('myfeeds_continue_search', $skip_posts_temp);
            }
            myfeeds_log_to_file('Exception thrown ' . esc_html($e->getMessage()) . '!');
            if($auto == 1)
            {
                myfeeds_clearFromList($param);
            }
            return 'fail';
        }
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Rule ID ' . esc_html($param) . ' for ' . $ids . ' successfully run! ' . esc_html($posts_inserted) . ' items added to the RSS feed: ' . esc_url(get_bloginfo('url') . '/?feed=' . esc_html($post_status)));
        }
        if (isset($myfeeds_Main_Settings['send_email']) && $myfeeds_Main_Settings['send_email'] == 'on' && $myfeeds_Main_Settings['email_address'] !== '') {
            if (isset($myfeeds_Main_Settings['email_summary']) && $myfeeds_Main_Settings['email_summary'] == 'on') 
            {
                $last_sent  = get_option('myfeeds_last_sent_email', false);
                if($last_sent == false)
                {
                    $last_sent = date("d.m.y");
                    update_option('myfeeds_last_sent_email', $last_sent);
                }
                $email_content  = get_option('myfeeds_email_content', '');
                $email_content .= '<br/>Rule ID ' . esc_html($param) . ' for ' . $ids . ' successfully run! ' . esc_html($posts_inserted) . ' items added to the RSS feed: ' . esc_url(get_bloginfo('url') . '/?feed=' . esc_html($post_status));
                if($last_sent != date("d.m.y"))
                {
                    update_option('myfeeds_last_sent_email', date("d.m.y"));
                    update_option('myfeeds_email_content', '');
                    try {
                        $to        = $myfeeds_Main_Settings['email_address'];
                        if (!filter_var($to, FILTER_VALIDATE_EMAIL) === false)
                        {
                            $subject   = '[Custom Curated RSS Feeds - RSS From Any Site] Rule running report - ' . myfeeds_get_date_now();
                            $message   = 'Rule ID ' . esc_html($param) . ' for ' . $ids . ' successfully run! ' . esc_html($posts_inserted) . ' items added to the RSS feed: ' . esc_url(get_bloginfo('url') . '/?feed=' . esc_html($post_status));
                            $headers[] = 'From: Custom Curated RSS Feeds - RSS From Any Site Plugin <echo@noreply.net>';
                            $headers[] = 'Reply-To: noreply@echo.com';
                            $headers[] = 'X-Mailer: PHP/' . phpversion();
                            $headers[] = 'Content-Type: text/html';
                            $headers[] = 'Charset: ' . get_option('blog_charset', 'UTF-8');
                            wp_mail($to, $subject, $message, $headers);
                        }
                    }
                    catch (Exception $e) {
                        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                            myfeeds_log_to_file('Failed to send mail: Exception thrown ' . esc_html($e->getMessage()) . '!');
                        }
                    }
                }
                else
                {
                    update_option('myfeeds_email_content', $email_content);
                }
            }
            else
            {
                $getdatex = get_option('myfeeds_last_sent_email', false);
                if($getdatex != false)
                {
                    update_option('myfeeds_last_sent_email', false);
                }
                $getdatex = get_option('myfeeds_email_content', false);
                if($getdatex != false)
                {
                    update_option('myfeeds_email_content', false);
                }
                try {
                    $to        = $myfeeds_Main_Settings['email_address'];
                    if (!filter_var($to, FILTER_VALIDATE_EMAIL) === false)
                    {
                        $subject   = '[Custom Curated RSS Feeds - RSS From Any Site] Rule running report - ' . myfeeds_get_date_now();
                        $message   = 'Rule ID ' . esc_html($param) . ' for ' . $ids . ' successfully run! ' . esc_html($posts_inserted) . ' items added to the RSS feed: ' . esc_url(get_bloginfo('url') . '/?feed=' . esc_html($post_status));
                        $headers[] = 'From: Custom Curated RSS Feeds - RSS From Any Site Plugin <echo@noreply.net>';
                        $headers[] = 'Reply-To: noreply@echo.com';
                        $headers[] = 'X-Mailer: PHP/' . phpversion();
                        $headers[] = 'Content-Type: text/html';
                        $headers[] = 'Charset: ' . get_option('blog_charset', 'UTF-8');
                        wp_mail($to, $subject, $message, $headers);
                    }
                }
                catch (Exception $e) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Failed to send mail: Exception thrown ' . esc_html($e->getMessage()) . '!');
                    }
                }
            }
        }
    }
    if ($posts_inserted == 0) {
        if($auto == 1)
        {
            myfeeds_clearFromList($param);
        }
        return 'nochange';
    } else {
        if($auto == 1)
        {
            myfeeds_clearFromList($param);
        }
        return 'ok';
    }
}

function myfeeds_stringMatchWithWildcard($source, $pattern) {
    $pattern = preg_quote($pattern,'/');        
    $pattern = str_replace( '\*' , '.*', $pattern);   
    return preg_match( '~' . $pattern . '~i' , $source );
}

function myfeeds_add_link_tags($content) {
    $content = preg_replace_callback('~<(a\s[^>]+)>~isU', "myfeeds_link_callback", preg_quote($content));
    return $content;
}

function myfeeds_link_callback($match) { 
    list($original, $tag) = $match;
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $blog_url = get_home_url();
    $disallowed = array('http://', 'https://', 'www.');
    foreach($disallowed as $d) {
       $blog_url = str_replace($d, '', $blog_url);
    }
    if (stripos($tag, $blog_url) !== false) {
        if (isset($myfeeds_Main_Settings['link_attributes_internal']) && $myfeeds_Main_Settings['link_attributes_internal'] != '') {
            return "<$tag " . $myfeeds_Main_Settings['link_attributes_internal'] . ">";
        }
    }
    else {
        if (isset($myfeeds_Main_Settings['link_attributes_external']) && $myfeeds_Main_Settings['link_attributes_external'] != '') {
            return "<$tag " . $myfeeds_Main_Settings['link_attributes_external'] . ">";
        }
    }
    return $original;
}

$myfeeds_fatal = false;
function myfeeds_clear_flag_at_shutdown($param)
{
    $error = error_get_last();
    if ($error !== null && $error['type'] === E_ERROR && $GLOBALS['myfeeds_fatal'] === false) {
        $GLOBALS['myfeeds_fatal'] = true;
        $running = array();
        update_option('myfeeds_running_list', $running);
        myfeeds_log_to_file('[FATAL] Exit error: ' . $error['message'] . ', file: ' . $error['file'] . ', line: ' . $error['line'] . ' - rule ID: ' . $param . '!');
        myfeeds_clearFromList($param);
    }
    else
    {
        myfeeds_clearFromList($param);
    }
}

function myfeeds_strip_images($content)
{
    $content = preg_replace("/<img[^>]+\>/i", "", $content); 
    return $content;
}
function myfeeds_get_url_domain($url) {
    $result = parse_url($url);
    if($result === false)
    {
        return $url;
    }
    return $result['scheme']."://".$result['host'];
}
function myfeeds_strip_links($content)
{
    $content = preg_replace('~<a(?:[^>]*)>~', "", $content);
    $content = preg_replace('~<\/a>~', "", $content);
    return $content;
}
function myfeeds_strip_external_links($content, $url)
{
    $parse = parse_url($url);
    if(isset($parse['host']) && $parse['host'] != '')
    {
        $content = preg_replace('#<a(?:[^>]*)href=[\'"]http.?:\/\/' . preg_quote($parse['host']) . '[^\'"]*?[\'"](?:[^>]*)>(.*?)<\/a>#', "\\1", $content);
    }
    return $content;
}

function myfeeds_generate_featured_image($image_url, $post_id, $use_proxy)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $upload_dir = wp_upload_dir();
    
    if(substr( $image_url, 0, 10 ) === "data:image")
    {
        $data = explode(',', $image_url);
        if(isset($data[1]))
        {
            $image_data = base64_decode($data[1]);
            if($image_data === FALSE)
            {
                return false;
            }
        }
        else
        {
            return false;
        }
        preg_match('{data:image/(.*?);}', $image_url ,$ex_matches);
        if(isset($ex_matches[1]))
        {
            $image_url = 'image.' . $ex_matches[1];
        }
        else
        {
            $image_url = 'image.jpg';
        }
    }
    else
    {
        $image_data = myfeeds_get_web_page(html_entity_decode($image_url), '', '', $use_proxy, '');
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $filename = explode("?", $filename);
    $filename = $filename[0];
    $filename = urlencode($filename);
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $file_parts = pathinfo($filename);
    if(isset($file_parts['extension']))
    {
        switch($file_parts['extension'])
        {
            case "":
            $filename .= '.jpg';
            break;
            case NULL:
            $filename .= '.jpg';
            break;
        }
    }
    else
    {
        $filename .= '.jpg';
    }
    $filename = stripslashes(preg_replace_callback('#(%[a-zA-Z0-9_]*)#', function($matches){ return rand(0, 9); }, preg_quote($filename)));
    $filename = sanitize_file_name($filename);
    if (wp_mkdir_p($upload_dir['path']))
        $file = $upload_dir['path'] . '/' . $post_id . '-' . $filename;
    else
        $file = $upload_dir['basedir'] . '/' . $post_id . '-' . $filename;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $ret = $wp_filesystem->put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    $wp_filetype = wp_check_filetype($filename, null);
    if($wp_filetype['type'] == '')
    {
        $wp_filetype['type'] = 'image/png';
    }
    $attachment  = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($filename),
        'post_content' => '',
        'post_status' => 'inherit'
    );
    $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
    if ($attach_id === 0) {
        return false;
    }
    require_once(ABSPATH . 'wp-admin/includes/image.php');
    require_once(ABSPATH . 'wp-admin/includes/media.php');
    $attach_data = wp_generate_attachment_metadata($attach_id, $file);
    wp_update_attachment_metadata($attach_id, $attach_data);
    $res2 = set_post_thumbnail($post_id, $attach_id);
    if ($res2 === FALSE) {
        return false;
    }
    $post_title = get_the_title($post_id);
    if($post_title != '')
    {
        update_post_meta($attach_id, '_wp_attachment_image_alt', $post_title);
    }
    return true;
}

function myfeeds_copy_image_locally($image_url, $use_proxy)
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $upload_dir = wp_upload_dir();
    if(substr( $image_url, 0, 10 ) === "data:image")
    {
        $data = explode(',', $image_url);
        if(isset($data[1]))
        {
            $image_data = base64_decode($data[1]);
            if($image_data === FALSE)
            {
                return false;
            }
        }
        else
        {
            return false;
        }
        preg_match('{data:image/(.*?);}', $image_url ,$ex_matches);
        if(isset($ex_matches[1]))
        {
            $image_url = 'image.' . $ex_matches[1];
        }
        else
        {
            $image_url = 'image.jpg';
        }
    }
    else
    {
        $image_data = myfeeds_get_web_page(html_entity_decode($image_url), '', '', $use_proxy, '');
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $filename = explode("?", $filename);
    $filename = $filename[0];
    $filename = urlencode($filename);
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $file_parts = pathinfo($filename);
    switch($file_parts['extension'])
    {
        case "":
        $filename .= 'jpg';
        break;
        case NULL:
        $filename .= '.jpg';
        break;
    }
    if (wp_mkdir_p($upload_dir['path'] . '/localimages'))
    {
        $file = $upload_dir['path'] . '/localimages/' . $filename;
        $ret_path = $upload_dir['url'] . '/localimages/' . $filename;
    }
    else
    {
        $file = $upload_dir['basedir'] . '/' . $filename;
        $ret_path = $upload_dir['baseurl'] . '/' . $filename;
    }
    if($wp_filesystem->exists($file))
    {
        if(empty($file_parts['extension']))
        {
            $file_parts['extension'] = 'jpg';
        }
        $unid = uniqid();
        $file .= $unid . '.' . $file_parts['extension'];
        $ret_path .= $unid . '.' . $file_parts['extension'];
    }
    
    $ret = $wp_filesystem->put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    $wp_filetype = wp_check_filetype( $file, null );
    $attachment = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name( $file ),
        'post_content' => '',
        'post_status' => 'inherit'
    );
    $screens_attach_id = wp_insert_attachment( $attachment, $file );
    require_once( ABSPATH . 'wp-admin/includes/image.php' );
    require_once( ABSPATH . 'wp-admin/includes/media.php' );
    $attach_data = wp_generate_attachment_metadata( $screens_attach_id, $file );
    wp_update_attachment_metadata( $screens_attach_id, $attach_data );
    return $ret_path;
}

function myfeeds_url_is_image( $url ) {
    $url = str_replace(' ', '%20', $url);
    if ( ! filter_var( $url, FILTER_VALIDATE_URL ) ) {
        return FALSE;
    }
    $ext = array( 'jpeg', 'jpg', 'gif', 'png', 'jpe', 'tif', 'tiff', 'svg', 'ico' , 'webp', 'dds', 'heic', 'psd', 'pspimage', 'tga', 'thm', 'yuv', 'ai', 'eps', 'php');
    $info = (array) pathinfo( parse_url( $url, PHP_URL_PATH ) );
    if(!isset( $info['extension'] ))
    {
        return true;
    }
    return isset( $info['extension'] )
        && in_array( strtolower( $info['extension'] ), $ext, TRUE );
}


function myfeeds_preg_grep_keys( $pattern, $input, $flags = 0 )
{
    if(!is_array($input))
    {
        return array();
    }
    $keys = preg_grep( $pattern, array_keys( $input ), $flags );
    $vals = array();
    foreach ( $keys as $key )
    {
        $vals[$key] = $input[$key];
    }
    return $vals;
}

function myfeeds_hour_diff($date1, $date2)
{
    $date1 = new DateTime($date1, myfeeds_get_blog_timezone());
    $date2 = new DateTime($date2, myfeeds_get_blog_timezone());
    
    $number1 = (int) $date1->format('U');
    $number2 = (int) $date2->format('U');
    return ($number1 - $number2) / 60;
}

function myfeeds_add_hour($date, $hour)
{
    $date1 = new DateTime($date, myfeeds_get_blog_timezone());
    $date1->modify("$hour hours");
    $date1 = (array)$date1;
    foreach ($date1 as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return $date;
}

function myfeeds_minute_diff($date1, $date2)
{
    $date1 = new DateTime($date1, myfeeds_get_blog_timezone());
    $date2 = new DateTime($date2, myfeeds_get_blog_timezone());
    
    $number1 = (int) $date1->format('U');
    $number2 = (int) $date2->format('U');
    return ($number1 - $number2);
}

function myfeeds_add_minute($date, $minute)
{
    $date1 = new DateTime($date, myfeeds_get_blog_timezone());
    $date1->modify("$minute minutes");
    $date1 = (array)$date1;
    foreach ($date1 as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return $date;
}

function myfeeds_wp_custom_css_files($src, $cont)
{
    wp_enqueue_style('myfeeds-thumbnail-css-' . $cont, $src, __FILE__);
}

function myfeeds_get_date_now($param = 'now')
{
    $date = new DateTime($param, myfeeds_get_blog_timezone());
    $date = (array)$date;
    foreach ($date as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return '';
}

function myfeeds_removeTagByClass(string $html, string $className) 
{
    if($html == '')
    {
        return '';
    }
    $dom = new \DOMDocument();
    $internalErrors = libxml_use_internal_errors(true);
    $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html);
    libxml_use_internal_errors($internalErrors);
    $finder = new \DOMXPath($dom);
    $nodes = $finder->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' {$className} ')]");
    foreach ($nodes as $node) {
        $node->parentNode->removeChild($node);
    }
    return $dom->saveHTML();
}
function myfeeds_removeTagByID(string $html, string $className) 
{
    if($html == '')
    {
        return '';
    }
    $dom = new \DOMDocument();
    $internalErrors = libxml_use_internal_errors(true);
    $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html);
    libxml_use_internal_errors($internalErrors);
    $finder = new \DOMXPath($dom);
    $nodes = $finder->query('//*[@id="' . trim($className) . '"]');
    foreach ($nodes as $node) {
        $node->parentNode->removeChild($node);
    }
    return $dom->saveHTML();
}
function myfeeds_removeTagByXPath(string $html, string $className) 
{
    if($html == '')
    {
        return '';
    }
    $dom = new \DOMDocument();
    $internalErrors = libxml_use_internal_errors(true);
    $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html);
    libxml_use_internal_errors($internalErrors);
    $finder = new \DOMXPath($dom);
    $nodes = $finder->query(trim($className));
    foreach ($nodes as $node) {
        $node->parentNode->removeChild($node);
    }
    return $dom->saveHTML();
}
function myfeeds_removeTagByTag(string $html, string $className) 
{
    if($html == '')
    {
        return '';
    }
    $dom = new \DOMDocument();
    $internalErrors = libxml_use_internal_errors(true);
    $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html);
    libxml_use_internal_errors($internalErrors);
    $finder = new \DOMXPath($dom);
    $nodes = $finder->query("//" . trim($className));
    foreach ($nodes as $node) {
        $node->parentNode->removeChild($node);
    }
    return $dom->saveHTML();
}
function myfeeds_getExcerpt($the_content)
{
    $preview = myfeeds_strip_html_tags($the_content);
    $preview = myfeeds_wp_trim_words($preview, 55, '');
    $preview = trim($preview, ',');
    return $preview;
}

function myfeeds_getPlainContent($the_content)
{
    $preview = myfeeds_strip_html_tags($the_content);
    $preview = myfeeds_wp_trim_words($preview, 999999);
    return $preview;
}
function myfeeds_getItemImage($img, $just_title)
{
    if($img == '')
    {
        return '';
    }
    $preview = '<img src="' . esc_url($img) . '" alt="' . esc_html($just_title) . '" />';
    return $preview;
}

function myfeeds_getReadMoreButton($url, $read_more)
{
    $link = '';
    if($read_more == ' '){
        return '';
    }
    if (isset($url)) {
        $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
        if($read_more == '')
        {
            if (isset($myfeeds_Main_Settings['read_more_text']) && $myfeeds_Main_Settings['read_more_text'] != '') {
                $read_more = $myfeeds_Main_Settings['read_more_text'];
            }
            else
            {
                $read_more = esc_html__('Read More', 'rss-feed-from-any-site');
            }
        }
        $link = '<a rel="nofollow noopener" href="' . $url . '" class="button purchase" target="_blank">' . esc_html($read_more) . '</a>';
    }
    return $link;
}

function myfeeds_testPhantom()
{
    if(!function_exists('shell' . '_exec')) {
        return -1;
    }
    $disabled = explode(',', ini_get('disable_functions'));
    if(in_array('shell' . '_exec', $disabled))
    {
        return -2;
    }
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['phantom_path']) && $myfeeds_Main_Settings['phantom_path'] != '') 
    {
        $phantomjs_comm = $myfeeds_Main_Settings['phantom_path'] . ' ';
    }
    else
    {
        $phantomjs_comm = 'phantomjs ';
    }
    $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
    $cmdResult = $shefunc($phantomjs_comm . '-h 2>&1');
    if(stristr($cmdResult, 'Usage') !== false)
    {
        return 1;
    }
    return 0;
}

function myfeeds_get_page_Puppeteer($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if(!function_exists('shell' . '_exec')) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('shel' . 'l_exec not found!');
        }
        return false;
    }
    $disabled = explode(',', ini_get('disable_functions'));
    if(in_array('shell' . '_exec', $disabled))
    {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('shel' . 'l_exec disabled');
        }
        return false;
    }
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    if($custom_user_agent == '')
    {
        $custom_user_agent = 'default';
    }
    if (isset($myfeeds_Main_Settings['phantom_timeout']) && $myfeeds_Main_Settings['phantom_timeout'] != '') 
    {
        $phantomjs_timeout = ((int)$myfeeds_Main_Settings['phantom_timeout']);
    }
    else
    {
        $phantomjs_timeout = '15000';
    }
    if($custom_cookies == '')
    {
        $custom_cookies = 'default';
    }
    if($user_pass == '')
    {
        $user_pass = 'default';
    }
    $phantomjs_proxcomm = '"null"';
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') 
    {
        $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
        $randomness = array_rand($prx);
        $phantomjs_proxcomm = '"' . trim($prx[$randomness]);
        if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
        {
            $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
            if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
            {
                $phantomjs_proxcomm .= '~~~' . trim($prx_auth[$randomness]);
            }
        }
        $phantomjs_proxcomm .= '"';
    }
    
    $puppeteer_comm = 'node ';
    $puppeteer_comm .= '"' . dirname(__FILE__) . '/res/puppeteer/puppeteer.js" "' . $url . '" ' . $phantomjs_proxcomm . '  "' . $custom_user_agent . '" "' . $custom_cookies . '" "' . $user_pass . '" "' . $phantomjs_timeout . '" "' . $phantom_wait .'"';
    $puppeteer_comm .= ' 2>&1';
    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
        myfeeds_log_to_file('Puppeteer command: ' . $puppeteer_comm);
    }
    $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
    $cmdResult = $shefunc($puppeteer_comm);
    if($cmdResult === NULL || $cmdResult == '')
    {
        myfeeds_log_to_file('puppeteer did not return usable info for: ' . $url);
        return false;
    }
    if(trim($cmdResult) === 'timeout')
    {
        myfeeds_log_to_file('puppeteer timed out while getting page: ' . $url. ' - please increase timeout in Main Settings');
        return false;
    }
    if(stristr($cmdResult, 'sh: puppeteer: command not found') !== false)
    {
        myfeeds_log_to_file('puppeteer not found, please install it on your server');
        return false;
    }
    if(stristr($cmdResult, 'sh: node: command not found') !== false || stristr($cmdResult, 'throw err;') !== false)
    {
        myfeeds_log_to_file('nodeJS not found, please install it on your server');
        return false;
    }
    if(stristr($cmdResult, 'res/puppeteer/puppeteer.js:') !== false)
    {
        myfeeds_log_to_file('puppeteer failed to run, error: ' . $cmdResult);
        return false;
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    return $cmdResult;
}
function myfeeds_get_page_PhantomJS($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait)
{
    if(!function_exists('shell' . '_exec')) {
        return false;
    }
    $disabled = explode(',', ini_get('disable_functions'));
    if(in_array('shell' . '_exec', $disabled))
    {
        return false;
    }
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    if (isset($myfeeds_Main_Settings['phantom_path']) && $myfeeds_Main_Settings['phantom_path'] != '') 
    {
        $phantomjs_comm = $myfeeds_Main_Settings['phantom_path'];
    }
    else
    {
        $phantomjs_comm = 'phantomjs';
    }
    if (isset($myfeeds_Main_Settings['phantom_timeout']) && $myfeeds_Main_Settings['phantom_timeout'] != '') 
    {
        $phantomjs_timeout = ((int)$myfeeds_Main_Settings['phantom_timeout']);
    }
    else
    {
        $phantomjs_timeout = '15000';
    }
    if($custom_user_agent == '')
    {
        $custom_user_agent = 'default';
    }
    if($custom_cookies == '')
    {
        $custom_cookies = 'default';
    }
    if($user_pass == '')
    {
        $user_pass = 'default';
    }
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') 
    {
        $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
        $randomness = array_rand($prx);
        $phantomjs_comm .= ' --proxy=' . trim($prx[$randomness]);
        if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
        {
            $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
            if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
            {
                $phantomjs_comm .= ' --proxy-auth=' . trim($prx_auth[$randomness]);
            }
        }
    }
    $phantomjs_comm .= ' --ignore-ssl-errors=true ';
    $phantomjs_comm .= '"' . dirname(__FILE__) . '/res/phantomjs/phantom.js" "' . $url . '" "' . esc_html($phantomjs_timeout) . '" "' . $custom_user_agent . '" "' . $custom_cookies . '" "' . $user_pass . '" "' . esc_html($phantom_wait) . '"';
    $phantomjs_comm .= ' 2>&1';
    $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
    $cmdResult = $shefunc($phantomjs_comm);
    if($cmdResult === NULL || $cmdResult == '')
    {
        myfeeds_log_to_file('phantomjs did not return usable info for: ' . $url);
        return false;
    }
    if(trim($cmdResult) === 'timeout')
    {
        myfeeds_log_to_file('phantomjs timed out while getting page: ' . $url. ' - please increase timeout in Main Settings');
        return false;
    }
    if(stristr($cmdResult, 'sh: phantomjs: command not found') !== false)
    {
        myfeeds_log_to_file('phantomjs not found, please install it on your server');
        return false;
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    return $cmdResult;
}

register_activation_hook(__FILE__, 'myfeeds_activation_callback');
function myfeeds_activation_callback($defaults = FALSE)
{
    if (!get_option('myfeeds_posts_per_page') || $defaults === TRUE) {
        if ($defaults === FALSE) {
            add_option('myfeeds_posts_per_page', '12');
        } else {
            update_option('myfeeds_posts_per_page', '12');
        }
    }
    if (!get_option('myfeeds_Main_Settings') || $defaults === TRUE) {
        $myfeeds_Main_Settings = array(
            'myfeeds_enabled' => 'on',
            'force_refresh' => '',
            'alt_read' => '',
            'strip_scripts' => '',
            'strip_html' => '',
            'screenshot_height' => '450',
            'screenshot_width' => '600',
            'skip_no_img' => '',
            'skip_old' => '',
            'skip_year' => '',
            'phantom_path' => '',
            'phantom_timeout' => '',
            'skip_month' => '',
            'skip_day' => '',
            'custom_html2' => '',
            'custom_html' => '',
            'sentence_list' => 'This is one %adjective %noun %sentence_ending
This is another %adjective %noun %sentence_ending
I %love_it %nouns , because they are %adjective %sentence_ending
My %family says this plugin is %adjective %sentence_ending
These %nouns are %adjective %sentence_ending',
            'sentence_list2' => 'Meet this %adjective %noun %sentence_ending
This is the %adjective %noun ever %sentence_ending
I %love_it %nouns , because they are the %adjective %sentence_ending
My %family says this plugin is very %adjective %sentence_ending
These %nouns are quite %adjective %sentence_ending',
            'variable_list' => 'adjective_very => %adjective;very %adjective;

adjective => clever;interesting;smart;huge;astonishing;unbelievable;nice;adorable;beautiful;elegant;fancy;glamorous;magnificent;helpful;awesome

noun_with_adjective => %noun;%adjective %noun

noun => plugin;WordPress plugin;item;ingredient;component;constituent;module;add-on;plug-in;addon;extension

nouns => plugins;WordPress plugins;items;ingredients;components;constituents;modules;add-ons;plug-ins;addons;extensions

love_it => love;adore;like;be mad for;be wild about;be nuts about;be crazy about

family => %adjective %family_members;%family_members

family_members => grandpa;brother;sister;mom;dad;grandma

sentence_ending => .;!;!!',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'refresh_url' => '',
            'enable_detailed_logging' => '',
            'rule_timeout' => '3600',
            'request_timeout' => '10',
            'request_delay' => '',
            'strip_links' => '',
            'strip_content_links' => '',
            'strip_internal_content_links' => '',
            'email_address' => '',
            'email_summary' => '',
            'send_email' => '',
            'best_password' => '',
            'protected_terms' => '',
            'best_user' => '',
            'spin_text' => 'disabled',
            'max_word_content' => '',
            'min_word_content' => '',
            'max_word_title' => '',
            'min_word_title' => '',
            'myfeeds_clear_curl_charset' => '',
            'proxy_url' => '',
            'proxy_auth' => '',
            'disable_backend_content' => '',
            'search_google' => '',
            'read_more_text' => 'Read More',
            'no_local_image' => '',
            'no_title_spin' => '',
            'rule_delay' => '',
            'no_spin' => '',
            'replace_url' => '',
            'link_attributes_external' => '',
            'link_attributes_internal' => '',
            'multi_separator' => ',',
            'shortest_api' => '',
            'iframe_resize_height' => '',
            'iframe_resize_width' => '',
            'skip_image_names' => '',
            'cat_separator' => ',',
            'deepl_auth' => '',
            'deppl_free' => '',
            'google_trans_auth' => '',
            'flickr_order' => 'date-posted-desc',
            'flickr_license' => '-1',
            'flickr_api' => '',
            'scrapeimg_height' => '',
            'attr_text' => 'Photo Credit: <a href="%%image_source_url%%" target="_blank">%%image_source_name%%</a>',
            'scrapeimg_width' => '',
            'scrapeimg_cat' => 'all',
            'scrapeimg_order' => 'any',
            'scrapeimg_orientation' => 'all',
            'imgtype' => 'all',
            'pixabay_api' => '',
            'pexels_api' => '',
            'morguefile_secret' => '',
            'morguefile_api' => '',
            'bimage' => 'on',
            'no_orig' => '',
            'img_order' => 'popular',
            'img_cat' => 'all',
            'img_width' => '',
            'img_mwidth' => '',
            'img_ss' => '',
            'img_editor' => '',
            'img_language' => 'any',
            'pixabay_scrape' => '',
            'unsplash_api' => '',
            'google_images' => '',
            'scrapeimgtype' => 'all'
        );
        if ($defaults === FALSE) {
            add_option('myfeeds_Main_Settings', $myfeeds_Main_Settings);
        } else {
            update_option('myfeeds_Main_Settings', $myfeeds_Main_Settings);
        }
    }
}


function myfeeds_get_free_image($myfeeds_Main_Settings, $query_words, &$img_attr, $res_cnt = 3)
{
    $original_url = '';
    $rand_arr = array();
    if(isset($myfeeds_Main_Settings['pixabay_api']) && $myfeeds_Main_Settings['pixabay_api'] != '')
    {
        $rand_arr[] = 'pixabay';
    }
    if(isset($myfeeds_Main_Settings['flickr_api']) && $myfeeds_Main_Settings['flickr_api'] !== '')
    {
        $rand_arr[] = 'flickr';
    }
    if(isset($myfeeds_Main_Settings['pexels_api']) && $myfeeds_Main_Settings['pexels_api'] !== '')
    {
        $rand_arr[] = 'pexels';
    }
    if(isset($myfeeds_Main_Settings['pixabay_scrape']) && $myfeeds_Main_Settings['pixabay_scrape'] == 'on')
    {
        $rand_arr[] = 'pixabayscrape';
    }
    if(isset($myfeeds_Main_Settings['unsplash_api']) && $myfeeds_Main_Settings['unsplash_api'] == 'on')
    {
        $rand_arr[] = 'unsplash';
    }
    if(isset($myfeeds_Main_Settings['google_images']) && $myfeeds_Main_Settings['google_images'] == 'on')
    {
        $rand_arr[] = 'google';
    }
    $rez = false;
    while(($rez === false || $rez === '') && count($rand_arr) > 0)
    {
        $rand = array_rand($rand_arr);
        if($rand_arr[$rand] == 'pixabay')
        {
            unset($rand_arr[$rand]);
            if(isset($myfeeds_Main_Settings['img_ss']) && $myfeeds_Main_Settings['img_ss'] == 'on')
            {
                $img_ss = '1';
            }
            else
            {
                $img_ss = '0';
            }
            if(isset($myfeeds_Main_Settings['img_editor']) && $myfeeds_Main_Settings['img_editor'] == 'on')
            {
                $img_editor = '1';
            }
            else
            {
                $img_editor = '0';
            }
            $rez = myfeeds_get_pixabay_image($myfeeds_Main_Settings['pixabay_api'], $query_words, $myfeeds_Main_Settings['img_language'], $myfeeds_Main_Settings['imgtype'], $myfeeds_Main_Settings['scrapeimg_orientation'], $myfeeds_Main_Settings['img_order'], $myfeeds_Main_Settings['img_cat'], $myfeeds_Main_Settings['img_mwidth'], $myfeeds_Main_Settings['img_width'], $img_ss, $img_editor, $original_url, $res_cnt);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pixabay', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://pixabay.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'morguefile')
        {
            unset($rand_arr[$rand]);
            $rez = myfeeds_get_morguefile_image($myfeeds_Main_Settings['morguefile_api'], $myfeeds_Main_Settings['morguefile_secret'], $query_words, $original_url);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'MorgueFile', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', 'https://morguefile.com/', $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://morguefile.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'flickr')
        {
            unset($rand_arr[$rand]);
            $rez = myfeeds_get_flickr_image($myfeeds_Main_Settings, $query_words, $original_url, $res_cnt);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Flickr', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://www.flickr.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'pexels')
        {
            unset($rand_arr[$rand]);
            $rez = myfeeds_get_pexels_image($myfeeds_Main_Settings, $query_words, $original_url, $res_cnt);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pexels', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://www.pexels.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'pixabayscrape')
        {
            unset($rand_arr[$rand]);
            $rez = myfeeds_scrape_pixabay_image($myfeeds_Main_Settings, $query_words, $original_url);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Pixabay', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://pixabay.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'unsplash')
        {
            unset($rand_arr[$rand]);
            $rez = myfeeds_scrape_unsplash_image($query_words, $original_url);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Unsplash', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://unsplash.com/', $img_attr);
            }
        }
        elseif($rand_arr[$rand] == 'google')
        {
            unset($rand_arr[$rand]);
            $original_url = 'https://google.com/';
            $rez = myfeeds_get_random_image_google($query_words);
            if($rez !== false && $rez !== '')
            {
                $img_attr = str_replace('%%image_source_name%%', 'Google Images', $img_attr);
                $img_attr = str_replace('%%image_source_url%%', $original_url, $img_attr);
                $img_attr = str_replace('%%image_source_website%%', 'https://google.com/', $img_attr);
            }
        }
        else
        {
            myfeeds_log_to_file('Unrecognized free file source: ' . $rand_arr[$rand]);
            unset($rand_arr[$rand]);
        }
    }
    $img_attr = str_replace('%%image_source_name%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_url%%', '', $img_attr);
    $img_attr = str_replace('%%image_source_website%%', '', $img_attr);
    return $rez;
}
function myfeeds_get_all_redirects($url){
    $redirects = array();
    while ($newurl = myfeeds_get_redirect_url($url)){
        if (in_array($newurl, $redirects)){
            break;
        }
        $redirects[] = $newurl;
        $url = $newurl;
    }
    return $redirects;
}

function myfeeds_get_final_url($url){
    if (strpos($url, 'localhost') !== false)
    {
        return $url;
    }
    $redirects = myfeeds_get_all_redirects($url);
    if (count($redirects)>0){
        return array_pop($redirects);
    } else {
        return $url;
    }
}
function myfeeds_scrape_unsplash_image($query, &$original_url)
{
    $original_url = 'https://unsplash.com/';
    $feed_uri = 'https://source.unsplash.com/1600x900/';
    if($query != '')
    {
        $feed_uri .= '?' . urlencode($query);
    }
    error_reporting(0);
    ini_set('default_socket_timeout', 120);
    $exec = get_headers($feed_uri);
    error_reporting(E_ALL);
    if ($exec === FALSE || !is_array($exec))
    {
        myfeeds_log_to_file('Error while getting api url: ' . $feed_uri);
    }
    $nono = false;
    $locx = false;
    foreach($exec as $ex)
    {
        if(strstr($ex, 'Location:') !== false)
        {
            if(strstr($ex, 'source-404') !== false)
            {
                $nono = true;
            }
            $locx = $ex;
            $locx = preg_replace('/^Location: /', '', $locx);
            break;
        }
    }
    if($nono == true)
    {
        myfeeds_log_to_file('NO image found on Unsplash for query: ' . $query);
        return false;
    }
    else
    {
        if($locx == false)
        {
            myfeeds_log_to_file('Failed to parse response: ' . $feed_uri);
            return false;
        }
        $original_url = $locx;
        return $locx;
    }
}
function myfeeds_generateRandomString($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}
function myfeeds_get_redirect_url($url){
    $url_parts = parse_url($url);
    if (!$url_parts) return false;
    if (!isset($url_parts['host'])) return false;
    if (!isset($url_parts['path'])) $url_parts['path'] = '/';

    $sock = fsockopen($url_parts['host'], (isset($url_parts['port']) ? (int)$url_parts['port'] : 80), $errno, $errstr, 30);
    if (!$sock) return false;

    $request = "HEAD " . $url_parts['path'] . (isset($url_parts['query']) ? '?'.$url_parts['query'] : '') . " HTTP/1.1".PHP_EOL; 
    $request .= 'Host: ' . $url_parts['host'] . PHP_EOL; 
    $request .= "Connection: Close".PHP_EOL.PHP_EOL; 
    fwrite($sock, $request);
    $response = '';
    while(!feof($sock)) $response .= fread($sock, 8192);
    fclose($sock);

    if (preg_match('/^Location: (.+?)$/m', $response, $matches)){
        if ( substr($matches[1], 0, 1) == "/" )
            return $url_parts['scheme'] . "://" . $url_parts['host'] . trim($matches[1]);
        else
            return trim($matches[1]);

    } else {
        return false;
    }
}
function myfeeds_get_pixabay_image($app_id, $query, $lang, $image_type, $orientation, $order, $image_category, $max_width, $min_width, $safe_search, $editors_choice, &$original_url, $get_max = 3)
{
    $original_url = 'https://pixabay.com';
    $featured_image = '';
    $feed_uri = 'https://pixabay.com/api/?key=' . $app_id;
    if($query != '')
    {
        $feed_uri .= '&q=' . urlencode($query);
    }
    $feed_uri .= '&per_page=' . $get_max;
    if($lang != '' && $lang != 'any')
    {
        $feed_uri .= '&lang=' . $lang;
    }
    if($image_type != '')
    {
        $feed_uri .= '&image_type=' . $image_type;
    }
    if($orientation != '')
    {
        $feed_uri .= '&orientation=' . $orientation;
    }
    if($order != '')
    {
        $feed_uri .= '&order=' . $order;
    }
    if($image_category != '')
    {
        $feed_uri .= '&category=' . $image_category;
    }
    if($max_width != '')
    {
        $feed_uri .= '&max_width=' . $max_width;
    }
    if($min_width != '')
    {
        $feed_uri .= '&min_width=' . $min_width;
    }
    if($safe_search == '1')
    {
        $feed_uri .= '&safesearch=true';
    }
    if($editors_choice == '1')
    {
        $feed_uri .= '&editors_choice=true';
    }
    $feed_uri .= '&callback=' . myfeeds_generateRandomString(6);
     
    $exec = myfeeds_get_web_page($feed_uri, '', '', '0', '');
    if ($exec !== FALSE) 
    {
        if (stristr($exec, '"hits"') !== FALSE) 
        {
            $exec = preg_replace('#^[a-zA-Z0-9]*#', '', $exec);
            $exec = trim($exec, '()');
            $json  = json_decode($exec);
            $items = $json->hits;
            if (count($items) != 0) 
            {
                shuffle($items);
                foreach($items as $item)
                {
                    $featured_image = $item->webformatURL;
                    $original_url = $item->pageURL;
                    break;
                }
            }
        }
        else
        {
            myfeeds_log_to_file('Unknow response from api: ' . $feed_uri . ' - resp: ' . $exec);
            return false;
        }
    }
    else
    {
        myfeeds_log_to_file('Error while getting api url: ' . $feed_uri);
        return false;
    }
    return $featured_image;
}
function myfeeds_scrape_pixabay_image($myfeeds_Main_Settings, $query, &$original_url)
{
    $original_url = 'https://pixabay.com';
    $featured_image = '';
    $feed_uri = 'https://pixabay.com/en/photos/';
    if($query != '')
    {
        $feed_uri .= '?q=' . urlencode($query);
    }

    if($myfeeds_Main_Settings['scrapeimgtype'] != 'all')
    {
        $feed_uri .= '&image_type=' . $myfeeds_Main_Settings['scrapeimgtype'];
    }
    if($myfeeds_Main_Settings['scrapeimg_orientation'] != '')
    {
        $feed_uri .= '&orientation=' . $myfeeds_Main_Settings['scrapeimg_orientation'];
    }
    if($myfeeds_Main_Settings['scrapeimg_order'] != '' && $myfeeds_Main_Settings['scrapeimg_order'] != 'any')
    {
        $feed_uri .= '&order=' . $myfeeds_Main_Settings['scrapeimg_order'];
    }
    if($myfeeds_Main_Settings['scrapeimg_cat'] != '')
    {
        $feed_uri .= '&category=' . $myfeeds_Main_Settings['scrapeimg_cat'];
    }
    if($myfeeds_Main_Settings['scrapeimg_height'] != '')
    {
        $feed_uri .= '&min_height=' . $myfeeds_Main_Settings['scrapeimg_height'];
    }
    if($myfeeds_Main_Settings['scrapeimg_width'] != '')
    {
        $feed_uri .= '&min_width=' . $myfeeds_Main_Settings['scrapeimg_width'];
    }
    $exec = myfeeds_get_web_page($feed_uri, '', '', '0', '');
    if ($exec !== FALSE) 
    {
        preg_match_all('/<a href="([^"]+?)".+?(?:data-lazy|src)="([^"]+?\.jpg|png)"/i', $exec, $matches);
        if (!empty($matches[2])) {
            $p = array_combine($matches[1], $matches[2]);
            if(count($p) > 0)
            {
                shuffle($p);
                foreach ($p as $key => $val) {
                    $featured_image = $val;
                    if(!is_numeric($key))
                    {
                        if(substr($key, 0, 4) !== "http")
                        {
                            $key = 'https://pixabay.com' . $key;
                        }
                        $original_url = $key;
                    }
                    else
                    {
                        $original_url = 'https://pixabay.com';
                    }
                    break;
                }
            }
        }
    }
    else
    {
        myfeeds_log_to_file('Error while getting api url: ' . $feed_uri);
        return false;
    }
    return $featured_image;
}
function myfeeds_get_morguefile_image($app_id, $app_secret, $query, &$original_url)
{
    $featured_image = '';
    if(!class_exists('myfeeds_morguefile'))
    {
        require_once (dirname(__FILE__) . "/res/morguefile/mf.api.class.php");
    }
    $query = explode(' ', $query);
    $query = $query[0];
    {
        $mf = new myfeeds_morguefile($app_id, $app_secret);
        $rez = $mf->call('/images/search/sort/page/' . $query);
        if ($rez !== FALSE) 
        {
            $chosen_one = $rez->doc[array_rand($rez->doc)];
            if (isset($chosen_one->file_path_large)) 
            {
                return $chosen_one->file_path_large;
            }
            else
            {
                return false;
            }
        }
        else
        {
            myfeeds_log_to_file('Error while getting api response from morguefile.');
            return false;
        }
    }
    return $featured_image;
}
function myfeeds_get_flickr_image($myfeeds_Main_Settings, $query, &$original_url, $max)
{
    $original_url = 'https://www.flickr.com';
    $featured_image = '';
    $feed_uri = 'https://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=' . $myfeeds_Main_Settings['flickr_api'] . '&media=photos&per_page=' . esc_html($max) . '&format=php_serial&text=' . urlencode($query);
    if(isset($myfeeds_Main_Settings['flickr_license']) && $myfeeds_Main_Settings['flickr_license'] != '-1')
    {
        $feed_uri .= '&license=' . $myfeeds_Main_Settings['flickr_license'];
    }
    if(isset($myfeeds_Main_Settings['flickr_order']) && $myfeeds_Main_Settings['flickr_order'] != '')
    {
        $feed_uri .= '&sort=' . $myfeeds_Main_Settings['flickr_order'];
    }
    $feed_uri .= '&extras=description,license,date_upload,date_taken,owner_name,icon_server,original_format,last_update,geo,tags,machine_tags,o_dims,views,media,path_alias,url_sq,url_t,url_s,url_q,url_m,url_n,url_z,url_c,url_l,url_o';
     
    {
        $ch               = curl_init();
        if ($ch === FALSE) {
            myfeeds_log_to_file('Failed to init curl for flickr!');
            return false;
        }
        if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
            $timeout = intval($myfeeds_Main_Settings['request_timeout']);
        } else {
            $timeout = 10;
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Referer: https://www.flickr.com/'));
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HTTPGET, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_URL, $feed_uri);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $exec = curl_exec($ch);
        curl_close($ch);
        if (stristr($exec, 'photos') === FALSE) {
            myfeeds_log_to_file('Unrecognized Flickr API response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        $items = unserialize ( $exec );
        if(!isset($items['photos']['photo']))
        {
            myfeeds_log_to_file('Failed to find photo node in response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        if(count($items['photos']['photo']) == 0)
        {
            return $featured_image;
        }
        $x = 0;
        shuffle($items['photos']['photo']);
        while($featured_image == '' && isset($items['photos']['photo'][$x]))
        {
            $item = $items['photos']['photo'][$x];
            if(isset($item['url_o']))
            {
                $featured_image = $item['url_o'];
            }
            elseif(isset($item['url_l']))
            {
                $featured_image = $item['url_l'];
            }
            elseif(isset($item['url_c']))
            {
                $featured_image = $item['url_c'];
            }
            elseif(isset($item['url_z']))
            {
                $featured_image = $item['url_z'];
            }
            elseif(isset($item['url_n']))
            {
                $featured_image = $item['url_n'];
            }
            elseif(isset($item['url_m']))
            {
                $featured_image = $item['url_m'];
            }
            elseif(isset($item['url_q']))
            {
                $featured_image = $item['url_q'];
            }
            elseif(isset($item['url_s']))
            {
                $featured_image = $item['url_s'];
            }
            elseif(isset($item['url_t']))
            {
                $featured_image = $item['url_t'];
            }
            elseif(isset($item['url_sq']))
            {
                $featured_image = $item['url_sq'];
            }
            if($featured_image != '')
            {
                $original_url = esc_url('https://www.flickr.com/photos/' . $item['owner'] . '/' . $item['id']);
            }
            $x++;
        }
    }
    return $featured_image;
}
function myfeeds_get_pexels_image($myfeeds_Main_Settings, $query, &$original_url, $max)
{
    $original_url = 'https://pexels.com';
    $featured_image = '';
    $feed_uri = 'https://api.pexels.com/v1/search?query=' . urlencode($query) . '&per_page=' . $max;
     
    {
        $ch               = curl_init();
        if ($ch === FALSE) {
            myfeeds_log_to_file('Failed to init curl for flickr!');
            return false;
        }
        if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
            $timeout = intval($myfeeds_Main_Settings['request_timeout']);
        } else {
            $timeout = 10;
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: ' . $myfeeds_Main_Settings['pexels_api']));
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HTTPGET, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_URL, $feed_uri);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $exec = curl_exec($ch);
        curl_close($ch);
        if (stristr($exec, 'photos') === FALSE) {
            myfeeds_log_to_file('Unrecognized Pexels API response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        $items = json_decode ( $exec, true );
        if(!isset($items['photos']))
        {
            myfeeds_log_to_file('Failed to find photo node in Pexels response: ' . $exec . ' URI: ' . $feed_uri);
            return false;
        }
        if(count($items['photos']) == 0)
        {
            return $featured_image;
        }
        $x = 0;
        shuffle($items['photos']);
        while($featured_image == '' && isset($items['photos'][$x]))
        {
            $item = $items['photos'][$x];
            if(isset($item['src']['large']))
            {
                $featured_image = $item['src']['large'];
            }
            elseif(isset($item['src']['medium']))
            {
                $featured_image = $item['src']['medium'];
            }
            elseif(isset($item['src']['small']))
            {
                $featured_image = $item['src']['small'];
            }
            elseif(isset($item['src']['portrait']))
            {
                $featured_image = $item['src']['portrait'];
            }
            elseif(isset($item['src']['landscape']))
            {
                $featured_image = $item['src']['landscape'];
            }
            elseif(isset($item['src']['original']))
            {
                $featured_image = $item['src']['original'];
            }
            elseif(isset($item['src']['tiny']))
            {
                $featured_image = $item['src']['tiny'];
            }
            if($featured_image != '')
            {
                $original_url = $item['url'];
            }
            $x++;
        }
    }
    return $featured_image;
}


function myfeeds_url_handle($href, $api_key)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://api.shorte.st/v1/data/url");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "urlToShorten=" . trim($href));
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $headers = [
        'public-api-token: ' . $api_key,
        'Content-Type: application/x-www-form-urlencoded'
    ];
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT,10);
    $serverOutput = json_decode(curl_exec($ch), true);
    curl_close($ch);
    if (!isset($serverOutput['shortenedUrl']) || $serverOutput['shortenedUrl'] == '') {
        return $href;
    } else {
        return esc_url($serverOutput['shortenedUrl']);
    }  
}

function myfeeds_spin_text($title, $content, $alt = false)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $titleSeparator = '[19459000]';
    $text           = $title . ' ' . $titleSeparator . ' ' . $content;
    $text           = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        require_once(dirname(__FILE__) . "/res/myfeeds-text-spinner.php");
        $phpTextSpinner = new PhpTextSpinner();
        if ($alt === FALSE) {
            $spinContent = $phpTextSpinner->spinContent($text);
        } else {
            $spinContent = $phpTextSpinner->spinContentAlt($text);
        }
        $translated = $phpTextSpinner->runTextSpinner($spinContent);
    }
    catch (Exception $e) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}


function myfeeds_best_spin_text($title, $content)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['best_user']) || $myfeeds_Main_Settings['best_user'] == '' || !isset($myfeeds_Main_Settings['best_password']) || $myfeeds_Main_Settings['best_password'] == '') {
        myfeeds_log_to_file('Please insert a valid "The Best Spinner" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $newhtml             = $title . ' ' . $titleSeparator . ' ' . $content;
    $url              = 'http://thebestspinner.com/api.php';
    $data             = array();
    $data['action']   = 'authenticate';
    $data['format']   = 'php';
    $data['username'] = $myfeeds_Main_Settings['best_user'];
    $data['password'] = $myfeeds_Main_Settings['best_password'];
    $ch               = curl_init();
    if ($ch === FALSE) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"The Best Spinner" failed to init curl.');
        }
        return FALSE;
    }
    if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
        $timeout = intval($myfeeds_Main_Settings['request_timeout']);
    } else {
        $timeout = 10;
    }
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    $fdata = "";
    foreach ($data as $key => $val) {
        $fdata .= "$key=" . urlencode($val) . "&";
    }
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_REFERER, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    $html = myfeeds_curl_exec_utf8($ch);
    curl_close($ch);
    if ($html === FALSE || empty($html)) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"The Best Spinner" failed to exec curl.');
        }
        return FALSE;
    }
    $output = unserialize($html);
    if ($output['success'] == 'true') {
        $session                = $output['session'];
        $data                   = array();
        $data['session']        = $session;
        $data['format']         = 'php';
        if (isset($myfeeds_Main_Settings['protected_terms']) && $myfeeds_Main_Settings['protected_terms'] != '') 
        {
            $protected_terms = $myfeeds_Main_Settings['protected_terms'];
        }
        else
        {
            $protected_terms = '';
        }
        $data['protectedterms'] = $protected_terms;
        $data['action']         = 'replaceEveryonesFavorites';
        $data['maxsyns']        = '100';
        $data['quality']        = '1';
        $ch = curl_init();
        if ($ch === FALSE) {
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                myfeeds_log_to_file('Failed to init curl');
            }
            return FALSE;
        }
        $newhtml = html_entity_decode($newhtml);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, $url);
        $spinned = '';
        if(str_word_count($newhtml) > 4000)
        {
            while($newhtml != '')
            {
                $first30k = substr($newhtml, 0, 30000);
                $first30k = rtrim($first30k, '(*');
                $first30k = ltrim($first30k, ')*');
                $newhtml = substr($newhtml, 30000);
                $data['text']           = $first30k;
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode($val) . "&";
                }
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                $output = curl_exec($ch);
                if ($output === FALSE) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('"The Best Spinner" failed to exec curl after auth.');
                    }
                    return FALSE;
                }
                $output = unserialize($output);
                if ($output['success'] == 'true') {
                    $spinned .= ' ' . $output['output'];
                } else {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('"The Best Spinner" failed to spin article.');
                    }
                    return FALSE;
                }
            }
        }
        else
        {
            $data['text'] = $newhtml;
            $fdata = "";
            foreach ($data as $key => $val) {
                $fdata .= "$key=" . urlencode($val) . "&";
            }
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
            $output = curl_exec($ch);
            if ($output === FALSE) {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('"The Best Spinner" failed to exec curl after auth.');
                }
                return FALSE;
            }
            $output = unserialize($output);
            if ($output['success'] == 'true') {
                $spinned = $output['output'];
            } else {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('"The Best Spinner" failed to spin article: ' . print_r($output, true));
                }
                return FALSE;
            }
        }
        curl_close($ch);
        $result = explode($titleSeparator, $spinned);
        if (count($result) < 2) {
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                myfeeds_log_to_file('"The Best Spinner" failed to spin article - titleseparator not found.' . print_r($output, true));
            }
            return FALSE;
        }
        $spintax = new myfeeds_Spintax();
        $result[0] = $spintax->process($result[0]);
        $result[1] = $spintax->process($result[1]);
        return $result;

    } else {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"The Best Spinner" authentification failed. ' . print_r($output, true));
        }
        return FALSE;
    }
}

class myfeeds_Spintax
{
    public function process($text)
    {
        return stripslashes(preg_replace_callback(
            '/\{(((?>[^\{\}]+)|(?R))*)\}/x',
            array($this, 'replace'),
            preg_quote($text)
        ));
    }
    public function replace($text)
    {
        $text = $this->process($text[1]);
        $parts = explode('|', $text);
        return $parts[array_rand($parts)];
    }
}
function myfeeds_wordai_spin_text($title, $content)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['best_user']) || $myfeeds_Main_Settings['best_user'] == '' || !isset($myfeeds_Main_Settings['best_password']) || $myfeeds_Main_Settings['best_password'] == '') {
        myfeeds_log_to_file('Please insert a valid "Wordai" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $quality = 'Readable';
    $html             = $title . ' ' . $titleSeparator . ' ' . $content;
    $email = $myfeeds_Main_Settings['best_user'];
    $pass = $myfeeds_Main_Settings['best_password'];
    $html = urlencode($html);
    $ch = curl_init('https://wai.wordai.com/api/rewrite');
    if($ch === false)
    {
        myfeeds_log_to_file('Failed to init curl in wordai spinning.');
        return FALSE;
    }
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_POST, 1);
    curl_setopt ($ch, CURLOPT_POSTFIELDS, "input=$html&uniqueness=2&rewrite_num=1&return_rewrites=true&email=$email&key=$pass");
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 120);
    $result = curl_exec($ch);
    if ($result === FALSE) {
        myfeeds_log_to_file('"Wordai" failed to exec curl after auth: ' . curl_error($ch));
        curl_close ($ch);
        return FALSE;
    }
    curl_close ($ch);
    $result = json_decode($result);
    if(!isset($result->rewrites))
    {
        myfeeds_log_to_file('"Wordai" unrecognized response: ' . print_r($result, true));
        return FALSE;
    }
    $result = explode($titleSeparator, $result->rewrites[0]);
    if (count($result) < 2) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"Wordai" failed to spin article - titleseparator not found.');
        }
        return FALSE;
    }
    return $result;
}
function myfeeds_spinrewriter_spin_text($title, $content)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['best_user']) || $myfeeds_Main_Settings['best_user'] == '' || !isset($myfeeds_Main_Settings['best_password']) || $myfeeds_Main_Settings['best_password'] == '') {
        myfeeds_log_to_file('Please insert a valid "SpinRewriter" user name and password.');
        return FALSE;
    }
    $titleSeparator = '(19459000)';
    $quality = '50';
    $html = $title . ' ' . $titleSeparator . ' ' . $content;
    $html = preg_replace('/\s+/', ' ', $html);
    $data = array();
    $data['email_address'] = $myfeeds_Main_Settings['best_user'];
    $data['api_key'] = $myfeeds_Main_Settings['best_password'];
    $data['action'] = "unique_variation";
    $data['auto_protected_terms'] = "true";					
    $data['confidence_level'] = "high";							
    $data['auto_sentences'] = "true";							
    $data['auto_paragraphs'] = "false";							
    $data['auto_new_paragraphs'] = "false";						
    $data['auto_sentence_trees'] = "false";						
    $data['use_only_synonyms'] = "true";						
    $data['reorder_paragraphs'] = "false";						
    $data['nested_spintax'] = "false";						
    if (isset($myfeeds_Main_Settings['protected_terms']) && $myfeeds_Main_Settings['protected_terms'] != '') 
    {
        $protected_terms = $myfeeds_Main_Settings['protected_terms'];
        $data['protected_terms'] = str_replace(',', '\n', $protected_terms);
    }
    if(str_word_count($html) >= 2500)
    {
        $result = '';
        while($html != '' && $html != ' ')
        {
            $words = explode(" ", $html);
            $first30k = join(" ", array_slice($words, 0, 2500));
            $html = join(" ", array_slice($words, 2500));
            
            $data['text'] = $first30k;	
            $api_response = myfeeds_spinrewriter_api_post($data);
            if ($api_response === FALSE) {
                myfeeds_log_to_file('"SpinRewriter" failed to exec curl after auth.');
                return FALSE;
            }
            $api_response = json_decode($api_response);
            if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
            {
                if(isset($api_response->status) && $api_response->status == 'ERROR')
                {
                    if(isset($api_response->response) && $api_response->response == 'You can only submit entirely new text for analysis once every 7 seconds.')
                    {
                        $api_response = myfeeds_spinrewriter_api_post($data);
                        if ($api_response === FALSE) {
                            myfeeds_log_to_file('"SpinRewriter" failed to exec curl after auth (after resubmit).');
                            return FALSE;
                        }
                        $api_response = json_decode($api_response);
                        if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
                        {
                            myfeeds_log_to_file('"SpinRewriter" failed to wait and resubmit spinning: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                            return FALSE;
                        }
                    }
                    else
                    {
                        myfeeds_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                        return FALSE;
                    }
                }
                else
                {
                    myfeeds_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                    return FALSE;
                }
            }
            $spinned = $api_response->response;
            $result .= ' ' . $spinned;
            if($html != '' && $html != ' ')
            {
                sleep(7);
            }
        }
    }
    else
    {
        $data['text'] = $html;	
        $api_response = myfeeds_spinrewriter_api_post($data);
        if ($api_response === FALSE) {
            myfeeds_log_to_file('"SpinRewriter" failed to exec curl after auth.');
            return FALSE;
        }
        $api_response = json_decode($api_response);
        if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
        {
            if(isset($api_response->status) && $api_response->status == 'ERROR')
            {
                if(isset($api_response->response) && $api_response->response == 'You can only submit entirely new text for analysis once every 7 seconds.')
                {
                    $api_response = myfeeds_spinrewriter_api_post($data);
                    if ($api_response === FALSE) {
                        myfeeds_log_to_file('"SpinRewriter" failed to exec curl after auth (after resubmit).');
                        return FALSE;
                    }
                    $api_response = json_decode($api_response);
                    if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
                    {
                        myfeeds_log_to_file('"SpinRewriter" failed to wait and resubmit spinning: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                        return FALSE;
                    }
                }
                else
                {
                    myfeeds_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                    return FALSE;
                }
            }
            else
            {
                myfeeds_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                return FALSE;
            }
        }
        $result = $api_response->response;
    }
    $result = explode($titleSeparator, $result);
    if (count($result) < 2) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"SpinRewriter" failed to spin article - titleseparator not found: ' . $api_response->response);
        }
        return FALSE;
    }
    return $result;
}

function myfeeds_turkcespin_spin_text($title, $content)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if ((!isset($myfeeds_Main_Settings['best_user']) || $myfeeds_Main_Settings['best_user'] == '') && (!isset($myfeeds_Main_Settings['best_password']) || $myfeeds_Main_Settings['best_password'] == '')) {
        myfeeds_log_to_file('Please insert a valid "TurkceSpin" user name and password.');
        return FALSE;
    }
    if(!isset($myfeeds_Main_Settings['best_password']) || $myfeeds_Main_Settings['best_password'] == '')
    {
        $appi = $myfeeds_Main_Settings['best_user'];
    }
    else
    {
        $appi = $myfeeds_Main_Settings['best_password'];
    }
    $titleSeparator   = '[19459000]';
    $html             = $title . ' ' . $titleSeparator . ' ' . $content;
    $postData = array(
        'token'  => $appi,
        'article' => $html
    );
    if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
        $timeout = intval($myfeeds_Main_Settings['request_timeout']);
    } else {
        $timeout = 10;
    }
    $ch = curl_init("https://turkcespin.com/api/spin");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postData));
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    $api_response = curl_exec ($ch);
    curl_close($ch);
    if ($api_response === FALSE) {
        myfeeds_log_to_file('"TurkceSpin" failed to exec curl after auth.');
        return FALSE;
    }
    $api_response = json_decode($api_response);
    if(!isset($api_response->article) || !isset($api_response->status) || ($api_response->status != 'ok' && $api_response->status != 'OK'))
    {
        myfeeds_log_to_file('"TurkceSpin" error response: ' . print_r($api_response, true) . ' params: ' . print_r($appi, true) . ' --- ' . print_r($html, true));
        return FALSE;
    }
    $api_response = urldecode($api_response->article);
    $result = explode($titleSeparator, $api_response);
    if (count($result) < 2) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('"TurkceSpin" failed to spin article - titleseparator not found.');
        }
        return FALSE;
    }
    return $result;
}

function myfeeds_spinrewriter_api_post($data){
	$data_raw = "";
    
    $GLOBALS['wp_object_cache']->delete('crspinrewriter_spin_time', 'options');
    $spin_time = get_option('crspinrewriter_spin_time', false);
    if($spin_time !== false && is_numeric($spin_time))
    {
        $c_time = time();
        $spassed = $c_time - $spin_time;
        if($spassed < 10 && $spassed >= 0)
        {
            sleep(10 - $spassed);
        }
    }
    update_option('crspinrewriter_spin_time', time());
    
	foreach ($data as $key => $value){
		$data_raw = $data_raw . $key . "=" . urlencode($value) . "&";
	}
	$ch = curl_init();
    if($ch === false)
    {
        return false;
    }
	curl_setopt($ch, CURLOPT_URL, "http://www.spinrewriter.com/action/api");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data_raw);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT,90);
	$response = trim(curl_exec($ch));
	curl_close($ch);
	return $response;
}
function myfeeds_replaceExcludes($text, &$htmlfounds, &$pre_tags_matches, &$pre_tags_matches_s, &$conseqMatchs)
{
    preg_match_all ( '{<script.*?script>}s', $text, $script_matchs );
    $script_matchs = $script_matchs [0];
    preg_match_all ( '{<pre.*?/pre>}s', $text, $pre_matchs );
    $pre_matchs = $pre_matchs [0];
    preg_match_all ( '{<code.*?/code>}s', $text, $code_matchs );
    $code_matchs = $code_matchs [0];
    preg_match_all ( "/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER );
    $htmlfounds = array_filter ( array_unique ( $matches [0] ) );
    $htmlfounds = array_merge ( $script_matchs, $pre_matchs, $code_matchs, $htmlfounds );
    $htmlfounds [] = '&quot;';
    $imgFoundsSeparated = array ();
    $new_imgFoundsSeparated = array ();
    $altSeparator = '';
    $colonSeparator = '';
    foreach ( $htmlfounds as $key => $currentFound ) 
    {
        if (stristr ( $currentFound, '<img' ) && stristr ( $currentFound, 'alt' ) && ! stristr ( $currentFound, 'alt=""' )) 
        {
            $altSeparator = '';
            $colonSeparator = '';
            if (stristr ( $currentFound, 'alt="' )) {
                $altSeparator = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr ( $currentFound, 'alt = "' )) {
                $altSeparator = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr ( $currentFound, 'alt ="' )) {
                $altSeparator = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr ( $currentFound, 'alt= "' )) {
                $altSeparator = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr ( $currentFound, 'alt=\'' )) {
                $altSeparator = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr ( $currentFound, 'alt = \'' )) {
                $altSeparator = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr ( $currentFound, 'alt= \'' )) {
                $altSeparator = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr ( $currentFound, 'alt =\'' )) {
                $altSeparator = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim ( $altSeparator ) != '') 
            {
                $currentFoundParts = explode ( $altSeparator, $currentFound );
                $preAlt = $currentFoundParts [1];
                $preAltParts = explode ( $colonSeparator, $preAlt );
                $altText = $preAltParts [0];
                if (trim ( $altText ) != '') 
                {
                    unset ( $preAltParts [0] );
                    $past_alt_text = implode ( $colonSeparator, $preAltParts );
                    $imgFoundsSeparated [] = $currentFoundParts [0] . $altSeparator;
                    $imgFoundsSeparated [] = $colonSeparator . $past_alt_text;
                    $htmlfounds [$key] = '';
                }
            }
        }
    }
    $title_separator = str_replace ( 'alt', 'title', $altSeparator );
    foreach ( $imgFoundsSeparated as $img_part ) 
    {
        if (stristr ( $img_part, ' title' )) 
        {
            $img_part_parts = explode ( $title_separator, $img_part );
            $pre_title_part = $img_part_parts [0] . $title_separator;
            $post_title_parts = explode ( $colonSeparator, $img_part_parts [1] );
            $found_title = $post_title_parts [0];
            unset ( $post_title_parts [0] );
            $past_title_text = implode ( $colonSeparator, $post_title_parts );
            $post_title_part = $colonSeparator . $past_title_text;
            $new_imgFoundsSeparated [] = $pre_title_part;
            $new_imgFoundsSeparated [] = $post_title_part;
        } else {
            $new_imgFoundsSeparated [] = $img_part;
        }
    }
    if (count ( $new_imgFoundsSeparated ) != 0) {
        $htmlfounds = array_merge ( $htmlfounds, $new_imgFoundsSeparated );
    }
    preg_match_all ( "/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER );
    $newhtmlfounds = $matches2 [0];
    preg_match_all ( "/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER );
    $shortcodesfounds = $matches3 [0];
    $htmlfounds = array_merge ( $htmlfounds, $newhtmlfounds, $shortcodesfounds );
    $in = 0;
    $cleanHtmlFounds = array ();
    foreach ( $htmlfounds as $htmlfound ) {
        
        if ($htmlfound == '[19459000]') {
        } elseif (trim ( $htmlfound ) == '') {
        } else {
            $cleanHtmlFounds [] = $htmlfound;
        }
    }
    $htmlfounds = array_filter ( $cleanHtmlFounds );
    $start = 19459001;
    foreach ( $htmlfounds as $htmlfound ) {
        $text = str_replace ( $htmlfound, '[' . $start . ']', $text );
        $start ++;
    }
    $text = str_replace ( '.{', '. {', $text );
    preg_match_all ( '!(?:\[1945\d*\][\s]*){2,}!s', $text, $conseqMatchs );
    $startConseq = 19659001;
    foreach ( $conseqMatchs [0] as $conseqMatch ) {
        $text = preg_replace ( '{' . preg_quote ( trim ( $conseqMatch ) ) . '}', '[' . $startConseq . ']', $text, 1 );
        $startConseq ++;
    }
    preg_match_all ( '{\[.*?\]}', $text, $pre_tags_matches );
    $pre_tags_matches = ($pre_tags_matches [0]);
    preg_match_all ( '{\s*\[.*?\]\s*}u', $text, $pre_tags_matches_s );
    $pre_tags_matches_s = ($pre_tags_matches_s [0]);
    $text = str_replace ( '[', "\n\n[", $text );
    $text = str_replace ( ']', "]\n\n", $text );
	return $text;	
}
function myfeeds_restoreExcludes($translated, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs){
    $translated = preg_replace ( '{]\s*?1945}', '][1945', $translated );
    $translated = preg_replace ( '{ 19459(\d*?)]}', ' [19459$1]', $translated );
    $translated = str_replace ( '[ [1945', '[1945', $translated );
    $translated = str_replace ( '], ', ']', $translated );
    preg_match_all ( '{\[.*?\]}', $translated, $bracket_matchs );
    $bracket_matchs = $bracket_matchs [0];
    foreach ( $bracket_matchs as $single_bracket ) 
    {
        if (stristr ( $single_bracket, '1' ) && stristr ( $single_bracket, '9' )) {
            $single_bracket_clean = str_replace ( array (
                    ',',
                    ' ' 
            ), '', $single_bracket );
            $translated = str_replace ( $single_bracket, $single_bracket_clean, $translated );
        }
    }
    preg_match_all ( '{\[\d*?\]}', $translated, $post_tags_matches );
    $post_tags_matches = ($post_tags_matches [0]);
    if (count ( $pre_tags_matches ) == count ( $post_tags_matches )) 
    {
        if ($pre_tags_matches !== $post_tags_matches) 
        {
            $i = 0;
            foreach ( $post_tags_matches as $post_tags_match ) {
                $translated = preg_replace ( '{' . preg_quote ( trim ( $post_tags_match ) ) . '}', '[' . $i . ']', $translated, 1 );
                $i ++;
            }
            $i = 0;
            foreach ( $pre_tags_matches as $pre_tags_match ) {
                $translated = str_replace ( '[' . $i . ']', $pre_tags_match, $translated );
                $i ++;
            }
        }
    }
    $translated = str_replace ( "\n\n[", '[', $translated );
    $translated = str_replace ( "]\n\n", ']', $translated );
    $i = 0;
    foreach ( $pre_tags_matches_s as $pre_tags_match ) 
    {
        $pre_tags_match_h = htmlentities ( $pre_tags_match );
        if (stristr ( $pre_tags_match_h, '&nbsp;' )) {
            $pre_tags_match = str_replace ( '&nbsp;', ' ', $pre_tags_match_h );
        }
        $translated = preg_replace ( '{' . preg_quote ( trim ( $pre_tags_match ) ) . '}', "[$i]", $translated, 1 );
        $i ++;
    }
    $translated = preg_replace ( '{\s*\[}u', '[', $translated );
    $translated = preg_replace ( '{\]\s*}u', ']', $translated );
    $i = 0;
    foreach ( $pre_tags_matches_s as $pre_tags_match ) 
    {
        $pre_tags_match_h = htmlentities ( $pre_tags_match );
        if (stristr ( $pre_tags_match_h, '&nbsp;' )) {
            $pre_tags_match = str_replace ( '&nbsp;', ' ', $pre_tags_match_h );
        }
        $translated = preg_replace ( '{' . preg_quote ( "[$i]" ) . '}', $pre_tags_match, $translated, 1 );
        $i ++;
    }
    $startConseq = 19659001;
    foreach ( $conseqMatchs [0] as $conseqMatch ) {
        $translated = str_replace ( '[' . $startConseq . ']', $conseqMatch, $translated );
        $startConseq ++;
    }
    preg_match_all ( '!\[.*?\]!', $translated, $brackets );
    $brackets = $brackets [0];
    $brackets = array_unique ( $brackets );
    foreach ( $brackets as $bracket ) {
        if (stristr ( $bracket, '19' )) 
        {
            $corrrect_bracket = str_replace ( ' ', '', $bracket );
            $corrrect_bracket = str_replace ( '.', '', $corrrect_bracket );
            $corrrect_bracket = str_replace ( ',', '', $corrrect_bracket );
            $translated = str_replace ( $bracket, $corrrect_bracket, $translated );
        }
    }
    $start = 19459001;
    foreach ( $htmlfounds as $htmlfound ) {
        $translated = str_replace ( '[' . $start . ']', $htmlfound, $translated );
        $start ++;
    }
    return $translated;
}
function myfeeds_fix_spinned_content($final_content, $spinner)
{
    if ($spinner == 'wordai') {
        $final_content = str_replace('-LRB-', '(', $final_content);
        $final_content1 = preg_replace("/{\*\|.*?}/", '*', $final_content);
        if($final_content1 !== null)
        {
            $final_content = $final_content1;
        }
    }
    elseif ($spinner == 'spinrewriter' || $spinner == 'translate') {
        $final_content = str_replace('& #', '&#', $final_content);
        $final_content = str_replace('& ldquo;', '"', $final_content);
        $final_content = str_replace('& rdquo;', '"', $final_content);
    }
    return $final_content;
}
function myfeeds_spin_and_translate($post_title, $final_content, $translate, $source_lang, $use_proxy = '1')
{
    $pre_tags_matches = array();
    $pre_tags_matches_s = array();
    $conseqMatchs = array();
    $turk = false;
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['spin_text']) && $myfeeds_Main_Settings['spin_text'] !== 'disabled') {
        if ($myfeeds_Main_Settings['spin_text'] == 'turkcespin') {
            $turk = true;
        }
        $htmlfounds = array();
        if($turk == false)
        {
            $final_content = myfeeds_replaceExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
        }
        if ($myfeeds_Main_Settings['spin_text'] == 'builtin') {
            $translation = myfeeds_builtin_spin_text($post_title, $final_content);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'wikisynonyms') {
            $translation = myfeeds_spin_text($post_title, $final_content, false);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'freethesaurus') {
            $translation = myfeeds_spin_text($post_title, $final_content, true);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'best') {
            $translation = myfeeds_best_spin_text($post_title, $final_content);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'wordai') {
            $translation = myfeeds_wordai_spin_text($post_title, $final_content);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'spinrewriter') {
            $translation = myfeeds_spinrewriter_spin_text($post_title, $final_content);
        } elseif ($myfeeds_Main_Settings['spin_text'] == 'turkcespin') {
            $translation = myfeeds_turkcespin_spin_text($post_title, $final_content);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                if (isset($myfeeds_Main_Settings['no_title_spin']) && $myfeeds_Main_Settings['no_title_spin'] == 'on') {
                }
                else
                {
                    $post_title    = $translation[0];
                }
                $final_content = $translation[1];
                if($turk == false)
                {
                    $final_content = myfeeds_fix_spinned_content($final_content, $myfeeds_Main_Settings['spin_text']);
                    $final_content = myfeeds_restoreExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
                }
                
            } else {
                if($turk == false)
                {
                    $final_content = myfeeds_restoreExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
                }
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('Text Spinning failed - malformed data ' . $myfeeds_Main_Settings['spin_text']);
                }
            }
        } else {
            if($turk == false)
            {
                $final_content = myfeeds_restoreExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
            }
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                myfeeds_log_to_file('Text Spinning Failed - returned false ' . $myfeeds_Main_Settings['spin_text']);
            }
        }
    }
    if ($translate != 'disabled') {
        if (isset($source_lang) && $source_lang != 'disabled' && $source_lang != '') {
            $tr = $source_lang;
        }
        else
        {
            $tr = 'auto';
        }
        
        $htmlfounds = array();
        $final_content = myfeeds_replaceExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
        
        $translation = myfeeds_translate($post_title, $final_content, $tr, $translate, $use_proxy);
        if (is_array($translation) && isset($translation[1]))
        {
            $translation[1] = preg_replace('#(?<=[\*(])\s+(?=[\*)])#', '', $translation[1]);
            $translation[1] = preg_replace('#([^(*\s]\s)\*+\)#', '$1', $translation[1]);
            $translation[1] = preg_replace('#\(\*+([\s][^)*\s])#', '$1', $translation[1]);
            $translation[1] = myfeeds_restoreExcludes($translation[1], $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
        }
        else
        {
            $final_content = myfeeds_restoreExcludes($final_content, $htmlfounds, $pre_tags_matches, $pre_tags_matches_s, $conseqMatchs);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                if (isset($myfeeds_Main_Settings['no_title_spin']) && $myfeeds_Main_Settings['no_title_spin'] == 'on') {
                }
                else
                { 
                    $post_title    = $translation[0];
                }
                $final_content = $translation[1];
                $final_content = str_replace('</ iframe>', '</iframe>', $final_content);
                if(stristr($final_content, '<head>') !== false)
                {
                    $d = new DOMDocument;
                    $mock = new DOMDocument;
                    $internalErrors = libxml_use_internal_errors(true);
                    $d->loadHTML('<?xml encoding="utf-8" ?>' . $final_content);
                    libxml_use_internal_errors($internalErrors);
                    $body = $d->getElementsByTagName('body')->item(0);
                    foreach ($body->childNodes as $child)
                    {
                        $mock->appendChild($mock->importNode($child, true));
                    }
                    if(method_exists($mock, 'saveHTML'))
                    {
                        $new_post_content_temp = $mock->saveHTML();
                    }
                    if($new_post_content_temp !== '' && $new_post_content_temp !== false)
                    {
						$new_post_content_temp = str_replace('<?xml encoding="utf-8" ?>', '', $new_post_content_temp);
                        $final_content = preg_replace("/_addload\(function\(\){([^<]*)/i", "", $new_post_content_temp); 
                    }
                }
                $final_content = htmlspecialchars_decode($final_content);
                $final_content = str_replace('</ ', '</', $final_content);
                $final_content = str_replace(' />', '/>', $final_content);
                $final_content = str_replace('< br/>', '<br/>', $final_content);
                $final_content = str_replace('< / ', '</', $final_content);
                $final_content = str_replace(' / >', '/>', $final_content);
                $final_content = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $final_content);
                $final_content = html_entity_decode($final_content);
                $final_content = preg_replace_callback("#src(?:\s)?=(?:\s)?[\'\"]([^\"\']+?)[\'\"]#", "myfeeds_removeSpaces", $final_content);
                if (isset($myfeeds_Main_Settings['no_title_spin']) && $myfeeds_Main_Settings['no_title_spin'] == 'on') {
                }
                else
                { 
                    $post_title = preg_replace('{&\s*#\s*(\d+)\s*;}', '&#$1;', $post_title);
$post_title = htmlspecialchars_decode($post_title);
                    $post_title = str_replace('</ ', '</', $post_title);
                    $post_title = str_replace(' />', '/>', $post_title);
                    $post_title = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $post_title);
                }
            } else {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('Translation failed - malformed data!');
                }
            }
        } else {
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                myfeeds_log_to_file('Translation Failed - returned false!');
            }
        }
    }
    return array(
        $post_title,
        $final_content
    );
}

function myfeeds_translate($title, $content, $from, $to, $use_proxy = '1')
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    $ch = FALSE;
    try {
        if($from == 'disabled')
        {
            if(strstr($to, '-') !== false && $to != 'zh-CN' && $to != 'zh-TW')
            {
                $from = 'auto-';
            }
            else
            {
                $from = 'auto';
            }
        }
        if($from != 'en' && $from != 'en-' && $from == $to)
        {
            if(strstr($to, '-') !== false && $to != 'zh-CN' && $to != 'zh-TW')
            {
                $from = 'en-';
            }
            else
            {
                $from = 'en';
            }
        }
        elseif(($from == 'en' || $from == 'en-') && $from == $to)
        {
            return false;
        }
        if(strstr($to, '-') !== false && $to != 'zh-CN' && $to != 'zh-TW')
        {
            if (!isset($myfeeds_Main_Settings['deepl_auth']) || trim($myfeeds_Main_Settings['deepl_auth']) == '')
            {
                throw new Exception('You must enter a DeepL API key from plugin settings, to use this feature!');
            }
            $to = rtrim($to, '-');
            $from = rtrim($from, '-');
            if(strlen($content) > 30000)
            {
                $translated = '';
                while($content != '')
                {
                    $first30k = substr($content, 0, 30000);
                    $content = substr($content, 30000);
                    if (isset($myfeeds_Main_Settings['deppl_free']) && trim($myfeeds_Main_Settings['deppl_free']) == 'on')
                    {
                        $ch = curl_init('https://api-free.deepl.com/v2/translate');
                    }
                    else
                    {
                        $ch = curl_init('https://api.deepl.com/v2/translate');
                    }
                    if($ch !== false)
                    {
                        $data           = array();
                        $data['text']   = $first30k;
                        if($from != 'auto')
                        {
                            $data['source_lang']   = $from;
                        }
                        $data['tag_handling']  = 'xml';
                        $data['non_splitting_tags']  = 'div';
                        $data['preserve_formatting']  = '1';
                        $data['target_lang']   = $to;
                        $data['auth_key']   = trim($myfeeds_Main_Settings['deepl_auth']);
                        $fdata = "";
                        foreach ($data as $key => $val) {
                            $fdata .= "$key=" . urlencode(trim($val)) . "&";
                        }
                        $headers = [
                            'Content-Type: application/x-www-form-urlencoded',
                            'Content-Length: ' . strlen($fdata)
                        ];
                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                        curl_setopt($ch, CURLOPT_POST, 1);
                        curl_setopt($ch, CURLOPT_USERAGENT, myfeeds_get_random_user_agent());
                        curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                        $translated_temp = curl_exec($ch);
                        if($translated_temp === false)
                        {
                            throw new Exception('Failed to post to DeepL: ' . curl_error($ch));
                        }
                        curl_close($ch);
                    }
                    $trans_json = json_decode($translated_temp, true);
                    if($trans_json === false)
                    {
                        throw new Exception('Incorrect multipart response from DeepL: ' . $translated_temp);
                    }
                    if(!isset($trans_json['translations'][0]['text']))
                    {
                        throw new Exception('Unrecognized multipart response from DeepL: ' . $translated_temp);
                    }
                    $translated .= ' ' . $trans_json['translations'][0]['text'];
                }
            }
            else
            {
                if (isset($myfeeds_Main_Settings['deppl_free']) && trim($myfeeds_Main_Settings['deppl_free']) == 'on')
                {
                    $ch = curl_init('https://api-free.deepl.com/v2/translate');
                }
                else
                {
                    $ch = curl_init('https://api.deepl.com/v2/translate');
                }
                if($ch !== false)
                {
                    $data           = array();
                    $data['text']   = $content;
                    if($from != 'auto')
                    {
                        $data['source_lang']   = $from;
                    }
                    $data['tag_handling']  = 'xml';
                    $data['non_splitting_tags']  = 'div';
                    $data['preserve_formatting']  = '1';
                    $data['target_lang']   = $to;
                    $data['auth_key']   = trim($myfeeds_Main_Settings['deepl_auth']);
                    $fdata = "";
                    foreach ($data as $key => $val) {
                        $fdata .= "$key=" . urlencode(trim($val)) . "&";
                    }
                    curl_setopt($ch, CURLOPT_POST, 1);
                    $headers = [
                        'Content-Type: application/x-www-form-urlencoded',
                        'Content-Length: ' . strlen($fdata)
                    ];
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                    $translated = curl_exec($ch);
                    if($translated === false)
                    {
                        throw new Exception('Failed to post to DeepL: ' . curl_error($ch));
                    }
                    curl_close($ch);
                }
                $trans_json = json_decode($translated, true);
                if($trans_json === false)
                {
                    throw new Exception('Incorrect text response from DeepL: ' . $translated);
                }
                if(!isset($trans_json['translations'][0]['text']))
                {
                    throw new Exception('Unrecognized text response from DeepL: ' . $translated);
                }
                $translated = $trans_json['translations'][0]['text'];
            }
            $translated = str_replace('<strong>', ' <strong>', $translated);
            $translated = str_replace('</strong>', '</strong> ', $translated);
            if($from != 'auto')
            {
                $from_from = '&source_lang=' . $from;
            }
            else
            {
                $from_from = '';
            }
            if (isset($myfeeds_Main_Settings['deppl_free']) && trim($myfeeds_Main_Settings['deppl_free']) == 'on')
            {
                $translated_title = myfeeds_get_web_page('https://api-free.deepl.com/v2/translate?text=' . urlencode($title) . $from_from . '&target_lang=' . $to . '&auth_key=' . trim($myfeeds_Main_Settings['deepl_auth']) . '&tag_handling=xml&preserve_formatting=1', '', '', '0', '');
            }
            else
            {
                $translated_title = myfeeds_get_web_page('https://api.deepl.com/v2/translate?text=' . urlencode($title) . $from_from . '&target_lang=' . $to . '&auth_key=' . trim($myfeeds_Main_Settings['deepl_auth']) . '&tag_handling=xml&preserve_formatting=1', '', '', '0', '');
            }
            $trans_json = json_decode($translated_title, true);
            if($trans_json === false)
            {
                throw new Exception('Incorrect title response from DeepL: ' . $translated_title);
            }
            if(!isset($trans_json['translations'][0]['text']))
            {
                throw new Exception('Unrecognized title response from DeepL: ' . $translated_title);
            }
            $translated_title = $trans_json['translations'][0]['text'];
        }
        else
        {
            if (isset($myfeeds_Main_Settings['google_trans_auth']) && trim($myfeeds_Main_Settings['google_trans_auth']) != '')
            {
                require_once(dirname(__FILE__) . "/res/translator-api.php");
                $ch = curl_init();
                if ($ch === FALSE) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Failed to init cURL in translator!');
                    }
                    return false;
                }
                if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') 
                {
                    $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
                    $randomness = array_rand($prx);
                    curl_setopt( $ch, CURLOPT_PROXY, trim($prx[$randomness]));
                    if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
                    {
                        $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                        if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                        {
                            curl_setopt( $ch, CURLOPT_PROXYUSERPWD, trim($prx_auth[$randomness]) );
                        }
                    }
                }
                if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
                    $timeout = intval($myfeeds_Main_Settings['request_timeout']);
                } else {
                    $timeout = 10;
                }
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
                $GoogleTranslatorAPI = new GoogleTranslatorAPI($ch, $myfeeds_Main_Settings['google_trans_auth']);
                $translated = '';
                $translated_title = '';
                if($content != '')
                {
                    if(strlen($content) > 30000)
                    {
                        while($content != '')
                        {
                            $first30k = substr($content, 0, 30000);
                            $content = substr($content, 30000);
                            $translated_temp       = $GoogleTranslatorAPI->translateText($first30k, $from, $to);
                            $translated .= ' ' . $translated_temp;
                        }
                    }
                    else
                    {
                        $translated       = $GoogleTranslatorAPI->translateText($content, $from, $to);
                    }
                }
                if($title != '')
                {
                    $translated_title = $GoogleTranslatorAPI->translateText($title, $from, $to);
                }
                curl_close($ch);
            }
            else
            {
                require_once(dirname(__FILE__) . "/res/myfeeds-translator.php");
                $ch = curl_init();
                if ($ch === FALSE) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Failed to init cURL in translator!');
                    }
                    return false;
                }
                if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled') 
                {
                    $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
                    $randomness = array_rand($prx);
                    curl_setopt( $ch, CURLOPT_PROXY, trim($prx[$randomness]));
                    if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
                    {
                        $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
                        if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
                        {
                            curl_setopt( $ch, CURLOPT_PROXYUSERPWD, trim($prx_auth[$randomness]) );
                        }
                    }
                }
                if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
                    $timeout = intval($myfeeds_Main_Settings['request_timeout']);
                } else {
                    $timeout = 10;
                }
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
                $GoogleTranslator = new GoogleTranslator($ch);
                $translated = '';
                $translated_title = '';
                if($content != '')
                {
                    if(strlen($content) > 13000)
                    {
                        while($content != '')
                        {
                            $first30k = substr($content, 0, 13000);
                            $content = substr($content, 13000);
                            $translated_temp       = $GoogleTranslator->translateText($first30k, $from, $to);
                            if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                                throw new Exception('Page content already in ' . $to);
                            }
                            if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                                throw new Exception('Unexpected error while translating page!');
                            }
                            if(substr_compare($translated_temp, '</pre>', -strlen('</pre>')) === 0){$translated_temp = substr_replace($translated_temp ,"", -6);}if(substr( $translated_temp, 0, 5 ) === "<pre>"){$translated_temp = substr($translated_temp, 5);}
                            $translated .= ' ' . $translated_temp;
                        }
                    }
                    else
                    {
                        $translated       = $GoogleTranslator->translateText($content, $from, $to);
                        if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                            throw new Exception('Page content already in ' . $to);
                        }
                        if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                            throw new Exception('Unexpected error while translating page!');
                        }
                    }
                }
                if($title != '')
                {
                    $translated_title = $GoogleTranslator->translateText($title, $from, $to);
                }
                if (strpos($translated_title, '<h2>The page you have attempted to translate is already in ') !== false) {
                    throw new Exception('Page title already in ' . $to);
                }
                if (strpos($translated_title, 'Error 400 (Bad Request)!!1') !== false) {
                    throw new Exception('Unexpected error while translating page title!');
                }
                curl_close($ch);
            }
        }
    }
    catch (Exception $e) {
        if($ch !== false)
        {
            curl_close($ch);
        }
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
            myfeeds_log_to_file('Exception thrown in Translator ' . $e);
        }
        return false;
    }
    if(substr_compare($translated_title, '</pre>', -strlen('</pre>')) === 0){$title = substr_replace($translated_title ,"", -6);}else{$title = $translated_title;}if(substr( $title, 0, 5 ) === "<pre>"){$title = substr($title, 5);}
    if(substr_compare($translated, '</pre>', -strlen('</pre>')) === 0){$text = substr_replace($translated ,"", -6);}else{$text = $translated;}if(substr( $text, 0, 5 ) === "<pre>"){$text = substr($text, 5);}
    $text  = preg_replace('/' . preg_quote('html lang=') . '.*?' . preg_quote('>') . '/', '', $text);
    $text  = preg_replace('/' . preg_quote('!DOCTYPE') . '.*?' . preg_quote('<') . '/', '', $text);
    return array(
        $title,
        $text
    );
}

function myfeeds_removeSpaces($matches) {
  return "src='" . str_replace(" ", "", $matches[1]) . "'";
}
function myfeeds_strip_html_tags($str, $allow_tags = '')
{
    $str = html_entity_decode($str);
    $str1 = preg_replace('/(<|>)\1{2}/is', '', $str);
    if($str1 !== null)
    {
        $str = $str1;
    }
    if($allow_tags != '')
    {
        $rparr = array();
        if(stristr($allow_tags, '<head>') == false)
        {
            $rparr[] = '@<head[^>]*?>.*?</head>@siu';
        }
        if(stristr($allow_tags, '<style>') == false)
        {
            $rparr[] = '@<style[^>]*?>.*?</style>@siu';
        }
        if(stristr($allow_tags, '<script>') == false)
        {
            $rparr[] = '@<script[^>]*?.*?</script>@siu';
        }
        if(stristr($allow_tags, '<noscript>') == false)
        {
            $rparr[] = '@<noscript[^>]*?.*?</noscript>@siu';
        }
        if(count($rparr) > 0)
        {
            $str1 = preg_replace($rparr, "", $str);
            if($str1 !== null)
            {
                $str = $str1;
            }
        }
    }
    else
    {
        $str1 = preg_replace(array(
            '@<head[^>]*?>.*?</head>@siu',
            '@<style[^>]*?>.*?</style>@siu',
            '@<script[^>]*?.*?</script>@siu',
            '@<noscript[^>]*?.*?</noscript>@siu'
        ), "", $str);
        if($str1 !== null)
        {
            $str = $str1;
        }
    }
    if($allow_tags != '')
    {
        $str = strip_tags($str, $allow_tags);
    }
    else
    {
        $str = strip_tags($str);
    }
    
    return $str;
}

function myfeeds_DOMinnerHTML(DOMNode $element)
{
    $innerHTML = "";
    $children  = $element->childNodes;
    
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    
    return $innerHTML;
}
function myfeeds_encodeURI($url) {
    $unescaped = array(
        '%2D'=>'-','%5F'=>'_','%2E'=>'.','%21'=>'!', '%7E'=>'~',
        '%2A'=>'*', '%27'=>"'", '%28'=>'(', '%29'=>')', '%5B'=>'[', '%5D'=>']'
    );
    $reserved = array(
        '%3B'=>';','%2C'=>',','%2F'=>'/','%3F'=>'?','%3A'=>':',
        '%40'=>'@','%26'=>'&','%3D'=>'=','%2B'=>'+','%24'=>'$','%25'=>'%'
    );
    $score = array(
        '%23'=>'#'
    );
    return strtr(rawurlencode($url), array_merge($reserved, $unescaped, $score));

}
function myfeeds_url_exists(&$url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass)
{
    if (filter_var($url, FILTER_VALIDATE_URL) === FALSE) {
        $url = myfeeds_encodeURI($url);
        if (filter_var($url, FILTER_VALIDATE_URL) === FALSE) {
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('URL is not valid: ' . $url); 
            }
            return false;
        }
    }
    $ch = curl_init($url);
    if($ch === false)
    {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to init curl while validating URL: ' . $url); 
        }
        return false;
    }
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '' && $myfeeds_Main_Settings['proxy_url'] != 'disable' && $myfeeds_Main_Settings['proxy_url'] != 'disabled')
    {
        $prx = explode(',', $myfeeds_Main_Settings['proxy_url']);
        $randomness = array_rand($prx);
        curl_setopt( $ch, CURLOPT_PROXY, trim($prx[$randomness]));
        if (isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '') 
        {
            $prx_auth = explode(',', $myfeeds_Main_Settings['proxy_auth']);
            if(isset($prx_auth[$randomness]) && trim($prx_auth[$randomness]) != '')
            {
                curl_setopt( $ch, CURLOPT_PROXYUSERPWD, trim($prx_auth[$randomness]) );
            }
        }
    }
    if($custom_user_agent != '')
    {
        curl_setopt($ch, CURLOPT_USERAGENT, $custom_user_agent);
    }
    if (isset($myfeeds_Main_Settings['request_timeout']) && $myfeeds_Main_Settings['request_timeout'] != '') {
        $timeout = intval($myfeeds_Main_Settings['request_timeout']);
    } else {
        $timeout = 10;
    }
    curl_setopt($ch, CURLOPT_NOBODY, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    if($custom_cookies != '')
    {
        $headers   = array();
        $headers[] = 'Cookie: ' . $custom_cookies;
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_COOKIE , $custom_cookies);
    }
    if($user_pass != '')
    {
        $har = explode(':', $user_pass);
        if(isset($har[1]))
        {
            curl_setopt($ch, CURLOPT_USERPWD, $user_pass);
        }
    }
    curl_exec($ch);
    $valid = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if($valid >= 400)
    {
        curl_close($ch);
        if(($valid == 405 || $valid == 503) && stristr($url, 'amazon.') !== false)
        {
            return true;
        }
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to validate URL (code: ' . $valid . '): ' . $url); 
        }
        return false;
    }
    curl_close($ch);
    return true;
}

function myfeeds_get_random_user_agent() {
	$agents = array(
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36 Edge/15.15063",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36"
	);
	$rand   = rand( 0, count( $agents ) - 1 );
	return trim( $agents[ $rand ] );
}
use fivefilters\Readability\Readability;
use fivefilters\Readability\Configuration;
function myfeeds_convert_readable_html($html_string) {
    if(!class_exists('\fivefilters\Readability\Readability'))
    {
        require_once (dirname(__FILE__) . "/res/readability/vendor/autoload.php");

        require_once (dirname(__FILE__) . "/res/readability/Readability.php");
        require_once (dirname(__FILE__) . "/res/readability/ParseException.php");
        require_once (dirname(__FILE__) . "/res/readability/Configuration.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/NodeUtility.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/NodeTrait.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMAttr.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMCdataSection.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMCharacterData.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMComment.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMDocument.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMDocumentFragment.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMDocumentType.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMElement.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMEntity.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMEntityReference.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMNodeList.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMNode.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMNotation.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMProcessingInstruction.php");
        require_once (dirname(__FILE__) . "/res/readability/Nodes/DOM/DOMText.php");
    }
    
    try {
        $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
        if (isset($myfeeds_Main_Settings['alt_read']) && $myfeeds_Main_Settings['alt_read'] == "on")
        {
            throw new Exception('fallback');
        }
        $readConf = new Configuration();
        $readConf->setSummonCthulhu(true);
        $readability = new Readability($readConf);
        $readability->parse($html_string);
        $return_me[0] = $readability->getTitle();
        $return_me[1] = $readability->getContent();
        if($return_me[0] == '' || $return_me[0] == null || $return_me[1] == '' || $return_me[1] == null)
        {
            throw new Exception('Content/title blank ' . print_r($return_me, true));
        }
        $return_me[1] = str_replace('</article>', '', $return_me[1]);
        $return_me[1] = str_replace('<article>', '', $return_me[1]);
        return $return_me;
    } catch (Exception $e) {
        try
        {
            require_once (dirname(__FILE__) . "/res/myfeeds-readability.php");
            $readability = new Readability2($html_string);
            $readability->debug = false;
            $readability->convertLinksToFootnotes = false;
            $result = $readability->init();
            if ($result) {
                $return_me[0] = $readability->getTitle()->innerHTML;
                $return_me[1] = $readability->getContent()->innerHTML;
                $return_me[1] = str_replace('</article>', '', $return_me[1]);
                $return_me[1] = str_replace('<article>', '', $return_me[1]);
                return $return_me;
            } else {
                return '';
            }
        }
        catch(Exception $e2)
        {
            myfeeds_log_to_file('Readability failed: ' . sprintf('Error processing text: %s', $e2->getMessage()));
            return '';
        }
    }
}

function myfeeds_get_timezone_timestamp()
{
    $tz = myfeeds_get_blog_timezone();;
    $timestamp = time();
    $dt = new DateTime("now", new DateTimeZone($tz->getName()));
    $dt->setTimestamp($timestamp);
    return strtotime($dt->format('d.m.Y, H:i:s'));
}
function myfeeds_tofloat($num, $price_sep) {
    if($num === '' || $num === false)
    {
        return false;
    }
    $dotPos = strrpos($num, '.');
    $commaPos = strrpos($num, ',');
    $sep = (($dotPos > $commaPos) && $dotPos) ? $dotPos : 
        ((($commaPos > $dotPos) && $commaPos) ? $commaPos : false);
   
    if (!$sep) {
        return floatval(preg_replace("/[^0-9]/", "", $num));
    } 

    return floatval(
        preg_replace("/[^0-9]/", "", substr($num, 0, $sep)) . $price_sep .
        preg_replace("/[^0-9]/", "", substr($num, $sep+1, strlen($num)))
    );
}
function myfeeds_wp_strip_all_tags($string, $remove_breaks = false) {
    $string = preg_replace( '@<(script|style)[^>]*?>.*?</\\1>@si', '', $string );
    $string = strip_tags(str_replace('<', ' <', $string));
 
    if ( $remove_breaks )
        $string = preg_replace('/[\r\n\t ]+/', ' ', $string);
 
    return trim( $string );
}
function myfeeds_wp_trim_words( $text, $num_words = 55, $more = null ) {
    if ( null === $more ) {
        $more = esc_html__( '...', 'rss-feed-from-any-site' );
    }
    $original_text = $text;
    $text = myfeeds_wp_strip_all_tags( $text );
    $sep = ' ';
    if ( strpos( _x( 'words', 'Word count type. Do not translate!', 'rss-feed-from-any-site' ), 'characters' ) === 0 && preg_match( '/^utf\-?8$/i', get_option( 'blog_charset' ) ) ) {
        $text = trim( preg_replace( "/[\n\r\t ]+/", ' ', $text ), ' ' );
        preg_match_all( '/./u', $text, $words_array );
        $words_array = array_slice( $words_array[0], 0, $num_words + 1 );
    } else {
        $words_array = preg_split( "/[\n\r\t ]+/", $text, $num_words + 1, PREG_SPLIT_NO_EMPTY );
    }
    if ( count( $words_array ) > $num_words ) {
        array_pop( $words_array );
        $text = implode( $sep, $words_array );
        $text = $text . $more;
    } else {
        $text = implode( $sep, $words_array );
    }
    return apply_filters( 'wp_trim_words', $text, $num_words, $more, $original_text );
}
$crawl_done = false;
$seed = true;
function myfeeds_crawl_page($url, $max, $skip_og, $skip_post_content, $no_external, $required_words, $banned_words, $type, $getname, $title_type, $title_getname, $image_type, $image_getname, $date_type, $date_getname, $cat_type, $cat_getname, $depth, $custom_cookies, $only_class, $only_id, $no_source, $seed_type, $seed_expre, $crawled_type, $crawled_expre, $paged_crawl_str, $paged_crawl_type, $max_paged_depth, $custom_user_agent, $cat_sep, $root_page, $seed_pag_type, $seed_pag_expre, $clear_static, $use_proxy, $use_phantom, $user_pass, $crawl_exclude, $crawl_title_exclude, $price_sep, $encoding, $reverse_crawl, $lazy_tag, $phantom_wait, $param, $continue_search, $strip_links, $royalty_free, $strip_by_id, $strip_by_class, $strip_by_xpath, $strip_by_tag, $only_text, $allow_html_tags, $content_percent, $replace_words, $strip_images, $limit_word_count, $read_more, $strip_by_regex, $strip_by_regex_title, $keep_source, $post_content, $post_title, $translate, $source_lang, $default_category, $remove_cats, $author_type, $author_expre, $custom_crawling_expre, $custom_tag_expre, $url_type, $url_expre, $feed_title, $feed_description, $regex_image, $replace_regex, $replace_regex_title, $skip_no_match, $no_link_scraper, $image_url)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if(isset($myfeeds_Main_Settings['attr_text']) && $myfeeds_Main_Settings['attr_text'] != '')
    {
        $img_attr = $myfeeds_Main_Settings['attr_text'];
    }
    else
    {
        $img_attr = '';
    }
    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
    {
        myfeeds_log_to_file('Now processing: ' . $url); 
    }
    $skip = false;
    foreach($crawl_exclude as $crex)
    {
        if($crex != '')
        {
            if(stristr($url, $crex) !== false)
            {
                myfeeds_log_to_file('Skipping ' . $url . ' because it is excluded from crawling.');
                return array();
            }
        }
    }
    static $seen = array();
    static $already_paginated = array();
    static $posts = array();
    if ($clear_static) {
        $posts = array();
    }
    if(count($posts) == $max)
    {
        $GLOBALS['crawl_done'] = true;
        return $posts;
    }
    if($GLOBALS['crawl_done'] === true)
    {
        return $posts;
    }
    if($GLOBALS['seed'] === true && $no_source == '1')
    {
        $skip = true;
    }
    if (isset($seen[$url]) || $depth === 0) {
        return $posts;
    }
    $post = array();
    $post['title'] = '';
    $post['content'] = '';
    $post['author'] = '';
    $post['date'] = '';
    $post['image'] = '';
    $post['categories'] = array();
    $post['final_content'] = '';
    $post['final_title'] = '';
    if(isset($myfeeds_Main_Settings['shortest_api']) && $myfeeds_Main_Settings['shortest_api'] != '')
    {
        $short_url = myfeeds_url_handle($url, $myfeeds_Main_Settings['shortest_api']);
    }
    else
    {
        $short_url = $url;
    }
    $post['short_url'] = $short_url;
    $post['url'] = $url;
    $seen[$url] = true;
    $dom = new DOMDocument('1.0');
    $got_phantom = false;
    $html_cont = false;
    if($use_phantom == '1')
    {
        $html_cont = myfeeds_get_page_PhantomJS($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
        if($html_cont !== false)
        {
            $got_phantom = true;
        }
    }
    elseif($use_phantom == '2')
    {
        $html_cont = myfeeds_get_page_Puppeteer($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
        if($html_cont !== false)
        {
            $got_phantom = true;
        }
    }
    elseif($use_phantom == '4')
    {
        $html_cont = myfeeds_get_page_PuppeteerAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
        if($html_cont !== false)
        {
            $got_phantom = true;
        }
    }
    elseif($use_phantom == '5')
    {
        $html_cont = myfeeds_get_page_TorAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
        if($html_cont !== false)
        {
            $got_phantom = true;
        }
    }
    elseif($use_phantom == '6')
    {
        $html_cont = myfeeds_get_page_PhantomJSAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
        if($html_cont !== false)
        {
            $got_phantom = true;
        }
    }
    if($got_phantom === false)
    {
        $html_cont = myfeeds_get_web_page($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass);
    }
    if($html_cont === false)
    {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to get content for: ' . $url); 
        }
        return false;
    }
    if ($encoding != 'UTF-8' && $encoding != 'NO_CHANGE')
    {
        $extract_temp = FALSE;
        if($encoding !== 'AUTO')
        {
            if (function_exists('iconv'))
            {
                $extract_temp = iconv($encoding, "UTF-8//IGNORE", $html_cont);
            }
        }
        else
        {
            if(function_exists('mb_detect_encoding'))
            {
                $temp_enc = mb_detect_encoding($html_cont, 'auto');
                if ($temp_enc !== FALSE && $temp_enc != 'UTF-8')
                {
                    if (function_exists('iconv'))
                    {
                        $extract_temp = iconv($temp_enc, "UTF-8//IGNORE", $html_cont);
                    }
                }
            }
        }
        if($extract_temp !== FALSE)
        {
            $html_cont = $extract_temp;
        }
    }
    $internalErrors = libxml_use_internal_errors(true);
    $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html_cont);
    libxml_use_internal_errors($internalErrors);
    if($skip != true)
    {
        if($type == 'disabled')
        {
            $post['content'] = '';
        }
        else
        {
            if($getname == '' || $type == 'auto')
            {
                $extract = myfeeds_convert_readable_html($html_cont);
                if($extract == '')
                {
                    $post['content'] = '';
                    $post['title'] = '';
                }
                else
                {
                    $post['content'] = $extract[1];
                    $post['title'] = $extract[0];
                }
            }
            else
            {
                $post['content'] = myfeeds_get_content($type, $getname, $html_cont);
                if($post['content'] == '')
                {
                    $extract = myfeeds_convert_readable_html($html_cont);
                    if($extract != '')
                    {
                        $post['content'] = $extract[1];
                    }
                }
            }
            if($paged_crawl_str != '' && $paged_crawl_type != 'disabled')
            {
                $extract_ext = myfeeds_get_paged_content($url, $html_cont, $type, $getname, $paged_crawl_type, $paged_crawl_str, $custom_cookies, $max_paged_depth, $custom_user_agent, $use_proxy, $use_phantom, $user_pass, $phantom_wait);
                if($extract_ext != '')
                {
                    if(isset($post['content']))
                    {
                        $post['content'] .= $extract_ext;
                    }
                    else
                    {
                        $post['content'] = $extract_ext;
                    }
                }
            }
        }
    }
    if($required_words != '')
    {
        $req_list = explode(',', trim($required_words, ','));
        foreach($req_list as $rl)
        {
            if(stristr($html_cont, $rl) === false)
            {
                if($GLOBALS['seed'] === false)
                {
                    return $posts;
                }
                else
                {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
                    {
                        myfeeds_log_to_file('Required word not found, skipping: ' . $url); 
                    }
                    $skip = true;
                }
            }
        }
    }
    if($banned_words != '')
    {
        $ban_list = explode(',', trim($banned_words, ','));
        foreach($ban_list as $bl)
        {
            if(stristr($html_cont, $bl) !== false)
            {
                if($GLOBALS['seed'] === false)
                {
                    return $posts;
                }
                else
                {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
                    {
                        myfeeds_log_to_file('Banned word detected, skipping it\'s importing: ' . $url); 
                    }
                    $skip = true;
                }
            }
        }
    }
    $custom_shortcode_final = array();
    if($skip != true)
    {
        if($title_type == 'disabled')
        {
            $post['title'] = '';
        }
        else
        {
            if($title_getname == '' || $title_type == 'auto')
            {
                if($post['title'] == '')
                {
                    $extract = myfeeds_convert_readable_html($html_cont);
                    if($extract == '')
                    {
                        $post['title'] = '';
                    }
                    else
                    {
                        $post['title'] = $extract[0];
                    }
                }
            }
            else
            {
                $post['title'] = myfeeds_wp_strip_all_tags(myfeeds_get_content($title_type, $title_getname, $html_cont));
                if($post['title'] == '')
                {
                    $extract = myfeeds_convert_readable_html($html_cont);
                    if($extract != '')
                    {
                        $post['title'] = $extract[0];
                    }
                }
            }
        }
        if($author_type != 'disabled')
        {
            if($author_expre == '' || $author_type == 'og')
            {
                $post['author'] = myfeeds_get_author($html_cont);
            }
            else
            {
                $temp_auth = myfeeds_get_content($author_type, $author_expre, $html_cont, true);
                if($temp_auth != '')
                {
                    $temp_auth = strip_tags($temp_auth);
                    if($temp_auth != '')
                    {
                        $post['author'] = $temp_auth;
                    }
                }
            }
        }
        if($post['content'] != '')
        {
            $post['content'] = preg_replace('/<a([^><]*)href=[\'"](#[^<>"\']*?)[\'"]/', '<a$1href="' . $url . '$2"', $post['content']);
            if (trim($lazy_tag) != '' && trim($lazy_tag) != 'src' && strstr($post['content'], trim($lazy_tag)) !== false) 
            {
                $lazy_tag = trim($lazy_tag);
                $lazy_found = false;
                preg_match_all('{<img .*?>}s', $post['content'], $imgsMatchs);
                if(isset($imgsMatchs[0]))
                {
                    $imgsMatchs = $imgsMatchs[0];
                    foreach($imgsMatchs as $imgMatch){
                        if(stristr($imgMatch, $lazy_tag )){
                            $newImg = $imgMatch;
                            $newImg = preg_replace('{ src=["\'].*?[\'"]}', '', $newImg);
                            if(stristr($lazy_tag, 'srcset') !== false)
                            {
                                $newImg = preg_replace('{\ssrcset=["\'].*?[\'"]}', '', $newImg);
                                $newImg = str_replace($lazy_tag, 'srcset', $newImg);
                                preg_match_all('#srcset=[\'"](?:([^"\'\s,]+)\s*(?:\s+\d+[wx])(?:,\s*)?)+["\']#', $newImg, $imgma);
                                if(isset($imgma[1][0]))
                                {
                                    $newImg = preg_replace('#<img#', '<img src="' . $imgma[1][0] . '"', $newImg);
                                }
                            }
                            else
                            {
                                $newImg = str_replace($lazy_tag, 'src', $newImg); 
                            }
                            $post['content'] = str_replace($imgMatch, $newImg, $post['content']);    
                            $lazy_found = true;       
                        }
                    }
                }
                if($lazy_found == false)
                {
                    $post['content'] = str_replace(trim($lazy_tag), 'src', $post['content']); 
                }
                preg_match_all('{<iframe .*?>}s', $post['content'], $imgsMatchs);
                if(isset($imgsMatchs[0]))
                {
                    $imgsMatchs = $imgsMatchs[0];
                    if(is_array($imgsMatchs))
                    {
                        foreach($imgsMatchs as $imgMatch){
                            if(stristr($imgMatch, $lazy_tag )){
                                $newImg = $imgMatch;
                                $newImg = preg_replace('{ src=["\'].*?[\'"]}', '', $newImg);
                                $newImg = str_replace($lazy_tag, 'src', $newImg);   
                                $post['content'] = str_replace($imgMatch, $newImg, $post['content']);                          
                            }
                        }
                    }
                }
            }
            else
            {
                $post['content'] = myfeeds_lazy_loading_auto_fix($post['content']);
            }
            if ((isset($myfeeds_Main_Settings['strip_content_links']) && $myfeeds_Main_Settings['strip_content_links'] == 'on') || $strip_links == '1') {
                $post['content'] = myfeeds_strip_links($post['content']);
            }
            if ((isset($myfeeds_Main_Settings['strip_internal_content_links']) && $myfeeds_Main_Settings['strip_internal_content_links'] == 'on')) {
                $post['content'] = myfeeds_strip_external_links($post['content'], $url);
            }
            if (isset($myfeeds_Main_Settings['strip_scripts']) && $myfeeds_Main_Settings['strip_scripts'] == 'on') {
                $post['content'] = preg_replace('{<script[\s\S]*?\/\s?script>}s', '', $post['content']);
                $post['content'] = preg_replace('{<ins.*?ins>}s', '', $post['content']);
                $post['content'] = preg_replace('{<ins.*?>}s', '', $post['content']);
                $post['content'] = preg_replace('{\(adsbygoogle.*?\);}s', '', $post['content']);
            }
            $my_url  = parse_url($url);
            $my_host = $my_url['host'];
            preg_match_all('{src[\s]*=[\s]*["|\'](.*?)["|\'].*?>}is', $post['content'], $matches);
            $img_srcs =  ($matches[1]);
            foreach ($img_srcs as $img_src){
                $original_src = $img_src;
                if(stristr($img_src, '../')){
                    $img_src = str_replace('../', '', $img_src);
                }
                if(stristr($img_src, 'http:') === FALSE && stristr($img_src, 'www.') === FALSE && stristr($img_src, 'https:') === FALSE && stristr($img_src, 'data:image') === FALSE)
                {
                    $img_src = trim($img_src);
                    if(preg_match('{^//}', $img_src)){
                        $img_src = 'http:'.$img_src;
                    }elseif( preg_match('{^/}', $img_src) ){
                        $img_src = 'http://'.$my_host.$img_src;
                    }else{
                        $img_src = 'http://'.$my_host.'/'.$img_src;
                    }
                    $reg_img = '{["|\'][\s]*'.preg_quote($original_src,'{').'[\s]*["|\']}s';
                    $post['content'] = preg_replace( $reg_img, '"'.$img_src.'"', $post['content']);
                }
            }
            $post['content'] = str_replace('href="../', 'href="http://'.$my_host.'/', $post['content']);
            $post['content'] = preg_replace('{href="/(\w)}', 'href="http://'.$my_host.'/$1', $post['content']);
            $post['content'] = preg_replace('{\ssrcset=".*?"}', ' ', $post['content']);
            $post['content'] = preg_replace('{\ssizes=".*?"}', ' ', $post['content']);
            $post['content'] = html_entity_decode($post['content']) ;

            if ($strip_by_id != '') {
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $strip_list = explode(',', $strip_by_id);
                $extractok = false;
                $html_dom_original_html = myfeeds_str_get_html($post['content']);
                if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    foreach ($strip_list as $strip_id) {
                        $ret = $html_dom_original_html->find('*[id="'.trim($strip_id).'"]');
                        foreach ($ret as $itm ) {
                            $extractok = true;
                            $itm->outertext = '' ;
                        }
                    }
                    $post['content'] = $html_dom_original_html->save();
                    $html_dom_original_html->clear();
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    foreach ($strip_list as $strip_id) {
                        if(trim($strip_id) == '')
                        {
                            continue;
                        }
                        $content_r = myfeeds_removeTagByID($post['content'], trim($strip_id));
                        if($content_r !== false)
                        {
                            $post['content'] = $content_r;
                        }
                    }
                }
            }
            if ($strip_by_class != '') {
                $extractok = false;
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $strip_list = explode(',', $strip_by_class);
                $html_dom_original_html = myfeeds_str_get_html($post['content']);
                if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    foreach ($strip_list as $strip_class) {
                        if(trim($strip_class) == '')
                        {
                            continue;
                        }
                        $ret = $html_dom_original_html->find('*[class="'.trim($strip_class).'"]');
                        foreach ($ret as $itm ) {
                            $extractok = true;
                            $itm->outertext = '' ;
                        }
                    }
                    $post['content'] = $html_dom_original_html->save();
                    $html_dom_original_html->clear();
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    foreach ($strip_list as $strip_class) {
                        if(trim($strip_class) == '')
                        {
                            continue;
                        }
                        $content_r = myfeeds_removeTagByClass($post['content'], trim($strip_class));
                        if($content_r !== false)
                        {
                            $post['content'] = $content_r;
                        }
                    }
                }
            }
            if ($strip_by_xpath != '') {
                $extractok = false;
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $html_dom_original_html = myfeeds_str_get_html($post['content']);
                if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    $ret = $html_dom_original_html->find($strip_by_xpath);
                    foreach ($ret as $itm ) {
                        $extractok = true;
                        $itm->outertext = '' ;
                    }
                    $post['content'] = $html_dom_original_html->save();
                    $html_dom_original_html->clear();
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    $content_r = myfeeds_removeTagByXPath($post['content'], trim($strip_by_xpath));
                    if($content_r !== false)
                    {
                        $post['content'] = $content_r;
                    }
                }
            }
            if ($strip_by_tag != '') {
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $extractok = false;
                $strip_list = explode(',', $strip_by_tag);
                $html_dom_original_html = myfeeds_str_get_html($post['content']);
                if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    foreach ($strip_list as $strip_tag) {
                        $strip_tag = trim($strip_tag);
                        if($strip_tag != '')
                        {
                            $ret = $html_dom_original_html->find($strip_tag);
                            foreach ($ret as $itm ) {
                                $extractok = true;
                                $itm->outertext = '' ;
                            }
                        }
                    }
                    $post['content'] = $html_dom_original_html->save();
                    $html_dom_original_html->clear();
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    foreach ($strip_list as $strip_tag) {
                        if(trim($strip_tag) == '')
                        {
                            continue;
                        }
                        $content_r = myfeeds_removeTagByTag($post['content'], trim($strip_tag));
                        if($content_r !== false)
                        {
                            $post['content'] = $content_r;
                        }
                    }
                }
            }
            if ($only_text == '1') {
                $post['content'] = myfeeds_strip_html_tags($post['content'], $allow_html_tags);
            }

            if($content_percent != '' && is_numeric($content_percent) && $content_percent != 100)
            {
                $temp_t = myfeeds_strip_html_tags($post['content']);
                $temp_t = str_replace('&nbsp;',"",$temp_t);
                $ccount = str_word_count($temp_t);
                if($ccount > 10)
                {
                    $str_count = strlen($post['content']);
                    $leave_cont = round($str_count * $content_percent / 100);
                    $post['content'] = myfeeds_substr_close_tags($post['content'], $leave_cont);
                }
                else
                {
                    $ccount = myfeeds_count_unicode_words($temp_t);
                    if($ccount > 10)
                    {
                        $str_count = strlen($post['content']);
                        $leave_cont = round($str_count * $content_percent / 100);
                        $post['content'] = myfeeds_substr_close_tags($post['content'], $leave_cont);
                    }
                }
            }
            $title_count = -1;
            if (isset($myfeeds_Main_Settings['min_word_title']) && $myfeeds_Main_Settings['min_word_title'] != '') {
                $title_count = str_word_count($post['title']);
                if ($title_count < intval($myfeeds_Main_Settings['min_word_title'])) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because title length (' . $title_count . ') < ' . $myfeeds_Main_Settings['min_word_title']);
                    }
                    $skip = true;
                }
            }
            if (isset($myfeeds_Main_Settings['max_word_title']) && $myfeeds_Main_Settings['max_word_title'] != '') {
                if ($title_count == -1) {
                    $title_count = str_word_count($post['title']);
                }
                if ($title_count > intval($myfeeds_Main_Settings['max_word_title'])) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because title length (' . $title_count . ') > ' . $myfeeds_Main_Settings['max_word_title']);
                    }
                    $skip = true;
                }
            }
            $content_count = -1;
            if (isset($myfeeds_Main_Settings['min_word_content']) && $myfeeds_Main_Settings['min_word_content'] != '') {
                $content_count = str_word_count(myfeeds_strip_html_tags($post['content']));
                if ($content_count < intval($myfeeds_Main_Settings['min_word_content'])) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because content length (' . $content_count . ') < ' . $myfeeds_Main_Settings['min_word_content']);
                    }
                    $skip = true;
                }
            }
            if (isset($myfeeds_Main_Settings['max_word_content']) && $myfeeds_Main_Settings['max_word_content'] != '') {
                if ($content_count == -1) {
                    $content_count = str_word_count(myfeeds_strip_html_tags($post['content']));
                }
                if ($content_count > intval($myfeeds_Main_Settings['max_word_content'])) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because content length (' . $content_count . ') > ' . $myfeeds_Main_Settings['max_word_content']);
                    }
                    $skip = true;
                }
            }   
            if(trim($replace_words) != '')
            {
                $replace_arr = explode(',', trim($replace_words));
                $replace_arr = array_map('trim', $replace_arr);
                foreach($replace_arr as $rex)
                {
                    $repla_parts = explode('|', $rex);
                    if(!isset($repla_parts[1]))
                    {
                        continue;
                    }
                    $post['content'] = str_replace($repla_parts[0], $repla_parts[1], $post['content']);
                }
            }
            if (isset($myfeeds_Main_Settings['strip_links']) && $myfeeds_Main_Settings['strip_links'] == 'on') {
                $post['content'] = myfeeds_strip_links($post['content']);
            }
            if (isset($myfeeds_Main_Settings['replace_url']) && $myfeeds_Main_Settings['replace_url'] !== '') {
                if(strstr($myfeeds_Main_Settings['replace_url'], '%%original_url%%') !== false)
                {
                    $repl = str_replace('%%original_url%%', '', $myfeeds_Main_Settings['replace_url']);
                    $post['content'] = preg_replace('/<a(.+?)href=["\']([^"\']+?)["\']([^>]*?)>/i','<a$1href="$2' . esc_html($repl) . '"$3>', $post['content']);
                }
                else
                {
                    $post['content'] = preg_replace('/<a(.+?)href=["\']([^"\']+?)["\']([^>]*?)>/i','<a$1href="' . esc_url($myfeeds_Main_Settings['replace_url']) . '"$3>', $post['content']);
                }
            }
            if ($strip_images == '1') {
                $post['content'] = myfeeds_strip_images($post['content']);
            }
            if ($limit_word_count !== "") {
                $post['content'] = myfeeds_custom_wp_trim_excerpt($post['content'], $limit_word_count, $short_url, $read_more);
            }
            if ((isset($myfeeds_Main_Settings['link_attributes_internal']) && $myfeeds_Main_Settings['link_attributes_internal'] !== '') || (isset($myfeeds_Main_Settings['link_attributes_external']) && $myfeeds_Main_Settings['link_attributes_external'] !== ''))
            {
                $post['content'] = myfeeds_add_link_tags($post['content']);
            }
            if (isset($myfeeds_Main_Settings['iframe_resize_width']) && $myfeeds_Main_Settings['iframe_resize_width'] !== '')
            {
                $post['content'] = preg_replace("~<iframe(.*?)(?:width=[\"\'](?:\d*?)[\"\'])?(.*?)>~i", '<iframe$1 width="' . esc_attr($myfeeds_Main_Settings['iframe_resize_width']) . '"$2>', $post['content']); 
            }
            if (isset($myfeeds_Main_Settings['iframe_resize_height']) && $myfeeds_Main_Settings['iframe_resize_height'] !== '')
            {
                $post['content'] = preg_replace("~<iframe(.*?)(?:height=[\"\'](?:\d*?)[\"\'])?(.*?)>~i", '<iframe$1 height="' . esc_attr($myfeeds_Main_Settings['iframe_resize_height']) . '"$2>', $post['content']); 
            }
            if ($strip_by_regex !== '')
            {
                $xstrip_by_regex = preg_split('/\r\n|\r|\n/', $strip_by_regex);
                $xreplace_regex = preg_split('/\r\n|\r|\n/', $replace_regex);
                $xcnt = 0;
                foreach($xstrip_by_regex as $sbr)
                {
                    if(isset($xreplace_regex[$xcnt]))
                    {
                        $repreg = $xreplace_regex[$xcnt];
                    }
                    else
                    {
                        $repreg = '';
                    }
                    $xcnt++;
                    if($skip_no_match == '1')
                    {
                        preg_match_all("~" . $sbr . "~i", $post['content'], $reqmatches);
                        if(!isset($reqmatches[0][0]))
                        {
                            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                                myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because Regex not matched.');
                            }
                            $skip = true;
                            break;
                        }
                    }
                    else
                    {
                        $temp_cont = preg_replace("~" . $sbr . "~i", $repreg, $post['content']);
                        if($temp_cont !== NULL)
                        {
                            $post['content'] = $temp_cont;
                        }
                    }
                }
            }
            if ($strip_by_regex_title !== '')
            {
                $xstrip_by_regex = preg_split('/\r\n|\r|\n/', $strip_by_regex_title);
                $xreplace_regex = preg_split('/\r\n|\r|\n/', $replace_regex_title);
                $xcnt = 0;
                foreach($xstrip_by_regex as $sbr)
                {
                    if(isset($xreplace_regex[$xcnt]))
                    {
                        $repreg = $xreplace_regex[$xcnt];
                    }
                    else
                    {
                        $repreg = '';
                    }
                    $xcnt++;
                    $temp_cont_title = preg_replace("~" . $sbr . "~i", $repreg, $post['title']);
                    if($temp_cont_title !== NULL)
                    {
                        $post['title'] = $temp_cont_title;
                    }
                }
            }
            $post['content'] = str_replace('</ iframe>', '</iframe>', $post['content']);
            if ($keep_source == '1')
            {
                $post['content'] = preg_replace('{"https:\/\/translate.google.com\/translate\?hl=(?:.*?)&prev=_t&sl=(?:.*?)&tl=(?:.*?)&u=([^"]*?)"}i', "$1", urldecode($post['content']));
            }
            if (isset($myfeeds_Main_Settings['strip_html']) && $myfeeds_Main_Settings['strip_html'] == 'on') {
                $post['content'] = myfeeds_strip_html_tags($post['content']);
            } 
        }
        if (isset($myfeeds_Main_Settings['skip_old']) && $myfeeds_Main_Settings['skip_old'] == 'on' && isset($myfeeds_Main_Settings['skip_year']) && $myfeeds_Main_Settings['skip_year'] !== '' && isset($myfeeds_Main_Settings['skip_month']) && isset($myfeeds_Main_Settings['skip_day'])) {
            $old_date      = $myfeeds_Main_Settings['skip_day'] . '-' . $myfeeds_Main_Settings['skip_month'] . '-' . $myfeeds_Main_Settings['skip_year'];
            $time_date     = strtotime($date);
            $time_old_date = strtotime($old_date);
            if ($time_date !== false && $time_old_date !== false) {
                if ($time_date < $time_old_date) {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('Skipping post "' . esc_html($title) . '", because it is older than ' . $old_date . ' - posted on ' . $date);
                    }
                    $skip = true;
                }
            }
        }
        if($post['title'] == '')
        {
            $h1s = $dom->getElementsByTagName('h1');
            $title = '';
            foreach ($h1s as $h1) {
                $title .= $h1->nodeValue;
            }
            if($title == '' && $post['content'] != '')
            {
                $title = myfeeds_wp_trim_words($post['content'], 10);
            }
            $post['title'] = $title;
        }
        foreach($crawl_title_exclude as $cret)
        {
            if($cret != '')
            {
                if(stristr($post['title'], $cret) !== false)
                {
                    myfeeds_log_to_file('Skipping ' . $post['title'] . ' because it is excluded from crawling by title.');
                    return array();
                }
            }
        }
        if($skip != true)
        {
            if($image_type != 'disabled')
            {
                if($image_getname == '' || $image_type == 'auto' || $image_type == 'og')
                {
                    if($image_type == 'og')
                    {
                        $skip_og = '0';
                    }
                    $post['image'] = myfeeds_get_featured_image($html_cont, $dom, $skip_og, $skip_post_content, $url, $lazy_tag);
                }
                else
                {
                    $temp_image = myfeeds_get_content($image_type, $image_getname, $html_cont, true);
                    if($temp_image != '')
                    {
                        if(filter_var(trim($temp_image), FILTER_VALIDATE_URL))
                        {
                            $post['image'] = trim($temp_image);
                        }
                        else
                        {
                            $tmpdoc = new DOMDocument();
                            $internalErrors = libxml_use_internal_errors(true);
                            $tmpdoc->loadHTML($temp_image);
                            libxml_use_internal_errors($internalErrors);
                            $imageTags = $tmpdoc->getElementsByTagName('img');
                            if(count($imageTags) > 0)
                            {
                                if($imageTags[0] !== null)
                                {
                                    if($lazy_tag == '')
                                    {
                                        $lazy_tag = 'src';
                                    }
                                    $post['image'] = $imageTags[0]->getAttribute($lazy_tag);
                                    if($post['image'] == '' && $lazy_tag != 'src')
                                    {
                                        $post['image'] = $imageTags[0]->getAttribute('src');
                                    }
                                    if($post['image'] == '')
                                    {
                                        preg_match('@src=["\']([^"\']+)["\']@i', $temp_image, $match);
                                        if(isset($match[1]) && $match[1] != '')
                                        {
                                            $post['image'] = $match[1];
                                        }
                                    }
                                    if($post['image'] == '')
                                    {
                                        $post['image'] = myfeeds_get_featured_image($html_cont, $dom, $skip_og, $skip_post_content, $url, $lazy_tag);
                                    }
                                }
                                else
                                {
                                    preg_match('@src=["\']([^"\']+)["\']@i', $temp_image, $match);
                                    if(isset($match[1]) && $match[1] != '')
                                    {
                                        $post['image'] = $match[1];
                                    }
                                    if(!isset($post['image']) || $post['image'] == '')
                                    {
                                        $post['image'] = myfeeds_get_featured_image($html_cont, $dom, $skip_og, $skip_post_content, $url, $lazy_tag);
                                    }
                                }
                            }
                            else
                            {
                                preg_match('@src=["\']([^"\']+)["\']@i', $temp_image, $match);
                                if(isset($match[1]) && $match[1] != '')
                                {
                                    $post['image'] = $match[1];
                                }
                                if(!isset($post['image']) || $post['image'] == '')
                                {
                                    $post['image'] = myfeeds_get_featured_image($html_cont, $dom, $skip_og, $skip_post_content, $url, $lazy_tag);
                                }
                            }
                            unset($tmpdoc);
                        }
                    }
                }
            }
            if(isset($post['image']) && $post['image'] != '')
            {
                if(stristr($post['image'], 'http:') === FALSE && stristr($post['image'], 'www.') === FALSE && stristr($post['image'], 'https:') === FALSE)
                {
                    $my_url  = parse_url($url);
                    $my_host = $my_url['host'];
                    $post['image'] = trim($post['image']);
                    if(preg_match('{^//}', $post['image'])){
                        $post['image'] = 'http:'.$post['image'];
                    }elseif( preg_match('{^/}', $post['image']) ){
                        $post['image'] = 'http://'.$my_host.$post['image'];
                    }else{
                        $post['image'] = 'http://'.$my_host.'/'.$post['image'];
                    }
                }
            }
            
            if(isset($post['image']) && $post['image'] != '')
            {
                $img_found = true;
                if(substr($post['image'], 0, 1) === "/")
                {
                    if(substr($post['image'], 1, 1) === "/")
                    {
                        $post['image'] = 'http:' . $post['image'];
                    }
                    else
                    {
                        $post['image'] = preg_replace('{\/(.*)}', myfeeds_get_url_domain($url) . '/$1', $post['image']);
                    }
                    $post['content'] = preg_replace('{"\/([^\/].+?)"}', '"' . myfeeds_get_url_domain($url) . '/$1"', $post['content']);
                }
            }
            
            if($royalty_free == '1')
            {
                $keyword_class = new myfeeds_keywords();
                $query_words = $keyword_class->keywords($post['title'], 2);
                $get_imgx = myfeeds_get_free_image($myfeeds_Main_Settings, $query_words, $img_attr, 10);
                if($get_imgx == '' || $get_imgx === false)
                {
                    if(isset($myfeeds_Main_Settings['bimage']) && $myfeeds_Main_Settings['bimage'] == 'on')
                    {
                        $query_words = $keyword_class->keywords($post['title'], 1);
                        $get_imgx = myfeeds_get_free_image($myfeeds_Main_Settings, $query_words, $img_attr, 20);
                        if($get_imgx == '' || $get_imgx === false)
                        {
                            if(isset($myfeeds_Main_Settings['no_orig']) && $myfeeds_Main_Settings['no_orig'] == 'on')
                            {
                                $get_imgx = '';
                            }
                            else
                            {
                                $item['image'] = $get_imgx;
                            }
                        }
                    }
                    else
                    {
                        if(isset($myfeeds_Main_Settings['no_orig']) && $myfeeds_Main_Settings['no_orig'] == 'on')
                        {
                            $get_imgx = '';
                        }
                        
                    }
                }
                else
                {
                    $item['image'] = $get_imgx;
                }
            }
            if (isset($myfeeds_Main_Settings['skip_image_names']) && $myfeeds_Main_Settings['skip_image_names'] != '' && $post['image'] != '') 
            {
                $need_to_continue = false;
                $skip_images = explode(',', $myfeeds_Main_Settings['skip_image_names']);
                foreach($skip_images as $ski)
                {
                    if(myfeeds_stringMatchWithWildcard($post['image'], trim($ski)))
                    {
                        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                            myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because it has excluded image name: ' . $post['image'] . ' - ' . $ski);
                        }
                        $need_to_continue = true;
                        break;
                    }
                }
                if($need_to_continue == true)
                {
                    $skip = true;
                }
            }
            if (isset($myfeeds_Main_Settings['skip_no_img']) && $myfeeds_Main_Settings['skip_no_img'] == 'on' && $img_found == false) {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('Skipping post "' . esc_html($post['title']) . '", because it has no detected image file attached');
                }
                $skip = true;
            }
            if(isset($post['image']) && substr($post['image'], 0, 2) === "//")
            {
                if(substr($url, 0, 5) === "https")
                {
                    $post['image'] = 'https:' . $post['image'];
                }
                else
                {
                    $post['image'] = 'http:' . $post['image'];
                }
            }
            
            if($regex_image == '1')
            {
                if ($strip_by_regex !== '')
                {
                    $xstrip_by_regex = preg_split('/\r\n|\r|\n/', $strip_by_regex);
                    $xreplace_regex = preg_split('/\r\n|\r|\n/', $replace_regex);
                    $xcnt = 0;
                    foreach($xstrip_by_regex as $sbr)
                    {
                        if(isset($xreplace_regex[$xcnt]))
                        {
                            $repreg = $xreplace_regex[$xcnt];
                        }
                        else
                        {
                            $repreg = '';
                        }
                        $xcnt++;
                        $temp_cont = preg_replace("~" . $sbr . "~i", $repreg, $post['image']);
                        if($temp_cont !== NULL)
                        {
                            $post['image'] = $temp_cont;
                        }
                    }
                }
            }
            if(!isset($post['image']) || $post['image'] == '')
            {
                if ($image_url != '') 
                {
                    $replacement = str_replace(array('[', ']'), '', $post['title']);
                    $image_url_temp = str_replace('%%item_title%%', $replacement, $image_url);
                    $image_url_temp = preg_replace_callback('#%%random_image\[([^\]]*?)\]%%#', function ($matches) {
                        $my_img = myfeeds_get_random_image_google($matches[1]);
                        return $my_img;
                    }, $image_url_temp);
                    $image_urlx = explode(',', $image_url_temp);
                    $image_urlx = trim($image_urlx[array_rand($image_urlx)]);
                    if($image_urlx != '')
                    {
                        $post['image'] = $image_urlx;
                    }
                }
            }
            if(trim($custom_crawling_expre) != '')
            {
                $custom_crawling_arr = preg_split('/\r\n|\r|\n/', trim($custom_crawling_expre));
                foreach($custom_crawling_arr as $cca)
                {
                    //shortcode_name => [class/id/xpath/regex] @@ [class/id/xpath/regex expression]
                    if(trim($cca) != '')
                    {
                        $cshortcode_name = explode('=>', $cca);
                        if(isset($cshortcode_name[1]))
                        {
                            $shortcode_name = trim($cshortcode_name[0]);
                            if(strstr($cshortcode_name[1], '@@'))
                            {
                                $xshortcode_args = explode('@@', $cshortcode_name[1]);
                                if(isset($xshortcode_args[1]) && trim($xshortcode_args[0]) != '' && trim($xshortcode_args[1]) != '')
                                {
                                    $extended_content = myfeeds_get_content(trim($xshortcode_args[0]), trim($xshortcode_args[1]), $html_cont, false);
                                    if($extended_content != '')
                                    {
                                        $custom_shortcode_final[$shortcode_name] = $extended_content;
                                    }
                                    else
                                    {
                                        $custom_shortcode_final[$shortcode_name] = '';
                                    }
                                }
                                else
                                {
                                    $custom_shortcode_final[$shortcode_name] = '';
                                }
                            }
                            else
                            {
                                $custom_shortcode_final[$shortcode_name] = '';
                            }
                        }
                    }
                }
            }
            if($url_expre == '' || $url_type == 'url' || $url_type == '')
            {
            }
            else
            {
                $temp_url = myfeeds_get_content($url_type, $url_expre, $html_cont, true);
                if($temp_url !== false)
                {
                    if (preg_match('#href=[\'"]([^\'"]*?)[\'"]#', $temp_url, $m)) 
                    {
                        if(isset($m[1]))
                        {
                            $temp_url = trim($m[1]);
                        }
                    }
                }
                if($temp_url !== false && filter_var($temp_url, FILTER_VALIDATE_URL))
                {
                    if(isset($myfeeds_Main_Settings['shortest_api']) && $myfeeds_Main_Settings['shortest_api'] != '')
                    {
                        $short_url = myfeeds_url_handle($temp_url, $myfeeds_Main_Settings['shortest_api']);
                    }
                    else
                    {
                        $short_url = $temp_url;
                    }
                    $post['short_url'] = $short_url;
                    $post['url'] = $temp_url;
                }
            }
            if($date_getname == '' || $date_type == 'current')
            {
                $post['date'] = date("Y-m-d H:i:s", time());
            }
            else
            {
                $temp_date = myfeeds_get_content($date_type, $date_getname, $html_cont, true);
                $temp_date = myfeeds_wp_trim_words($temp_date, 99999);
                $temp_date = strtotime($temp_date);
                if($temp_date !== false)
                {
                    $post['date'] = date("Y-m-d H:i:s", $temp_date);
                }
                else
                {
                    $post['date'] = date("Y-m-d H:i:s", time());
                }
            }
            if($cat_getname == '' || $cat_type == 'disabled')
            {
                $post['categories'] = array();
            }
            else
            {
                $temp_categories = myfeeds_get_content($cat_type, $cat_getname, $html_cont);
                $temp_categories = myfeeds_wp_trim_words($temp_categories, 99999);
                $post['categories'] = explode($cat_sep, $temp_categories);
                if($post['categories'] == '')
                {
                    $post['categories'] = array();
                }
            }
        }
    }
    if($default_category != '')
    {
        $cat_add = explode(',', $default_category);
        $cat_add = array_map('trim', $cat_add);
        $post['categories'] = array_merge($post['categories'], $cat_add);
    }
    if($remove_cats != '')
    {
        $cat_rm = explode(',', $remove_cats);
        $cat_rm = array_map('trim', $cat_rm);
        $post['categories'] = array_diff($post['categories'], $cat_rm);
    }
    
    $custom_tag_final = array();
    if(trim($custom_tag_expre) != '')
    {
        $custom_tag_arr = preg_split('/\r\n|\r|\n/', trim($custom_tag_expre));
        foreach($custom_tag_arr as $cca)
        {
            //tag_name => tag_value
            if(trim($cca) != '')
            {
                $ctag_name = explode('=>', $cca);
                if(isset($ctag_name[1]))
                {
                    $tag_name = trim($ctag_name[0]);
                    $custom_tag_final[htmlentities(str_replace('\\', '\\\\', $tag_name), ENT_QUOTES)] = htmlentities(str_replace('\\', '\\\\', myfeeds_replaceContentShortcodes(trim($ctag_name[1]), $post['title'], $post['content'], $short_url, $post['categories'], $post['image'], $read_more, $post['date'], $img_attr, $custom_shortcode_final, $feed_title, $feed_description)), ENT_QUOTES);
                }
            }
        }
    }
    $post['custom_tag'] = $custom_tag_final;
    if (strpos($post_content, '%%') !== false) {
        $post['final_content'] = myfeeds_replaceContentShortcodes($post_content, $post['title'], $post['content'], $short_url, $post['categories'], $post['image'], $read_more, $post['date'], $img_attr, $custom_shortcode_final, $feed_title, $feed_description);
    } else {
        $post['final_content'] = $post_content;
    }
    if (strpos($post_title, '%%') !== false) {
        $post['final_title'] = myfeeds_replaceContentShortcodes($post_title, $post['title'], $post['content'], $short_url, $post['categories'], $post['image'], $read_more, $post['date'], $img_attr, $custom_shortcode_final, $feed_title, $feed_description);
    } else {
        $post['final_title'] = $post_title;
    }
    $arr                         = myfeeds_spin_and_translate($post['final_title'], $post['final_content'], $translate, $source_lang, $use_proxy);
    $post['final_title']              = $arr[0];
    $post['final_content']            = $arr[1];
    $post['final_title']              = html_entity_decode($post['final_title']);
    $post['final_content']            = html_entity_decode($post['final_content']);
    $tmp_pc = array();
    foreach($post['categories'] as $tpc)
    {
        $tmp_pc[] = htmlentities(str_replace('\\', '\\\\', $tpc), ENT_QUOTES);
    }
    $post['categories'] = $tmp_pc;
    $post['title'] = htmlentities(str_replace('\\', '\\\\', $post['title']), ENT_QUOTES);
    $post['content'] = htmlentities(str_replace('\\', '\\\\', $post['content']), ENT_QUOTES);
    $post['final_title'] = htmlentities(str_replace('\\', '\\\\', $post['final_title']), ENT_QUOTES);
    $post['final_content'] = htmlentities(str_replace('\\', '\\\\', $post['final_content']), ENT_QUOTES);

    if($skip === false)
    {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('URL scraped: ' . $url); 
        }
        $posts[] = $post;
    }
    if(count($posts) == $max)
    {
        $GLOBALS['crawl_done'] = true;
        return $posts;
    }
    if($depth - 1 > 0 && $seed_type != 'disabled')
    {
        $anchors = array();
        if($GLOBALS['seed'] === true)
        {
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Crawling seed page for links: ' . $url); 
            }
            if($seed_expre != '')
            {
                if ($seed_type == 'xpath' || $seed_type == 'visual') 
                {
                    $dom_xpath = new DOMXpath($dom);
                    $elements = $dom_xpath->query($seed_expre);
                    
                    foreach($elements as $el) {
                        if(isset($el->tagName) && $el->tagName === 'a')
                        {
                            $anchors[] = $el;
                        }
                        else
                        {
                            $ancs = $el->getElementsByTagName('a');
                            foreach($ancs as $as)
                            {
                                $anchors[] = $as;
                            }
                        }
                    }
                }
                elseif ($seed_type == 'regex') 
                {
                    $matches     = array();
                    preg_match_all($seed_expre, $html_cont, $matches);
                    if(isset($matches[0][0]))
                    {
                        foreach ($matches[0] as $match) {
                            $el = $dom->createElement('a', 'link');
                            $el->setAttribute('href', trim($match));
                            $anchors[] = $el;
                            $el = '';
                        }
                    }
                    else
                    {
                        preg_match_all('#' . $seed_expre . '#', $html_cont, $matches);
                        if(isset($matches[0][0]))
                        {
                            foreach ($matches[0] as $match) {
                                $el = $dom->createElement('a', 'link');
                                $el->setAttribute('href', trim($match));
                                $anchors[] = $el;
                                $el = '';
                            }
                        }
                    }
                }
                elseif($seed_type == 'regex2')
                {
                    $matches     = array();
                    preg_match_all($seed_expre, $html_cont, $matches);
                    if(isset($matches[1][0]))
                    {
                        for ($i = 1; $i < count($matches); $i++) 
                        {
                            foreach ($matches[$i] as $match) {
                                $el = $dom->createElement('a', 'link');
                                $el->setAttribute('href', trim($match));
                                $anchors[] = $el;
                                $el = '';
                            }
                        }
                    }
                    else
                    {
                        preg_match_all('#' . $seed_expre . '#', $html_cont, $matches);
                        if(isset($matches[1][0]))
                        {
                            for ($i = 1; $i < count($matches); $i++) 
                            {
                                foreach ($matches[$i] as $match) {
                                    $el = $dom->createElement('a', 'link');
                                    $el->setAttribute('href', trim($match));
                                    $anchors[] = $el;
                                    $el = '';
                                }
                            }
                        }
                    }
                }
                else
                {
                    if($seed_type == 'id')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[@'.$seed_type.'="'.trim($seed_expre).'"]');
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                    elseif($seed_type == 'class')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[contains(concat(" ", normalize-space(@class), " "), " '.trim($seed_expre).' ")]');
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                    elseif($seed_type != '')
                    {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query('//*[@'.$seed_type.'="'.trim($seed_expre).'"]');
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                $anchors = $dom->getElementsByTagName('a');
            }
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                if(count($anchors) > 0)
                {
                    myfeeds_log_to_file('Links returned: ');
                    $cnter = 0;
                    foreach($anchors as $element)
                    {
                        myfeeds_log_to_file($cnter . '. ' . $element->getAttribute('href'));
                        $cnter++;
                    }
                }
            }
        }
        else
        {
            if ($crawled_type != 'disabled')
            {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
                {
                    myfeeds_log_to_file('Crawling leaf page for links: ' . $url); 
                }
                if($crawled_expre != '')
                {
                    if ($crawled_type == 'xpath' || $crawled_type == 'visual') {
                        $dom_xpath = new DOMXpath($dom);
                        $elements = $dom_xpath->query($crawled_expre);
                        foreach($elements as $el) {
                            if(isset($el->tagName) && $el->tagName === 'a')
                            {
                                $anchors[] = $el;
                            }
                            else
                            {
                                $ancs = $el->getElementsByTagName('a');
                                foreach($ancs as $as)
                                {
                                    $anchors[] = $as;
                                }
                            }
                        }
                    }
                    elseif($crawled_type == 'regex')
                    {
                        $matches     = array();
                        preg_match_all($crawled_expre, $html_cont, $matches);
                        if(isset($matches[0][0]))
                        {
                            foreach ($matches[0] as $match) {
                                $el = $dom->createElement('a', 'link');
                                $el->setAttribute('href', trim($match));
                                $anchors[] = $el;
                                $el = '';
                            }
                        }
                        else
                        {
                            preg_match_all('#' . $crawled_expre . '#', $html_cont, $matches);
                            if(isset($matches[0][0]))
                            {
                                foreach ($matches[0] as $match) {
                                    $el = $dom->createElement('a', 'link');
                                    $el->setAttribute('href', trim($match));
                                    $anchors[] = $el;
                                    $el = '';
                                }
                            }
                        }
                    }
                    elseif($crawled_type == 'regex2')
                    {
                        $matches     = array();
                        preg_match_all($crawled_expre, $html_cont, $matches);
                        if(isset($matches[1][0]))
                        {
                            for ($i = 1; $i < count($matches); $i++) 
                            {
                                foreach ($matches[$i] as $match) {
                                    $el = $dom->createElement('a', 'link');
                                    $el->setAttribute('href', trim($match));
                                    $anchors[] = $el;
                                    $el = '';
                                }
                            }
                        }
                        else
                        {
                            preg_match_all('#' . $crawled_expre . '#', $html_cont, $matches);
                            if(isset($matches[1][0]))
                            {
                                for ($i = 1; $i < count($matches); $i++) 
                                {
                                    foreach ($matches[$i] as $match) {
                                        $el = $dom->createElement('a', 'link');
                                        $el->setAttribute('href', trim($match));
                                        $anchors[] = $el;
                                        $el = '';
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if($crawled_type == 'class')
                        {
                            $dom_xpath = new DOMXpath($dom);
                            $elements = $dom_xpath->query('//*[contains(concat(" ", normalize-space(@class), " "), " '.trim($crawled_expre).' ")]');
                            foreach($elements as $el) {
                                if(isset($el->tagName) && $el->tagName === 'a')
                                {
                                    $anchors[] = $el;
                                }
                                else
                                {
                                    $ancs = $el->getElementsByTagName('a');
                                    foreach($ancs as $as)
                                    {
                                        $anchors[] = $as;
                                    }
                                }
                            }
                        }
                        elseif($crawled_type != '')
                        {
                            $dom_xpath = new DOMXpath($dom);
                            $elements = $dom_xpath->query('//*[@'.$crawled_type.'="'.trim($crawled_expre).'"]');
                            foreach($elements as $el) {
                                if(isset($el->tagName) && $el->tagName === 'a')
                                {
                                    $anchors[] = $el;
                                }
                                else
                                {
                                    $ancs = $el->getElementsByTagName('a');
                                    foreach($ancs as $as)
                                    {
                                        $anchors[] = $as;
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    $anchors = $dom->getElementsByTagName('a');
                }
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
                {
                    if(count($anchors) > 0)
                    {
                        myfeeds_log_to_file('Links returned: ');
                        $cnter = 0;
                        foreach($anchors as $element)
                        {
                            myfeeds_log_to_file($cnter . '. ' . $element->getAttribute('href'));
                            $cnter++;
                        }
                    }
                }
            }
        }
        $GLOBALS['seed'] = false;
        if($only_class != '')
        {
            $only_c = explode(',', $only_class);
        }
        else
        {
            $only_c = array();
        }
        if($only_id != '')
        {
            $only_i = explode(',', $only_id);
        }
        else
        {
            $only_i = array();
        }
        if($reverse_crawl == '1')
        {
            $anchors = array_reverse($anchors);
        }
        if($no_link_scraper == '1')
        {
            foreach ($anchors as $element) 
            {
                $lpost= array();
                $href = $element->getAttribute('href');
                if($href == '#' || $href === rtrim($url, '/') . '/#')
                {
                    continue;
                }
                $href = myfeeds_generate_valid_url($href, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                if($no_external == '1')
                {
                    if(myfeeds_isExternal($href, $url) != 0)
                    {
                        continue;
                    }
                }
                $need_continue = false;
                foreach($crawl_exclude as $crex)
                {
                    if($crex != '')
                    {
                        if(stristr($href, $crex) !== false)
                        {
                            $need_continue = true;
                            break;
                        }
                    }
                }
                if($need_continue == true)
                {
                    continue;
                }
                if(isset($myfeeds_Main_Settings['shortest_api']) && $myfeeds_Main_Settings['shortest_api'] != '')
                {
                    $short_url = myfeeds_url_handle($href, $myfeeds_Main_Settings['shortest_api']);
                }
                else
                {
                    $short_url = $href;
                }
                $lpost['short_url'] = $short_url;
                $lpost['url'] = $href;
                $posts[] = $lpost;
                if(count($posts) == $max)
                {
                    $GLOBALS['crawl_done'] = true;
                    return $posts;
                }
            }
        }
        else
        {
            foreach ($anchors as $element) {
                if($GLOBALS['crawl_done'] === true)
                {
                    break;
                }
                $tfound = false;
                if($only_class != '')
                {
                    $class_name = $element->getAttribute('class'); 
                    foreach($only_c as $oc)
                    {
                        $oc = trim($oc);
                        if($oc == $class_name)
                        {
                            $tfound = true;
                        }
                    }
                }
                if($only_id != '')
                {
                    $id_name = $element->getAttribute('id');
                    foreach($only_i as $oi)
                    {
                        $oi = trim($oi);
                        if($oi == $id_name)
                        {
                            $tfound = true;
                        }
                    }
                }
                if(($only_id != '' || $only_class != '') && $tfound === false)
                {
                    continue;
                }
                $href = $element->getAttribute('href');
                if($href == '#' || $href === rtrim($url, '/') . '/#')
                {
                    continue;
                }
                $href = myfeeds_generate_valid_url($href, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                if($no_external == '1')
                {
                    if(myfeeds_isExternal($href, $url) != 0)
                    {
                        continue;
                    }
                }
                myfeeds_crawl_page($href, $max, $skip_og, $skip_post_content, $no_external, $required_words, $banned_words, $type, $getname, $title_type, $title_getname, $image_type, $image_getname, $date_type, $date_getname, $cat_type, $cat_getname, $depth - 1, $custom_cookies, $only_class, $only_id, $no_source, $seed_type, $seed_expre, $crawled_type, $crawled_expre, $paged_crawl_str, $paged_crawl_type, $max_paged_depth, $custom_user_agent, $cat_sep, false, $seed_pag_type, $seed_pag_expre, false, $use_proxy, $use_phantom, $user_pass, $crawl_exclude, $crawl_title_exclude, $price_sep, $encoding, $reverse_crawl, $lazy_tag, $phantom_wait, $param, $continue_search, $strip_links, $royalty_free, $strip_by_id, $strip_by_class, $strip_by_xpath, $strip_by_tag, $only_text, $allow_html_tags, $content_percent, $replace_words, $strip_images, $limit_word_count, $read_more, $strip_by_regex, $strip_by_regex_title, $keep_source, $post_content, $post_title, $translate, $source_lang, $default_category, $remove_cats, $author_type, $author_expre, $custom_crawling_expre, $custom_tag_expre, $url_type, $url_expre, $feed_title, $feed_description, $regex_image, $replace_regex, $replace_regex_title, $skip_no_match, $no_link_scraper, $image_url);
            }
        }
    }
    else
    {
        $GLOBALS['seed'] = false;
    }
    if($root_page === true && count($posts) < $max && $seed_pag_type !== 'disabled' && $seed_type !== 'disabled')
    {
        $xanchors = array();
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Crawling seed pagination for links: ' . $url); 
        }
        if($seed_pag_expre != '' && $seed_pag_type != '' && $seed_pag_type != '1')
        {
            if ($seed_pag_type == 'xpath' || $seed_pag_type == 'visual') {
                $dom_xpath = new DOMXpath($dom);
                $elements = $dom_xpath->query($seed_pag_expre);
                foreach($elements as $el) {
                    if(isset($el->tagName) && $el->tagName === 'a')
                    {
                        $href_val = $el->getAttribute('href');
                        $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                        if($href_val != '')
                        {
                            if(!isset($already_paginated[$href_val]))
                            {
                                $already_paginated[$href_val] = '1';
                                $xanchors[] = $el;
                            }
                        }
                        else
                        {
                            if(!in_array($el, $already_paginated))
                            {
                                $already_paginated[] = $el;
                                $xanchors[] = $el;
                            }
                        }
                    }
                    else
                    {
                        $ancs = $el->getElementsByTagName('a');
                        foreach($ancs as $as)
                        {
                            $href_val = $as->getAttribute('href');
                            $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $as;
                                }
                            }
                            else
                            {
                                if(!in_array($as, $already_paginated))
                                {
                                    $already_paginated[] = $as;
                                    $xanchors[] = $as;
                                }
                            }
                        }
                    }
                }
            }
            elseif ($seed_pag_type == 'regex') {
                $matches     = array();
                preg_match_all($seed_pag_expre, $html_cont, $matches);
                if(isset($matches[0][0]))
                {
                    foreach ($matches[0] as $match) {
                        $el = $dom->createElement('a', 'link');
                        $href_val = myfeeds_generate_valid_url(trim($match), $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                        if($href_val != '')
                        {
                            $el->setAttribute('href', trim($href_val));
                            if(!isset($already_paginated[$href_val]))
                            {
                                $already_paginated[$href_val] = '1';
                                $xanchors[] = $el;
                            }
                        }
                        else
                        {
                            $el->setAttribute('href', trim($match));
                            if(!in_array($el, $already_paginated))
                            {
                                $already_paginated[] = $el;
                                $xanchors[] = $el;
                            }
                        }
                        $el = '';
                    }
                }
                else
                {
                    preg_match_all('#' . $seed_pag_expre . '#', $html_cont, $matches);
                    if(isset($matches[0][0]))
                    {
                        foreach ($matches[0] as $match) {
                            $el = $dom->createElement('a', 'link');
                            $href_val = myfeeds_generate_valid_url(trim($match), $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                $el->setAttribute('href', trim($href_val));
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $el;
                                }
                            }
                            else
                            {
                                $el->setAttribute('href', trim($match));
                                if(!in_array($el, $already_paginated))
                                {
                                    $already_paginated[] = $el;
                                    $xanchors[] = $el;
                                }
                            }
                            $el = '';
                        }
                    }
                }
            }
            elseif ($seed_pag_type == 'regex2') {
                $matches     = array();
                preg_match_all($seed_pag_expre, $html_cont, $matches);
                if(isset($matches[1][0]))
                {
                    for ($i = 1; $i < count($matches); $i++)
                    {
                        foreach ($matches[$i] as $match) 
                        {
                            $el = $dom->createElement('a', 'link');
                            $href_val = myfeeds_generate_valid_url(trim($match), $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                $el->setAttribute('href', trim($href_val));
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $el;
                                }
                            }
                            else
                            {
                                $el->setAttribute('href', trim($match));
                                if(!in_array($el, $already_paginated))
                                {
                                    $already_paginated[] = $el;
                                    $xanchors[] = $el;
                                }
                            }
                            $el = '';
                        }
                    }
                }
                else
                {
                    preg_match_all('#' . $seed_pag_expre . '#', $html_cont, $matches);
                    if(isset($matches[1][0]))
                    {
                        for ($i = 1; $i < count($matches); $i++)
                        {
                            foreach ($matches[$i] as $match) 
                            {
                                $el = $dom->createElement('a', 'link');
                                $href_val = myfeeds_generate_valid_url(trim($match), $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                                if($href_val != '')
                                {
                                    $el->setAttribute('href', trim($href_val));
                                    if(!isset($already_paginated[$href_val]))
                                    {
                                        $already_paginated[$href_val] = '1';
                                        $xanchors[] = $el;
                                    }
                                }
                                else
                                {
                                    $el->setAttribute('href', trim($match));
                                    if(!in_array($el, $already_paginated))
                                    {
                                        $already_paginated[] = $el;
                                        $xanchors[] = $el;
                                    }
                                }
                                $el = '';
                            }
                        }
                    }
                }
            }
            else
            {
                if($seed_pag_type == 'class')
                {
                    $dom_xpath = new DOMXpath($dom);
                    $elements = $dom_xpath->query('//*[contains(concat(" ", normalize-space(@class), " "), " '.trim($seed_pag_expre).' ")]');
                    foreach($elements as $el) {
                        if(isset($el->tagName) && $el->tagName === 'a')
                        {
                            $href_val = $el->getAttribute('href');
                            $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $el;
                                }
                            }
                            else
                            {
                                if(!in_array($el, $already_paginated))
                                {
                                    $already_paginated[] = $el;
                                    $xanchors[] = $el;
                                }
                            }
                        }
                        else
                        {
                            $ancs = $el->getElementsByTagName('a');
                            foreach($ancs as $as)
                            {
                                $href_val = $as->getAttribute('href');
                                $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                                if($href_val != '')
                                {
                                    if(!isset($already_paginated[$href_val]))
                                    {
                                        $already_paginated[$href_val] = '1';
                                        $xanchors[] = $as;
                                    }
                                }
                                else
                                {
                                    if(!in_array($as, $already_paginated))
                                    {
                                        $already_paginated[] = $as;
                                        $xanchors[] = $as;
                                    }
                                }
                            }
                        }
                    }
                }
                elseif($seed_pag_type == 'auto')
                {
                    $dom_xpath = new DOMXpath($dom);
                    $elements = $dom_xpath->query('//body//a');
                    foreach($elements as $el) {
                        if(isset($el->tagName) && $el->tagName === 'a')
                        {
                            $href_val = $el->getAttribute('href');
                            $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $el;
                                }
                            }
                            else
                            {
                                if(!in_array($el, $already_paginated))
                                {
                                    $already_paginated[] = $el;
                                    $xanchors[] = $el;
                                }
                            }
                        }
                        else
                        {
                            $ancs = $el->getElementsByTagName('a');
                            foreach($ancs as $as)
                            {
                                $href_val = $as->getAttribute('href');
                                $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                                if($href_val != '')
                                {
                                    if(!isset($already_paginated[$href_val]))
                                    {
                                        $already_paginated[$href_val] = '1';
                                        $xanchors[] = $as;
                                    }
                                }
                                else
                                {
                                    if(!in_array($as, $already_paginated))
                                    {
                                        $already_paginated[] = $as;
                                        $xanchors[] = $as;
                                    }
                                }
                            }
                        }
                    }
                }
                elseif($seed_pag_type != '')
                {
                    $dom_xpath = new DOMXpath($dom);
                    $elements = $dom_xpath->query('//*[@'.$seed_pag_type.'="'.trim($seed_pag_expre).'"]');
                    foreach($elements as $el) {
                        if(isset($el->tagName) && $el->tagName === 'a')
                        {
                            $href_val = $el->getAttribute('href');
                            $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                            if($href_val != '')
                            {
                                if(!isset($already_paginated[$href_val]))
                                {
                                    $already_paginated[$href_val] = '1';
                                    $xanchors[] = $el;
                                }
                            }
                            else
                            {
                                if(!in_array($el, $already_paginated))
                                {
                                    $already_paginated[] = $el;
                                    $xanchors[] = $el;
                                }
                            }
                        }
                        else
                        {
                            $ancs = $el->getElementsByTagName('a');
                            foreach($ancs as $as)
                            {
                                $href_val = $as->getAttribute('href');
                                $href_val = myfeeds_generate_valid_url($href_val, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
                                if($href_val != '')
                                {
                                    if(!isset($already_paginated[$href_val]))
                                    {
                                        $already_paginated[$href_val] = '1';
                                        $xanchors[] = $as;
                                    }
                                }
                                else
                                {
                                    if(!in_array($as, $already_paginated))
                                    {
                                        $already_paginated[] = $as;
                                        $xanchors[] = $as;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        $skip_posts_temp = get_option('myfeeds_continue_search', array());
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            if($seed_pag_expre != '' && $seed_pag_type != '' && $seed_pag_type != '1')
            {
                if(count($xanchors) > 0)
                {
                    myfeeds_log_to_file('Pagination links returned:');
                    $cnter = 0;
                    foreach($xanchors as $ancas)
                    {
                        myfeeds_log_to_file($cnter . '. ' . $ancas->getAttribute('href'));
                        $cnter++;
                    }
                }
                else
                {
                    myfeeds_log_to_file('No pagination links returned.');
                }
            }
        }
        foreach($xanchors as $ancas)
        {
            
            $ancas = $ancas->getAttribute('href');
            $ancas = myfeeds_generate_valid_url($ancas, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
            if($no_external == '1')
            {
                if(myfeeds_isExternal($ancas, $url) != 0)
                {
                    continue;
                }
            }
            if($continue_search == '1')
            {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('Saving URL for next time crawling (rule ID ' . $param . '): ' . $ancas . '!');
                }
                $skip_posts_temp[$param] = $ancas;
                update_option('myfeeds_continue_search', $skip_posts_temp);
            }
            if(count($posts) >= $max)
            {
                break;
            }
            $GLOBALS['seed'] = true;
            $GLOBALS['crawl_done'] = false;
            if(isset($seen[$ancas]))
            {
                unset($seen[$ancas]);
            }
            myfeeds_crawl_page($ancas, $max, $skip_og, $skip_post_content, $no_external, $required_words, $banned_words, $type, $getname, $title_type, $title_getname, $image_type, $image_getname, $date_type, $date_getname, $cat_type, $cat_getname, $depth, $custom_cookies, $only_class, $only_id, $no_source, $seed_type, $seed_expre, $crawled_type, $crawled_expre, $paged_crawl_str, $paged_crawl_type, $max_paged_depth, $custom_user_agent, $cat_sep, true, $seed_pag_type, $seed_pag_expre, false, $use_proxy, $use_phantom, $user_pass, $crawl_exclude, $crawl_title_exclude, $price_sep, $encoding, $reverse_crawl, $lazy_tag, $phantom_wait, $param, $continue_search, $strip_links, $royalty_free, $strip_by_id, $strip_by_class, $strip_by_xpath, $strip_by_tag, $only_text, $allow_html_tags, $content_percent, $replace_words, $strip_images, $limit_word_count, $read_more, $strip_by_regex, $strip_by_regex_title, $keep_source, $post_content, $post_title, $translate, $source_lang, $default_category, $remove_cats, $author_type, $author_expre, $custom_crawling_expre, $custom_tag_expre, $url_type, $url_expre, $feed_title, $feed_description, $regex_image, $replace_regex, $replace_regex_title, $skip_no_match, $no_link_scraper, $image_url);
        }
    }
    return $posts;
}
function myfeeds_giveHost($host_with_subdomain) {
    $array = explode(".", $host_with_subdomain);
    return (array_key_exists(count($array) - 2, $array) ? $array[count($array) - 2] : "") . "." . $array[count($array) - 1];
}
function myfeeds_isExternal($href, $base)
{
    if(empty($href) || empty($base))
    {
        return 1;
    }
    $components = parse_url($href); 
    $comp_base = parse_url($base);
    if(!isset($components['host']) || !isset($comp_base['host']))
    {
        if(stristr($href, $base) !== false)
        {
            return 0;
        }
        return 1;
    }
    return strcasecmp(myfeeds_giveHost($components['host']), myfeeds_giveHost($comp_base['host']));
}

function myfeeds_get_page_PuppeteerAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $timeout = '')
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['headlessbrowserapi_key']) || trim($myfeeds_Main_Settings['headlessbrowserapi_key']) == '')
    {
        myfeeds_log_to_file('You need to add your HeadlessBrowserAPI key in the plugin\'s \'Main Settings\' before you can use this feature.');
        return false;
    }
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    if($custom_user_agent == '')
    {
        $custom_user_agent = 'default';
    }
    if($custom_cookies == '')
    {
        $custom_cookies = 'default';
    }
    if($user_pass == '')
    {
        $user_pass = 'default';
    }
    if (isset($myfeeds_Main_Settings['phantom_timeout']) && $myfeeds_Main_Settings['phantom_timeout'] != '') 
    {
        $phantomjs_timeout = ((int)$myfeeds_Main_Settings['phantom_timeout']);
    }
    else
    {
        $phantomjs_timeout = 'default';
    }
    $phantomjs_proxcomm = '"null"';
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '') 
    {
        $proxy_url = $myfeeds_Main_Settings['proxy_url'];
        if(isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '')
        {
            $proxy_auth = $myfeeds_Main_Settings['proxy_auth'];
        }
        else
        {
            $proxy_auth = 'default';
        }
    }
    else
    {
        $proxy_url = 'default';
        $proxy_auth = 'default';
    }
    
    $za_api_url = 'https://headlessbrowserapi.com/apis/scrape/v1/puppeteer?apikey=' . trim($myfeeds_Main_Settings['headlessbrowserapi_key']) . '&url=' . urlencode($url) . '&custom_user_agent=' . urlencode($custom_user_agent) . '&custom_cookies=' . urlencode($custom_cookies) . '&user_pass=' . urlencode($user_pass) . '&timeout=' . urlencode($phantomjs_timeout) . '&proxy_url=' . urlencode($proxy_url) . '&proxy_auth=' . urlencode($proxy_auth);
    if($timeout != '')
    {
        $za_api_url .= '&sleep=' . urlencode($timeout);
    }
    $api_timeout = 120;
    $args = array(
       'timeout'     => $api_timeout,
       'redirection' => 10,
       'blocking'    => true,
       'compress'    => false,
       'decompress'  => true,
       'sslverify'   => false,
       'stream'      => false
    );
    $ret_data = wp_remote_get($za_api_url, $args);
    $response_code       = wp_remote_retrieve_response_code( $ret_data );
    $response_message    = wp_remote_retrieve_response_message( $ret_data );    
    if ( 200 != $response_code ) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to get response from HeadlessBrowserAPI: ' . $za_api_url . ' code: ' . $response_code . ' message: ' . $response_message);
            if(isset($ret_data->errors['http_request_failed']))
            {
                foreach($ret_data->errors['http_request_failed'] as $errx)
                {
                    myfeeds_log_to_file('Error message: ' . html_entity_decode($errx));
                }
            }
        }
        return false;
    } else {
        $cmdResult = wp_remote_retrieve_body( $ret_data );
    }
    $jcmdResult = json_decode($cmdResult, true);
    if($jcmdResult === false)
    {
        myfeeds_log_to_file('Failed to decode response from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    $cmdResult = $jcmdResult;
    if(isset($cmdResult['apicalls']))
    {
        update_option('headless_calls', esc_html($cmdResult['apicalls']));
    }
    if(isset($cmdResult['error']))
    {
        myfeeds_log_to_file('An error occurred while getting content from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult['error'], true));
        return false;
    }
    if(!isset($cmdResult['html']))
    {
        myfeeds_log_to_file('Malformed data imported from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    return '<html><body>' . $cmdResult['html'] . '</body></html>';
}
function myfeeds_get_page_TorAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $timeout = '')
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['headlessbrowserapi_key']) || trim($myfeeds_Main_Settings['headlessbrowserapi_key']) == '')
    {
        myfeeds_log_to_file('You need to add your HeadlessBrowserAPI key in the plugin\'s \'Main Settings\' before you can use this feature.');
        return false;
    }
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    if($custom_user_agent == '')
    {
        $custom_user_agent = 'default';
    }
    if($custom_cookies == '')
    {
        $custom_cookies = 'default';
    }
    if($user_pass == '')
    {
        $user_pass = 'default';
    }
    if (isset($myfeeds_Main_Settings['phantom_timeout']) && $myfeeds_Main_Settings['phantom_timeout'] != '') 
    {
        $phantomjs_timeout = ((int)$myfeeds_Main_Settings['phantom_timeout']);
    }
    else
    {
        $phantomjs_timeout = 'default';
    }
    $phantomjs_proxcomm = '"null"';
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '') 
    {
        $proxy_url = $myfeeds_Main_Settings['proxy_url'];
        if(isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '')
        {
            $proxy_auth = $myfeeds_Main_Settings['proxy_auth'];
        }
        else
        {
            $proxy_auth = 'default';
        }
    }
    else
    {
        $proxy_url = 'default';
        $proxy_auth = 'default';
    }
    
    $za_api_url = 'https://headlessbrowserapi.com/apis/scrape/v1/tor?apikey=' . trim($myfeeds_Main_Settings['headlessbrowserapi_key']) . '&url=' . urlencode($url) . '&custom_user_agent=' . urlencode($custom_user_agent) . '&custom_cookies=' . urlencode($custom_cookies) . '&user_pass=' . urlencode($user_pass) . '&timeout=' . urlencode($phantomjs_timeout) . '&proxy_url=' . urlencode($proxy_url) . '&proxy_auth=' . urlencode($proxy_auth);
    if($timeout != '')
    {
        $za_api_url .= '&sleep=' . urlencode($timeout);
    }
    $api_timeout = 120;
    $args = array(
       'timeout'     => $api_timeout,
       'redirection' => 10,
       'blocking'    => true,
       'compress'    => false,
       'decompress'  => true,
       'sslverify'   => false,
       'stream'      => false
    );
    $ret_data = wp_remote_get($za_api_url, $args);
    $response_code       = wp_remote_retrieve_response_code( $ret_data );
    $response_message    = wp_remote_retrieve_response_message( $ret_data );    
    if ( 200 != $response_code ) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to get response from HeadlessBrowserAPI: ' . $za_api_url . ' code: ' . $response_code . ' message: ' . $response_message);
            if(isset($ret_data->errors['http_request_failed']))
            {
                foreach($ret_data->errors['http_request_failed'] as $errx)
                {
                    myfeeds_log_to_file('Error message: ' . html_entity_decode($errx));
                }
            }
        }
        return false;
    } else {
        $cmdResult = wp_remote_retrieve_body( $ret_data );
    }
    $jcmdResult = json_decode($cmdResult, true);
    if($jcmdResult === false)
    {
        myfeeds_log_to_file('Failed to decode response from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    $cmdResult = $jcmdResult;
    if(isset($cmdResult['apicalls']))
    {
        update_option('headless_calls', esc_html($cmdResult['apicalls']));
    }
    if(isset($cmdResult['error']))
    {
        myfeeds_log_to_file('An error occurred while getting content from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult['error'], true));
        return false;
    }
    if(!isset($cmdResult['html']))
    {
        myfeeds_log_to_file('Malformed data imported from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    return '<html><body>' . $cmdResult['html'] . '</body></html>';
}
function myfeeds_get_page_PhantomJSAPI($url, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $timeout = '')
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (!isset($myfeeds_Main_Settings['headlessbrowserapi_key']) || trim($myfeeds_Main_Settings['headlessbrowserapi_key']) == '')
    {
        myfeeds_log_to_file('You need to add your HeadlessBrowserAPI key in the plugin\'s \'Main Settings\' before you can use this feature.');
        return false;
    }
    $delay = '';
    if (isset($myfeeds_Main_Settings['request_delay']) && $myfeeds_Main_Settings['request_delay'] != '') {
        if(stristr($myfeeds_Main_Settings['request_delay'], ',') !== false)
        {
            $tempo = explode(',', $myfeeds_Main_Settings['request_delay']);
            if(isset($tempo[1]) && is_numeric(trim($tempo[1])) && is_numeric(trim($tempo[0])))
            {
                $delay = rand(trim($tempo[0]), trim($tempo[1]));
            }
        }
        else
        {
            if(is_numeric(trim($myfeeds_Main_Settings['request_delay'])))
            {
                $delay = intval(trim($myfeeds_Main_Settings['request_delay']));
            }
        }
    }
    if($delay != '' && is_numeric($delay))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_last_time', 'options');
        $last_time = get_option('myfeeds_last_time', false);
        if($last_time !== false && intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000) > 0)
        {
            $sleep_time = intval(((intval($last_time) - time()) * 1000 + $delay ) * 1000);
            if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                myfeeds_log_to_file('Delay between requests set, waiting ' . ($sleep_time/1000) . ' ms');
            }
            usleep($sleep_time);
        }
    }
    if($custom_user_agent == '')
    {
        $custom_user_agent = 'default';
    }
    if($custom_cookies == '')
    {
        $custom_cookies = 'default';
    }
    if($user_pass == '')
    {
        $user_pass = 'default';
    }
    if (isset($myfeeds_Main_Settings['phantom_timeout']) && $myfeeds_Main_Settings['phantom_timeout'] != '') 
    {
        $phantomjs_timeout = ((int)$myfeeds_Main_Settings['phantom_timeout']);
    }
    else
    {
        $phantomjs_timeout = 'default';
    }
    $phantomjs_proxcomm = '"null"';
    if ($use_proxy == '1' && isset($myfeeds_Main_Settings['proxy_url']) && $myfeeds_Main_Settings['proxy_url'] != '') 
    {
        $proxy_url = $myfeeds_Main_Settings['proxy_url'];
        if(isset($myfeeds_Main_Settings['proxy_auth']) && $myfeeds_Main_Settings['proxy_auth'] != '')
        {
            $proxy_auth = $myfeeds_Main_Settings['proxy_auth'];
        }
        else
        {
            $proxy_auth = 'default';
        }
    }
    else
    {
        $proxy_url = 'default';
        $proxy_auth = 'default';
    }
    
    $za_api_url = 'https://headlessbrowserapi.com/apis/scrape/v1/phantomjs?apikey=' . trim($myfeeds_Main_Settings['headlessbrowserapi_key']) . '&url=' . urlencode($url) . '&custom_user_agent=' . urlencode($custom_user_agent) . '&custom_cookies=' . urlencode($custom_cookies) . '&user_pass=' . urlencode($user_pass) . '&timeout=' . urlencode($phantomjs_timeout) . '&proxy_url=' . urlencode($proxy_url) . '&proxy_auth=' . urlencode($proxy_auth);
    if($timeout != '')
    {
        $za_api_url .= '&sleep=' . urlencode($timeout);
    }
    $api_timeout = 120;
    $args = array(
       'timeout'     => $api_timeout,
       'redirection' => 10,
       'blocking'    => true,
       'compress'    => false,
       'decompress'  => true,
       'sslverify'   => false,
       'stream'      => false
    );
    $ret_data = wp_remote_get($za_api_url, $args);
    $response_code       = wp_remote_retrieve_response_code( $ret_data );
    $response_message    = wp_remote_retrieve_response_message( $ret_data );    
    if ( 200 != $response_code ) {
        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') 
        {
            myfeeds_log_to_file('Failed to get response from HeadlessBrowserAPI: ' . $za_api_url . ' code: ' . $response_code . ' message: ' . $response_message);
            if(isset($ret_data->errors['http_request_failed']))
            {
                foreach($ret_data->errors['http_request_failed'] as $errx)
                {
                    myfeeds_log_to_file('Error message: ' . html_entity_decode($errx));
                }
            }
        }
        return false;
    } else {
        $cmdResult = wp_remote_retrieve_body( $ret_data );
    }
    $jcmdResult = json_decode($cmdResult, true);
    if($jcmdResult === false)
    {
        myfeeds_log_to_file('Failed to decode response from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    $cmdResult = $jcmdResult;
    if(isset($cmdResult['apicalls']))
    {
        update_option('headless_calls', esc_html($cmdResult['apicalls']));
    }
    if(isset($cmdResult['error']))
    {
        myfeeds_log_to_file('An error occurred while getting content from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult['error'], true));
        return false;
    }
    if(!isset($cmdResult['html']))
    {
        myfeeds_log_to_file('Malformed data imported from HeadlessBrowserAPI: ' . $za_api_url . ' - ' . print_r($cmdResult, true));
        return false;
    }
    if($delay != '' && is_numeric($delay))
    {
        update_option('myfeeds_last_time', time());
    }
    return '<html><body>' . $cmdResult['html'] . '</body></html>';
}
function myfeeds_get_paged_content($url, $html_cont, $type, $getname, $paged_crawl_type, $paged_crawl_str, $custom_cookies, $max, $custom_user_agent, $use_proxy, $use_phantom, $user_pass, $phantom_wait)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    static $seen = array();
    $extract = '';
    $anchors = array();
    $seen[$url] = true;
    $domz = new DOMDocument('1.0');
    $internalErrors = libxml_use_internal_errors(true);
    $domz->loadHTML('<?xml encoding="utf-8" ?>' . $html_cont);
    libxml_use_internal_errors($internalErrors);
    if($paged_crawl_str != '')
    {
        if ($paged_crawl_type == 'xpath' || $paged_crawl_type == 'visual') {
            $dom_xpath = new DOMXpath($domz);
            $elements = $dom_xpath->query($paged_crawl_str);
            foreach($elements as $el) {
                if(isset($el->tagName) && $el->tagName === 'a')
                {
                    $anchors[] = $el;
                }
                else
                {
                    $ancs = $el->getElementsByTagName('a');
                    foreach($ancs as $as)
                    {
                        $anchors[] = $as;
                    }
                }
                
            }
        }
        elseif ($paged_crawl_type == 'regex') {
            $matches     = array();
            preg_match_all($paged_crawl_str, $html_cont, $matches);
            if(isset($matches[0][0]))
            {
                 foreach ($matches[0] as $match) {
                    $el = $dom->createElement('a', 'link');
                    $el->setAttribute('href', trim($match));
                    $anchors[] = $el;
                    $el = '';
                }
            }
            else
            {
                preg_match_all('#' . $paged_crawl_str . '#', $html_cont, $matches);
                if(isset($matches[0][0]))
                {
                    foreach ($matches[0] as $match) {
                        $el = $dom->createElement('a', 'link');
                        $el->setAttribute('href', trim($match));
                        $anchors[] = $el;
                        $el = '';
                    }
                }
            }
        }
        elseif ($paged_crawl_type == 'regex2') {
            $matches     = array();
            preg_match_all($paged_crawl_str, $html_cont, $matches);
            if(isset($matches[1][0]))
            {
                for ($i = 1; $i < count($matches); $i++)
                {
                    foreach ($matches[$i] as $match) {
                        $el = $dom->createElement('a', 'link');
                        $el->setAttribute('href', trim($match));
                        $anchors[] = $el;
                        $el = '';
                    }
                }
            }
            else
            {
                preg_match_all('#' . $paged_crawl_str . '#', $html_cont, $matches);
                if(isset($matches[1][0]))
                {
                    for ($i = 1; $i < count($matches); $i++)
                    {
                        foreach ($matches[$i] as $match) {
                            $el = $dom->createElement('a', 'link');
                            $el->setAttribute('href', trim($match));
                            $anchors[] = $el;
                            $el = '';
                        }
                    }
                }
            }
        }
        else
        {
            if($paged_crawl_type == 'class')
            {
                $dom_xpath = new DOMXpath($domz);
                $elements = $dom_xpath->query('//*[contains(concat(" ", normalize-space(@class), " "), " '.trim($paged_crawl_str).' ")]');
                foreach($elements as $el) {
                    if(isset($el->tagName) && $el->tagName === 'a')
                    {
                        $anchors[] = $el;
                    }
                    else
                    {
                        $ancs = $el->getElementsByTagName('a');
                        foreach($ancs as $as)
                        {
                            $anchors[] = $as;
                        }
                    }
                }
            }
            elseif($paged_crawl_type != '')
            {
                $dom_xpath = new DOMXpath($domz);
                $elements = $dom_xpath->query('//*[@'.$paged_crawl_type.'="'.trim($paged_crawl_str).'"]');
                foreach($elements as $el) {
                    if(isset($el->tagName) && $el->tagName === 'a')
                    {
                        $anchors[] = $el;
                    }
                    else
                    {
                        $ancs = $el->getElementsByTagName('a');
                        foreach($ancs as $as)
                        {
                            $anchors[] = $as;
                        }
                    }
                }
            }
        }
    }
    else
    {
        $anchors = $domz->getElementsByTagName('a');
    }
    
    foreach($anchors as $a)
    {
        $href = $a->getAttribute('href');
        $href = myfeeds_generate_valid_url($href, $url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass);
        if (isset($seen[$href])) {
            continue;
        }
        if(count($seen) > $max)
        {
            return $extract;
        }
        $got_phantom = false;
        $html_cont = false;
        if($use_phantom == '1')
        {
            $html_cont = myfeeds_get_page_PhantomJS($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
            if($html_cont !== false)
            {
                $got_phantom = true;
            }
        }
        elseif($use_phantom == '2')
        {
            $html_cont = myfeeds_get_page_Puppeteer($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
            if($html_cont !== false)
            {
                $got_phantom = true;
            }
        }
        elseif($use_phantom == '4')
        {
            $html_cont = myfeeds_get_page_PuppeteerAPI($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
            if($html_cont !== false)
            {
                $got_phantom = true;
            }
        }
        elseif($use_phantom == '5')
        {
            $html_cont = myfeeds_get_page_TorAPI($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
            if($html_cont !== false)
            {
                $got_phantom = true;
            }
        }
        elseif($use_phantom == '6')
        {
            $html_cont = myfeeds_get_page_PhantomJSAPI($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass, $phantom_wait);
            if($html_cont !== false)
            {
                $got_phantom = true;
            }
        }
        if($got_phantom === false)
        {
            $html_cont = myfeeds_get_web_page($href, $custom_cookies, $custom_user_agent, $use_proxy, $user_pass);
        }
        if($html_cont === false)
        {
            continue;
        }
        if($getname == '' || $type == 'auto')
        {
            $extract_temp = myfeeds_convert_readable_html($html_cont);
            if(isset($extract_temp[1]))
            {
                $extract .= ' ' . $extract_temp[1];
            }
        }
        else
        {
            if ($type == 'regex' || $type == 'regexall') {
                $matches     = array();
                preg_match_all($getname, $html_cont, $matches);
                if ($getname === FALSE) {
                    $extract_temp .= myfeeds_convert_readable_html($html_cont);
                    if(isset($extract_temp[1]))
                    {
                        $extract .= ' ' . $extract_temp[1];
                    }
                    continue;
                }
                if(isset($matches[0][0]))
                {
                    foreach ($matches[0] as $match) {
                        $extract .= ' ' . $match;
                    }
                }
            } elseif ($type == 'xpath' || $type == 'visual') {
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $extractok = false;
                $html_dom_original_html = myfeeds_str_get_html($html_cont);
                if(stristr($getname, ' or ') === false && $html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    $ret = $html_dom_original_html->find( trim($getname) );
                    foreach ($ret as $item ) {
                        $extractok = true;
                        $extract .= ' ' . $item->outertext ;              
                    }
                    $html_dom_original_html->clear();
                    $html_dom_original_html = null;
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    $doc = new DOMDocument;
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $html_cont);
                    libxml_use_internal_errors($internalErrors);
                    $xpath = new \DOMXpath($doc);
                    $articles = $xpath->query(trim($getname));
                    if($articles !== false && count($articles) > 0)
                    {
                        foreach($articles as $container) {
                            if(method_exists($container, 'saveHTML'))
                            {
                                $extract .= ' ' . $container->saveHTML();
                            }
                            elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                            {
                                $extract .= ' ' . $container->ownerDocument->saveHTML($container);
                            }
                            elseif(isset($container->nodeValue))
                            {
                                $extract .= ' ' . $container->nodeValue;
                            }
                        }
                    }
                    else
                    {
                        $extract_temp .= myfeeds_convert_readable_html($html_cont);
                        if(isset($extract_temp[1]))
                        {
                            $extract .= ' ' . $extract_temp[1];
                        }
                        continue;
                    }
                }
            } else {
                require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
                $extractok = false;
                $html_dom_original_html = myfeeds_str_get_html($html_cont);
                if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
                    $getnames = explode(',', $getname);
                    foreach($getnames as $gname)
                    {
                        $ret = $html_dom_original_html->find('*['.$type.'="'.trim($gname).'"]');
                        foreach ($ret as $item ) {
                            $extractok = true;
                            if($item->innertext == '')
                            {
                                $extract .= ' ' . $item->outertext ;
                            }
                            else
                            {
                                $extract .= ' ' . $item->innertext ;
                            }              
                        }
                    }
                    $html_dom_original_html->clear();
                    $html_dom_original_html = null;
                    unset($html_dom_original_html);
                }
                if($extractok == false)
                {
                    $doc = new DOMDocument;
                    $extracted = false;
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $html_cont);
                    libxml_use_internal_errors($internalErrors);
                    $xpath = new \DOMXpath($doc);
                    $getnames = explode(',', $getname);
                    foreach($getnames as $gname)
                    {
                        $articles = $xpath->query('*['.$type.'="'.trim($gname).'"]');
                        if($articles !== false && count($articles) > 0)
                        {
                            foreach($articles as $container) {
                                if(method_exists($container, 'saveHTML'))
                                {
                                    $extracted = true;
                                    $extract .= ' ' . $container->saveHTML();
                                }
                                elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                                {
                                    $extracted = true;
                                    $extract .= ' ' . $container->ownerDocument->saveHTML($container);
                                }
                                elseif(isset($container->nodeValue))
                                {
                                    $extracted = true;
                                    $extract .= ' ' . $container->nodeValue;
                                }
                            }
                        }
                    }
                    if($extracted == false)
                    {
                        $extract_temp .= myfeeds_convert_readable_html($html_cont);
                        if(isset($extract_temp[1]))
                        {
                            $extract .= ' ' . $extract_temp[1];
                        }
                    }
                }
            }
        }
        $extract .= ' ' . myfeeds_get_paged_content($href, $html_cont, $type, $getname, $paged_crawl_type, $paged_crawl_str, $custom_cookies, $max, $custom_user_agent, $use_proxy, $use_phantom, $user_pass, $phantom_wait);
    }
    
    return $extract;
}
if(!function_exists('http_build_url'))
{
    // Define constants
    define('HTTP_URL_REPLACE',          0x0001);    // Replace every part of the first URL when there's one of the second URL
    define('HTTP_URL_JOIN_PATH',        0x0002);    // Join relative paths
    define('HTTP_URL_JOIN_QUERY',       0x0004);    // Join query strings
    define('HTTP_URL_STRIP_USER',       0x0008);    // Strip any user authentication information
    define('HTTP_URL_STRIP_PASS',       0x0010);    // Strip any password authentication information
    define('HTTP_URL_STRIP_PORT',       0x0020);    // Strip explicit port numbers
    define('HTTP_URL_STRIP_PATH',       0x0040);    // Strip complete path
    define('HTTP_URL_STRIP_QUERY',      0x0080);    // Strip query string
    define('HTTP_URL_STRIP_FRAGMENT',   0x0100);    // Strip any fragments (#identifier)

    // Combination constants
    define('HTTP_URL_STRIP_AUTH',       HTTP_URL_STRIP_USER | HTTP_URL_STRIP_PASS);
    define('HTTP_URL_STRIP_ALL',        HTTP_URL_STRIP_AUTH | HTTP_URL_STRIP_PORT | HTTP_URL_STRIP_QUERY | HTTP_URL_STRIP_FRAGMENT);

    /**
     * HTTP Build URL
     * Combines arrays in the form of parse_url() into a new string based on specific options
     * @name http_build_url
     * @param string|array $url     The existing URL as a string or result from parse_url
     * @param string|array $parts   Same as $url
     * @param int $flags            URLs are combined based on these
     * @param array &$new_url       If set, filled with array version of new url
     * @return string
     */
    function http_build_url(/*string|array*/ $url, /*string|array*/ $parts = array(), /*int*/ $flags = HTTP_URL_REPLACE, /*array*/ &$new_url = false)
    {
        // If the $url is a string
        if(is_string($url))
        {
            $url = parse_url($url);
        }

        // If the $parts is a string
        if(is_string($parts))
        {
            $parts  = parse_url($parts);
        }

        // Scheme and Host are always replaced
        if(isset($parts['scheme'])) $url['scheme']  = $parts['scheme'];
        if(isset($parts['host']))   $url['host']    = $parts['host'];

        // (If applicable) Replace the original URL with it's new parts
        if(HTTP_URL_REPLACE & $flags)
        {
            // Go through each possible key
            foreach(array('user','pass','port','path','query','fragment') as $key)
            {
                // If it's set in $parts, replace it in $url
                if(isset($parts[$key])) $url[$key]  = $parts[$key];
            }
        }
        else
        {
            // Join the original URL path with the new path
            if(isset($parts['path']) && (HTTP_URL_JOIN_PATH & $flags))
            {
                if(isset($url['path']) && $url['path'] != '')
                {
                    // If the URL doesn't start with a slash, we need to merge
                    if($url['path'][0] != '/')
                    {
                        // If the path ends with a slash, store as is
                        if('/' == $parts['path'][strlen($parts['path'])-1])
                        {
                            $sBasePath  = $parts['path'];
                        }
                        // Else trim off the file
                        else
                        {
                            // Get just the base directory
                            $sBasePath  = dirname($parts['path']);
                        }

                        // If it's empty
                        if('' == $sBasePath)    $sBasePath  = '/';

                        // Add the two together
                        $url['path']    = $sBasePath . $url['path'];

                        // Free memory
                        unset($sBasePath);
                    }

                    if(false !== strpos($url['path'], './'))
                    {
                        // Remove any '../' and their directories
                        while(preg_match('/\w+\/\.\.\//', $url['path'])){
                            $url['path']    = preg_replace('/\w+\/\.\.\//', '', $url['path']);
                        }

                        // Remove any './'
                        $url['path']    = str_replace('./', '', $url['path']);
                    }
                }
                else
                {
                    $url['path']    = $parts['path'];
                }
            }

            // Join the original query string with the new query string
            if(isset($parts['query']) && (HTTP_URL_JOIN_QUERY & $flags))
            {
                if (isset($url['query']))   $url['query']   .= '&' . $parts['query'];
                else                        $url['query']   = $parts['query'];
            }
        }

        // Strips all the applicable sections of the URL
        if(HTTP_URL_STRIP_USER & $flags)        unset($url['user']);
        if(HTTP_URL_STRIP_PASS & $flags)        unset($url['pass']);
        if(HTTP_URL_STRIP_PORT & $flags)        unset($url['port']);
        if(HTTP_URL_STRIP_PATH & $flags)        unset($url['path']);
        if(HTTP_URL_STRIP_QUERY & $flags)       unset($url['query']);
        if(HTTP_URL_STRIP_FRAGMENT & $flags)    unset($url['fragment']);

        // Store the new associative array in $new_url
        $new_url    = $url;

        // Combine the new elements into a string and return it
        return
             ((isset($url['scheme'])) ? $url['scheme'] . '://' : '')
            .((isset($url['user'])) ? $url['user'] . ((isset($url['pass'])) ? ':' . $url['pass'] : '') .'@' : '')
            .((isset($url['host'])) ? $url['host'] : '')
            .((isset($url['port'])) ? ':' . $url['port'] : '')
            .((isset($url['path'])) ? $url['path'] : '')
            .((isset($url['query'])) ? '?' . $url['query'] : '')
            .((isset($url['fragment'])) ? '#' . $url['fragment'] : '')
        ;
    }
}
function myfeeds_starts_with($newx_url, $query)
{
    if(substr( $newx_url, 0, strlen($query) ) === $query)
    {
        return true;
    }
    return false;
}
function myfeeds_generate_valid_url($href, $root, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass)
{
    $newx_url = $href;
    if(substr($newx_url, 0, 2) === "//")
    {
        if(substr($root, 0, 5) === "https")
        {
            $newx_url = 'https:' . $newx_url;
        }
        else
        {
            $newx_url = 'http:' . $newx_url;
        }
    }
    if (0 !== strpos($newx_url, 'http')) 
    {
        if(myfeeds_starts_with($newx_url, './'))
        {
            $newx_url = substr($newx_url, 2);
            $href = substr($href, 2);
        }
        $path = '/' . ltrim($newx_url, '/');
        if (function_exists('http_build_url')) {
            $newx_url = http_build_url($root, array('path' => $path));
            $newx_url = strtok($newx_url, '?');
            if(!myfeeds_url_exists($newx_url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass))
            {
                $newx_url = rtrim($root, '/') . '/' . ltrim($href, '/');
            }
        } else {
            $parts = parse_url($root);
            $newx_url = $parts['scheme'] . '://';
            if (isset($parts['user']) && isset($parts['pass'])) {
                $newx_url .= $parts['user'] . ':' . $parts['pass'] . '@';
            }
            $newx_url .= $parts['host'];
            if (isset($parts['port'])) {
                $newx_url .= ':' . $parts['port'];
            }
            $newx_url .= $path;
            if(!myfeeds_url_exists($newx_url, $use_proxy, $myfeeds_Main_Settings, $custom_user_agent, $custom_cookies, $user_pass))
            {
                $path_parts = pathinfo(rtrim($root, '/'));
                if(isset($path_parts) && $path_parts != '')
                {
                    $root = rtrim($root, '/');
                    $str_poz = strrpos( $root, '/');
                    if($str_poz !== false)
                    {
                        $root = substr($root, 0, $str_poz);
                    }
                }
                $newx_url = rtrim($root, '/') . '/' . ltrim($href, '/');
            }
        }
    }
    return $newx_url;
}

function myfeeds_get_content($type, $getname, $htmlcontent, $single = false)
{
    $extract = '';
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if (isset($myfeeds_Main_Settings['multi_separator'])) {
        $cont_sep = $myfeeds_Main_Settings['multi_separator'];
    }
    else
    {
        if($single == true)
        {
            $cont_sep = '';
        }
        else
        {
            $cont_sep = '<br/>';
        }
    }
    if ($type == 'regex') {
        $matches     = array();
        $rez = preg_match_all($getname, $htmlcontent, $matches);
        if ($rez === FALSE) {
            $rez = preg_match_all('#' . $getname . '#', $htmlcontent, $matches);
            if ($rez === FALSE) {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('[myfeeds_get_content] preg_match_all failed for expr: ' . $getname . '!');
                }
                return '';
            }
        }
        $regcnt = 0;
        foreach ($matches as $match) {
            if($regcnt == 0)
            {
                $regcnt++;
                continue;
            }
            if(!isset($match[0]))
            {
                continue;
            }
            $regcnt++;
            $extract .= $match[0];
            if($single === true)
            {
                break;
            }
            else
            {
                $extract .= $cont_sep;
            }
        }
    } elseif ($type == 'regexall') {
        $matches     = array();
        $rez = preg_match_all($getname, $htmlcontent, $matches);
        if ($rez === FALSE) {
            $rez = preg_match_all('#' . $getname . '#', $htmlcontent, $matches);
            if ($rez === FALSE) {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('[myfeeds_get_content] preg_match_all failed for expr: ' . $getname . '!');
                }
                return '';
            }
        }
        $regcnt = 0;
        foreach ($matches as $match) {
            if($regcnt == 0 && count($matches) > 1)
            {
                $regcnt++;
                continue;
            }
            if(!isset($match[0]))
            {
                continue;
            }
            $regcnt++;
            foreach($match as $mmatch)
            {
                $extract .= $mmatch . $cont_sep;
                
            }
            if($single === true)
            {
                break;
            }
        }
    } elseif ($type == 'xpath' || $type == 'visual') {
        require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
        $extractok = false;
        $html_dom_original_html = myfeeds_str_get_html($htmlcontent);
        if(stristr($getname, ' or ') === false && $html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
            $ret = $html_dom_original_html->find( trim($getname) );
            if(count($ret) == 0)
            {
                $html_dom_original_html->clear();
                $html_dom_original_html = null;
                unset($html_dom_original_html);
                $doc = new DOMDocument;
                $internalErrors = libxml_use_internal_errors(true);
                $doc->loadHTML('<?xml encoding="utf-8" ?>' . $htmlcontent);
                libxml_use_internal_errors($internalErrors);
                $xpath = new \DOMXpath($doc);
                $articles = $xpath->query(trim($getname));
                if(count($articles) > 0)
                {
                    foreach($articles as $container) {
                        if(method_exists($container, 'saveHTML'))
                        {
                            $extractok = true;
                            $extract .= $container->saveHTML() . $cont_sep;
                        }
                        elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                        {
                            $extractok = true;
                            $extract .= $container->ownerDocument->saveHTML($container) . $cont_sep;
                        }
                        elseif(isset($container->nodeValue))
                        {
                            $extractok = true;
                            $extract .= $container->nodeValue . $cont_sep;
                        }
                    }
                }
                else
                {
                    if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                        myfeeds_log_to_file('myfeeds_str_get_html failed for page (first method), xpath: ' . $getname . '!');
                    }
                }
            }
            else
            {
                foreach ($ret as $item ) {
                    $extractok = true;
                    if($item->innertext == '')
                    {
                        $extract .= $item->outertext;
                    }
                    else
                    {
                        $extract .= $item->innertext;
                    }
                    
                    if($single === true)
                    {
                        break;
                    }
                    else
                    {
                        $extract .= $cont_sep;
                    }
                }
                $html_dom_original_html->clear();
                $html_dom_original_html = null;
                unset($html_dom_original_html);
            }
        }
        if($extractok == false)
        {
            $doc = new DOMDocument;
            $internalErrors = libxml_use_internal_errors(true);
            $doc->loadHTML('<?xml encoding="utf-8" ?>' . $htmlcontent);
            libxml_use_internal_errors($internalErrors);
            $xpath = new \DOMXpath($doc);
            $articles = $xpath->query(trim($getname));
            if(count($articles) > 0)
            {
                foreach($articles as $container) {
                    if(method_exists($container, 'saveHTML'))
                    {
                        $extract .= $container->saveHTML() . $cont_sep;
                    }
                    elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                    {
                        $extract .= $container->ownerDocument->saveHTML($container) . $cont_sep;
                    }
                    elseif(isset($container->nodeValue))
                    {
                        $extract .= $container->nodeValue . $cont_sep;
                    }
                }
            }
            else
            {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('myfeeds_str_get_html failed for page, the xpath: ' . $getname . '!');
                }
                return '';
            }
        }
    } else {
        require_once (dirname(__FILE__) . "/res/simple_html_dom.php");
        $extractok = false;
        $html_dom_original_html = myfeeds_str_get_html($htmlcontent);
        if($html_dom_original_html !== false && method_exists($html_dom_original_html, 'find')){
            $getnames = explode(',', $getname);
            foreach($getnames as $gname)
            {
                $ret = $html_dom_original_html->find('*['.$type.'="'.trim($gname).'"]');
                if(count($ret) == 0)
                {
                    $doc = new DOMDocument;
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $htmlcontent);
                    libxml_use_internal_errors($internalErrors);
                    $xpath = new \DOMXpath($doc);
                    $articles = $xpath->query('*['.$type.'="'.trim($gname).'"]');
                    $oks = false;
                    if(count($articles) > 0)
                    {
                        foreach($articles as $container) {
                            $oks = true;
                            if(method_exists($container, 'saveHTML'))
                            {
                                $extractok = true;
                                $extract .= $container->saveHTML() . $cont_sep;
                            }
                            elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                            {
                                $extractok = true;
                                $extract .= $container->ownerDocument->saveHTML($container) . $cont_sep;
                            }
                            elseif(isset($container->nodeValue))
                            {
                                $extractok = true;
                                $extract .= $container->nodeValue . $cont_sep;
                            }
                        }
                    }
                    if($oks == false)
                    {
                        if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                            myfeeds_log_to_file('No content found matching the query you set (first method).');
                        }
                    }
                }
                else
                {
                    foreach ($ret as $item ) {
                        $extractok = true;
                        if($item->innertext == '')
                        {
                            $extract .= $item->outertext . $cont_sep;
                        }
                        else
                        {
                            $extract .= $item->innertext . $cont_sep;
                        }
                        if($single === true)
                        {
                            break;
                        }
                    }
                }
            }
            $html_dom_original_html->clear();
            $html_dom_original_html = null;
            unset($html_dom_original_html);
        }
        if($extractok == false)
        {
            $html_dom_original_html = null;
            unset($html_dom_original_html);
            $doc = new DOMDocument;
            $internalErrors = libxml_use_internal_errors(true);
            $doc->loadHTML('<?xml encoding="utf-8" ?>' . $htmlcontent);
            libxml_use_internal_errors($internalErrors);
            $xpath = new \DOMXpath($doc);
            $getnames = explode(',', $getname);
            $oks = false;
            foreach($getnames as $gname)
            {
                $articles = $xpath->query('*['.$type.'="'.trim($gname).'"]');
                if(count($articles) > 0)
                {
                    foreach($articles as $container) {
                        $oks = true;
                        if(method_exists($container, 'saveHTML'))
                        {
                            $extract .= $container->saveHTML() . $cont_sep;
                        }
                        elseif(isset($container->ownerDocument) && method_exists($container->ownerDocument, 'saveHTML'))
                        {
                            $extract .= $container->ownerDocument->saveHTML($container) . $cont_sep;
                        }
                        elseif(isset($container->nodeValue))
                        {
                            $extract .= $container->nodeValue . $cont_sep;
                        }
                    }
                }
            }
            if($oks == false)
            {
                if (isset($myfeeds_Main_Settings['enable_detailed_logging']) && $myfeeds_Main_Settings['enable_detailed_logging'] == 'on') {
                    myfeeds_log_to_file('myfeeds_str_get_html failed for page, find does not exist!');
                }
                return '';
            }
        }
    }
    if($cont_sep != '' && $cont_sep != '<br/>')
    {
        $extract = rtrim($extract, $cont_sep);
    }
    return $extract;
}

function myfeeds_substr_close_tags($text, $max_length)
{
    $tags   = array();
    $result = "";

    $is_open   = false;
    $grab_open = false;
    $is_close  = false;
    $in_double_quotes = false;
    $in_single_quotes = false;
    $tag = "";

    $i = 0;
    $stripped = 0;

    $stripped_text = strip_tags($text);
    if (function_exists('mb_strlen') && function_exists('mb_substr')) {
        while ($i < mb_strlen($text) && $stripped < mb_strlen($stripped_text) && $stripped < $max_length)
        {
            $symbol  = mb_substr($text,$i,1);
            $result .= $symbol;

            switch ($symbol)
            {
               case '<':
                    $is_open   = true;
                    $grab_open = true;
                    break;

               case '"':
                   if ($in_double_quotes)
                       $in_double_quotes = false;
                   else
                       $in_double_quotes = true;

                break;

                case "'":
                  if ($in_single_quotes)
                      $in_single_quotes = false;
                  else
                      $in_single_quotes = true;

                break;

                case '/':
                    if ($is_open && !$in_double_quotes && !$in_single_quotes)
                    {
                        $is_close  = true;
                        $is_open   = false;
                        $grab_open = false;
                    }

                    break;

                case ' ':
                    if ($is_open)
                        $grab_open = false;
                    else
                        $stripped++;

                    break;

                case '>':
                    if ($is_open)
                    {
                        $is_open   = false;
                        $grab_open = false;
                        array_push($tags, $tag);
                        $tag = "";
                    }
                    else if ($is_close)
                    {
                        $is_close = false;
                        array_pop($tags);
                        $tag = "";
                    }

                    break;

                default:
                    if ($grab_open || $is_close)
                        $tag .= $symbol;

                    if (!$is_open && !$is_close)
                        $stripped++;
            }
            $i++;
        }
    }
    else
    {
        while ($i < strlen($text) && $stripped < strlen($stripped_text) && $stripped < $max_length)
        {
            $symbol  = $text[$i];
            $result .= $symbol;

            switch ($symbol)
            {
               case '<':
                    $is_open   = true;
                    $grab_open = true;
                    break;

               case '"':
                   if ($in_double_quotes)
                       $in_double_quotes = false;
                   else
                       $in_double_quotes = true;

                break;

                case "'":
                  if ($in_single_quotes)
                      $in_single_quotes = false;
                  else
                      $in_single_quotes = true;

                break;

                case '/':
                    if ($is_open && !$in_double_quotes && !$in_single_quotes)
                    {
                        $is_close  = true;
                        $is_open   = false;
                        $grab_open = false;
                    }

                    break;

                case ' ':
                    if ($is_open)
                        $grab_open = false;
                    else
                        $stripped++;

                    break;

                case '>':
                    if ($is_open)
                    {
                        $is_open   = false;
                        $grab_open = false;
                        array_push($tags, $tag);
                        $tag = "";
                    }
                    else if ($is_close)
                    {
                        $is_close = false;
                        array_pop($tags);
                        $tag = "";
                    }

                    break;

                default:
                    if ($grab_open || $is_close)
                        $tag .= $symbol;

                    if (!$is_open && !$is_close)
                        $stripped++;
            }
            $i++;
        }
    }

    while ($tags)
        $result .= "</".array_pop($tags).">";
    return force_balance_tags($result);
}


register_activation_hook(__FILE__, 'myfeeds_check_version');
function myfeeds_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'rss-feed-from-any-site').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . esc_html__('You are not allowed to activate plugins!', 'rss-feed-from-any-site') . '</p>';
        die;
    }
    $php_version_required = '5.6';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'rss-feed-from-any-site'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'rss-feed-from-any-site'), $wp_version_required) . '</p>';
        die;
    }
}
function myfeeds_get_pinfo() {
    ob_start();
    phpinfo();
    $data = ob_get_contents();
    ob_clean();
    return $data;
}

function myfeeds_register_mysettings()
{
    myfeeds_cron_schedule();
    if(isset($_GET['myfeeds_page']))
    {
        $curent_page = $_GET["myfeeds_page"];
    }
    else
    {
        $curent_page = '';
    }
    $all_rules = get_option('myfeeds_rules_list', array());
    $rules_count = count($all_rules);
    $rules_per_page = get_option('myfeeds_posts_per_page', 12);
    $max_pages = ceil($rules_count/$rules_per_page);
    if($max_pages == 0)
    {
        $max_pages = 1;
    }
    $last_url = (myfeeds_isSecure() ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    if(stristr($last_url, 'myfeeds_items_panel') !== false && (!is_numeric($curent_page) || $curent_page > $max_pages || $curent_page <= 0))
    {
        if(stristr($last_url, 'myfeeds_page=') === false)
        {
            if(stristr($last_url, '?') === false)
            {
                $last_url .= '?myfeeds_page=' . $max_pages;
            }
            else
            {
                $last_url .= '&myfeeds_page=' . $max_pages;
            }
        }
        else
        {
            if(isset($_GET['myfeeds_page']))
            {
                $curent_page = $_GET["myfeeds_page"];
            }
            else
            {
                $curent_page = '';
            }
            if(is_numeric($curent_page))
            {
                $last_url = str_replace('myfeeds_page=' . $curent_page, 'myfeeds_page=' . $max_pages, $last_url);
            }
            else
            {
                if(stristr($last_url, '?') === false)
                {
                    $last_url .= '?myfeeds_page=' . $max_pages;
                }
                else
                {
                    $last_url .= '&myfeeds_page=' . $max_pages;
                }
            }
        }
        myfeeds_redirect($last_url);
    }
    register_setting('myfeeds_option_group', 'myfeeds_Main_Settings');
    if(is_multisite())
    {
        if (!get_option('myfeeds_Main_Settings'))
        {
            myfeeds_activation_callback(TRUE);
        }
    }
    if(isset($_POST['myfeeds_download_rules_to_file']))
    {
        $GLOBALS['wp_object_cache']->delete('myfeeds_rules_list', 'options');
        if (!get_option('myfeeds_rules_list')) {
            $rules = array();
        } else {
            $rules = get_option('myfeeds_rules_list');
        }
        header("Content-type: application/x-msdownload");
        header("Content-Disposition: attachment; filename=myfeeds_rules.bak");
        header("Pragma: no-cache");
        header("Expires: 0");
        echo json_encode($rules);
        exit();
    }
    if(isset($_POST['myfeeds_restore_rules']))
    {
        if(isset($_FILES['myfeeds-file-upload-rules']['tmp_name'])) 
        {		
            global $wp_filesystem;
            if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                wp_filesystem($creds);
            }
            $file = $wp_filesystem->get_contents($_FILES['myfeeds-file-upload-rules']['tmp_name']);
            if($file === false)
            {
                myfeeds_log_to_file('Failed to restore rules from file: ' . $_FILES['myfeeds-file-upload-rules']['tmp_name']);
            }
            else
            {
                $rules = json_decode($file, true);
                if($rules === false)
                {
                    myfeeds_log_to_file('Failed to decode value: ' . print_r($file, true));
                }
                else
                {
                    if(isset($rules[0][0]) && isset($rules[0][37]))
                    {
                        update_option('myfeeds_rules_list', $rules, false);
                    }
                    else
                    {
                        myfeeds_log_to_file('Invalid file given: ' . print_r($rules, true));
                    }
                }
            }               
        }
    }
}

function myfeeds_get_plugin_url()
{
    return plugins_url('', __FILE__);
}

function myfeeds_get_file_url($url)
{
    return esc_url(myfeeds_get_plugin_url() . '/' . $url);
}

function myfeeds_admin_load_files()
{
    wp_register_style('myfeeds-browser-style', plugins_url('styles/myfeeds-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('myfeeds-browser-style');
    wp_register_style('myfeeds-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('myfeeds-custom-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
}

add_action('wp_enqueue_scripts', 'myfeeds_wp_load_files');
function myfeeds_wp_load_files()
{
    global $post;
    if(is_object($post) && isset($post->ID))
    {
        $css_cont = get_post_meta($post->ID, 'myfeeds_css_cont', true);
        if($css_cont != '')
        {
            $css_cont = wp_strip_all_tags($css_cont);
            wp_register_style( 'myfeeds-official-style', false );
            wp_enqueue_style( 'myfeeds-official-style' );
            wp_add_inline_style( 'myfeeds-official-style', $css_cont );
        }
    }
    wp_enqueue_style('myfeeds-thumbnail-css', plugins_url('styles/myfeeds-thumbnail.css', __FILE__));
}

function myfeeds_random_sentence_generator($first = true)
{
    $myfeeds_Main_Settings = get_option('myfeeds_Main_Settings', false);
    if ($first == false) {
        $r_sentences = $myfeeds_Main_Settings['sentence_list2'];
    } else {
        $r_sentences = $myfeeds_Main_Settings['sentence_list'];
    }
    $r_variables = $myfeeds_Main_Settings['variable_list'];
    $r_sentences = trim($r_sentences);
    $r_variables = trim($r_variables, ';');
    $r_variables = trim($r_variables);
    $r_sentences = str_replace("\r\n", "\n", $r_sentences);
    $r_sentences = str_replace("\r", "\n", $r_sentences);
    $r_sentences = explode("\n", $r_sentences);
    $r_variables = str_replace("\r\n", "\n", $r_variables);
    $r_variables = str_replace("\r", "\n", $r_variables);
    $r_variables = explode("\n", $r_variables);
    $r_vars      = array();
    for ($x = 0; $x < count($r_variables); $x++) {
        $var = explode("=>", trim($r_variables[$x]));
        if (isset($var[1])) {
            $key          = strtolower(trim($var[0]));
            $words        = explode(";", trim($var[1]));
            $r_vars[$key] = $words;
        }
    }
    $max_s    = count($r_sentences) - 1;
    $rand_s   = rand(0, $max_s);
    $sentence = $r_sentences[$rand_s];
    $sentence = str_replace(' ,', ',', ucfirst(myfeeds_replace_words($sentence, $r_vars)));
    $sentence = str_replace(' .', '.', $sentence);
    $sentence = str_replace(' !', '!', $sentence);
    $sentence = str_replace(' ?', '?', $sentence);
    $sentence = trim($sentence);
    return $sentence;
}

function myfeeds_get_word($key, $r_vars)
{
    if (isset($r_vars[$key])) {
        
        $words  = $r_vars[$key];
        $w_max  = count($words) - 1;
        $w_rand = rand(0, $w_max);
        return myfeeds_replace_words(trim($words[$w_rand]), $r_vars);
    } else {
        return "";
    }
    
}

function myfeeds_replace_words($sentence, $r_vars)
{
    
    if (str_replace('%', '', $sentence) == $sentence)
        return $sentence;
    
    $words = explode(" ", $sentence);
    
    $new_sentence = array();
    for ($w = 0; $w < count($words); $w++) {
        
        $word = trim($words[$w]);
        
        if ($word != '') {
            if (preg_match('/^%([^%\n]*)$/', $word, $m)) {
                $varkey         = trim($m[1]);
                $new_sentence[] = myfeeds_get_word($varkey, $r_vars);
            } else {
                $new_sentence[] = $word;
            }
        }
    }
    return implode(" ", $new_sentence);
}

function myfeeds_findRobotsMetaTagLine($html)
{
    if (preg_match('/\<meta name="robots".*?\>/mis', $html, $matches)) {
        return $matches[0];
    }

    return '';
} 
?>